<?php
/* BlueOwlCreative Framework
 *
 * The following file defines the some Core Theme functionality methods
 *
 * @author Kal (BlueOwlCreative)
 * @link http://blueowlcreative.com
 */
 
 
/**	
	BreadCrumbs method 
**/
if( ! function_exists( 'boc_breadcrumbs' ) ) { 
	function boc_breadcrumbs() {
			global $post;

			$breadcrumbs_position = wp_kses_post(ot_get_option('breadcrumbs_position','floated'));
			$str = "";
			
			// If portfolio template (with cat filter) and right breadcrumbs -> no breadcrumbs
			if( ($breadcrumbs_position!="normal") && is_page_template( 'portfolio-three-column.php' ) ) {
				return;
			}
			
			$str .= '<div class="breadcrumb '.(($breadcrumbs_position!="normal") ? "breadcrumb_".$breadcrumbs_position : "") .'">';
			
			if ( !is_front_page() ) {
				$str .= '<a class="first_bc" href="';
				$str .= esc_url(home_url('/'));
				$str .= '"><span>'.esc_html__('Home','alea');
				$str .= "</span></a>";
			}
			
			if (is_category() && !is_singular('portfolio')) {
				$current_cat = get_category(get_query_var('cat'),false);
				$parents_links = get_category_parents($current_cat->cat_ID, TRUE, '', FALSE );

				//Attach <span> to links      
				$parents_links = preg_replace("/(<a\s*href[^>]+>)/", "$1".'<span>', $parents_links);
				$parents_links = boc_str_lreplace("<a href","<a class='last_bc' href", $parents_links);
				$parents_links = str_replace("</a>", "</span></a>", $parents_links);
				
				$str .= $parents_links;
			}
			
			// Woocommerce Breadcrumbs
			if(function_exists('is_woocommerce') && is_woocommerce()) {
				
				// Woo 3.0 +
				if(function_exists('wc_get_page_id')){
					$shop_url = esc_url(get_permalink( wc_get_page_id( 'shop' ) ));
				}else {
					$shop_url = esc_url(get_permalink( woocommerce_get_page_id( 'shop' ) ));
				}
				// For categories and home shop etc
				if(function_exists('is_shop') && is_shop()) {
					$str .= "<a class='last_bc' href='". $shop_url."'><span>".esc_html__('Shop', 'alea')."</span></a>";
				}elseif(is_product()){
					$str .= "<a href='". $shop_url."'><span>".esc_html__('Shop', 'alea')."</span></a>";

					$taxonomy = 'product_cat';
					$terms = get_the_terms( $post->ID , $taxonomy );

					if($terms){
						// Sort so ones with parent=0 list first
						//usort($terms, create_function( '$a, $b', 'return strcmp($a->parent, $b->parent);'));
						usort($terms, function($a, $b){ return strcmp($a->parent, $b->parent);});
						
						if (! empty( $terms ) ) :
							foreach ( $terms as $term ) {

								$link = get_term_link( $term, $taxonomy );
								if ( !is_wp_error( $link ) ){
									$str .= '<a href="' . esc_url($link) . '"><span>' . esc_html($term->name) . '</span></a>';
								}
							}
						endif;
					}
					
				}elseif(is_product_category()){
					$str .= "<a href='".  $shop_url."'><span>".esc_html__('Shop', 'alea')."</span></a>";
					global $wp_query;
					// get the query object
					$cat_obj = $wp_query->get_queried_object();
					  
					if(isset($cat_obj) && $cat_obj->parent > 0){
						$parent_cat = get_term_by( 'id', $cat_obj->parent, 'product_cat');
						
						$link = get_term_link( $parent_cat, 'product_cat');
						$str .= '<a href="' . esc_url($link) . '"><span>' .  esc_html($parent_cat->name) . '</span></a>';
					}
				}else{
					$str .= "<a href='". $shop_url."'><span>".esc_html__('Shop', 'alea')."</span></a>";
				}	
			}
			
			// Taxonomy
			if (is_tax()) {
				$term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
				$str .= '<a class="last_bc" href="' . esc_url(get_term_link($term)) . '" title="' . esc_attr($term->name) . '"><span>' . esc_html($term->name) . '</span></a>';
			}


			// Portfolio Breadcrumbs
			if(is_singular('portfolio')) {
		
				$taxonomy = 'portfolio_category';
				$terms = get_the_terms( $post->ID , $taxonomy );

				if (! empty( $terms ) ) :
					foreach ( $terms as $term ) {
						
						$link = get_term_link( $term, $taxonomy );
						if ( !is_wp_error( $link ) )
							$str .= '<a href="' . esc_url($link) . '"><span>' . esc_html($term->name) . '</span></a>';
					}
				endif;
			}

			if(is_home()) {
				$str .= '<a class="last_bc" href="#" title="' . strip_tags(single_post_title('', false )) . '"><span>' . esc_html(single_post_title('',false)) . '</span></a>';
			}
			
			if(is_page() && !is_front_page()) {
				$parents = array();
				$parent_id = $post->post_parent;
				while ( $parent_id ) :
					$page = get_page( $parent_id );
					$parents[]  = '<a href="' . esc_url(get_permalink( $page->ID )) . '" title="' . strip_tags(get_the_title( $page->ID )) . '"><span>' . strip_tags(get_the_title( $page->ID )) . '</span></a>';
					$parent_id  = $page->post_parent;
				endwhile;
				$parents = array_reverse( $parents );
				$str .= join( ' ', $parents );
				$str .= '<a class="last_bc" href="' . esc_url(get_permalink()) . '" title="' . strip_tags(get_the_title()) . '"><span>' . strip_tags(get_the_title()). '</span></a>';
			}
			
			if(is_single()) {
				$args=array('orderby' => 'none');
				$terms = wp_get_post_terms( $post->ID , 'category', $args);
				foreach($terms as $term) {
				  $str .= '<a href="' . esc_url(get_term_link($term, 'category')) . '" title="' . strip_tags(get_the_title()) . '" ' . '><span>' . strip_tags($term->name) .'</span></a> ';
				}

				$str .= '<a class="last_bc" href="' . esc_url(get_permalink()) . '" title="' . strip_tags(get_the_title()) . '"><span>' . strip_tags(get_the_title()). '</span></a>';
			}
			
			if(is_tag()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html__("Tag", 'alea').": ".esc_html(single_tag_title('', false)).'</span></a>'; }
			if(is_404()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html__("404 - Page not Found", 'alea').'</span></a>'; }
			if(is_search()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html__("Search", 'alea').'</span></a>'; }
			if(is_year()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html(get_the_time('Y')).'</span></a>'; }
			if(is_month()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html(get_the_time('F Y')).'</span></a>'; }
			if(is_day()){ $str .= '<a class="last_bc" href="#"><span>'.esc_html(get_the_time('F jS, Y')).'</span></a>'; }
			if(is_author()) { 	$str .= '<a class="last_bc" href="#"><span>'.esc_html(get_the_author()).'</span></a>'; }

			$str .= "</div>";
			
			echo wp_kses_post($str);
	}
}

/**
	Replace last occurrence
**/
if( ! function_exists( 'boc_str_lreplace' ) ) {
	function boc_str_lreplace($search, $replace, $subject)
	{
		return preg_replace('~(.*)' . preg_quote($search, '~') . '(.*?)~', '$1' . $replace . '$2', $subject, 1);
	}
}


/**	
	Add SEARCH to the header "main_navigation" slot if option is set
**/
if( ! function_exists( 'boc_add_search_to_header' ) ) { 
	function boc_add_search_to_header() {

			$show_search_option = boc_show_search_in_header();
			$show_search_separator_option = boc_show_search_separator();

			if($show_search_option!='on') {
				return;
			}else {
				echo wp_kses_post(($show_search_separator_option!='off' ? '<li class="boc_search_border"><a href="#">|</a></li>' : '')).
				'<li class="boc_search_toggle_li"><a href="#" class="header_search_icon boc_i-search_icon"></a></li>';
			}

	}
}

/**	
	Generate custom Header Search Form Markup
**/
if ( ! function_exists( 'boc_search_form_in_header' ) ) {
	function boc_search_form_in_header() {

		$product_search_hidden_field = '';
		if(ot_get_option('woocommerce_header_product_search','off')=='on'){
			$product_search_hidden_field = "<input type='hidden' name='post_type' id='post_type' value='product'/>";
		}

		$search_form_html = '
			<div id="search_wrapper">
				<div class="search_bgr_holder">
					<div class="search_bgr"></div>
				</div>
				<div class="search_inner"> 
						<i id="search-close" class="boc_i-close"></i>
						<form method="get" action="'.esc_url( home_url( '/' ) ).'" role="search" class="header_search_form"><input type="search" id="header_search_field" name="s" autocomplete="off" placeholder="'.esc_attr__( 'Type then hit enter to search...', 'alea' ).'" />'.$product_search_hidden_field.'</form>
				</div>
			</div>';
		return $search_form_html;
	}
}



/**	
	Page Header method
**/
if( ! function_exists( 'boc_page_header' ) ) { 
	function boc_page_header() {

		// Get post id if on a post or page
		if(is_archive() || is_search() || is_tax()){
			$post_id = 0;
		}elseif(is_home()) {
			$post_id = get_option( 'page_for_posts' );
		}else {
			global $post;
			if(!empty($post))
				$post_id = $post->ID;
			else
				$post_id = 0;
		}
		
		global $woocommerce;
		
		// If shop get shop page id
		if(function_exists('is_shop') && is_shop()){

			if(function_exists('wc_get_page_id')){
				$post_id = wc_get_page_id('shop');
			}else {
				$post_id = woocommerce_get_page_id('shop');
			}
		}
		
		// Shall we display the page heading according to Post meta
		$boc_show_heading = get_post_meta($post_id, 'boc_page_heading_set', true);
		$boc_content_top_margin = (get_post_meta($post_id, 'boc_content_top_margin', true)!=='off'? true : false);
		

		if($boc_show_heading!=='off') {
			
			$boc_page_tall_heading = (get_post_meta($post_id, 'boc_page_tall_heading', true)=="on") ? true : false;
			if(is_archive() || is_search() || is_home() || is_404() || is_page() || is_tax() || is_single()) { 
			
				// Breadcrumbs are ON?
				if(ot_get_option('breadcrumbs','on')=='on'){
					$boc_page_breadcrumbs = (get_post_meta($post_id, 'boc_page_breadcrumbs', true)!=='off'? true : false);
				}else {
					$boc_page_breadcrumbs = false;
				}

				$breadcrumbs_position = wp_kses_post(ot_get_option('breadcrumbs_position','floated'));
			?>
				<div class="full_container_page_title <?php echo esc_attr($boc_content_top_margin ? '' : 'no_bm');?>  <?php echo esc_attr($boc_page_tall_heading ? 'tall_page_heading' : '');?> breadcrumb_position_<?php echo esc_attr($breadcrumbs_position); ?>">	
					<div class="container">		
						<div class="section no_bm">
								<?php 
								if($boc_page_breadcrumbs && ($breadcrumbs_position != "centered")) {
									boc_breadcrumbs(); 
								}
								?>
								
								<div class="page_heading"><h1 <?php echo (is_single()?'class="entry-title"':'');?>>
								<?php 	if (is_home() && is_front_page()) {
											esc_html_e('Home','alea');

										}elseif(is_home()){
											esc_html(single_post_title(''));

										}elseif(is_404()){
											esc_html_e('404 - Page Not Found', 'alea');

										}elseif(is_archive() && !(function_exists('is_woocommerce') && is_woocommerce())){
											if(is_year()){ echo esc_html(get_the_time('Y')); }
											elseif(is_month()){ echo esc_html(get_the_time('F Y')); }
											elseif(is_day()){ echo esc_html(get_the_time('F jS, Y')); }
											elseif(is_author()) { 	echo esc_html(get_the_author()); }
											elseif(is_tag()) { 	echo esc_html__("Tag", 'alea').": ". esc_html(single_tag_title('',false)); }
											else{
												echo esc_html(single_cat_title());
											}

										}elseif(is_search()){
											echo esc_html__('Search results for:', 'alea').' '. esc_html(get_search_query());	
										}elseif(is_page()){
											$title = get_the_title('');
											echo esc_html($title) ? esc_html($title) : '-';
										}elseif(is_tax()){
											echo esc_html(single_cat_title());
										}elseif((function_exists('is_woocommerce') && is_woocommerce()) && (is_shop() || is_product_category() || is_product_tag())) {
											echo (is_archive() ? esc_html_e('Shop', 'alea') : 
														(is_search() ? esc_html_e('Search results for:', 'alea').' '. esc_html(get_search_query()): 
																(is_home() ? esc_html(the_title('')) : esc_html(the_title())) ));
										}else {
											esc_html(the_title(''));
										}
								?>
								</h1></div>	
								
								<?php 
								if($boc_page_breadcrumbs && ($breadcrumbs_position == "centered")) {
									boc_breadcrumbs(); 
								}elseif($breadcrumbs_position == "centered"){
									echo "<div class='h8'></div>";
								}
								?>
						</div>
					</div>
				</div>
			<?php			
			}else {
				if($boc_content_top_margin){
						echo '<div class="h20"></div>';
				}
			} 
	
		}else {
			if(get_page_template_slug( $post_id ) == "portfolio-three-column.php") {
			//	echo '<div class="h100"></div>';				
			}
			if($boc_content_top_margin){
				// For any page other than the contact Page template
				if(get_page_template_slug( $post_id ) != "contact.php") {
					echo '<div class="h20"></div>';
				}
			}	
		}
	}
}




/* Walker Class for Adding <span> tag to Menu items with children.
 * @author BOC 
 * @link http://blueowlcreative.com
 */

class boc_Menu_Walker extends Walker_Nav_Menu
{
	function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output )
    {
        $id_field = $this->db_fields['id'];
		// Add a SPAN element to current one's title if it has children
		if( !empty( $children_elements[$element->$id_field] ) ) {
        	$element->title .= '<span></span>';
        }
        return parent::display_element( $element, $children_elements, $max_depth, $depth, $args, $output );
    }

}


// Remove span from title
if( ! function_exists( 'boc_removeSpanFromTitle' ) ) { 
	function boc_removeSpanFromTitle($title){
			
		$title = str_replace('<span>','',$title);
		$title = str_replace('</span>','',$title);
			
		return $title;	
	}
}



// Comments
if( ! function_exists( 'boc_comment' ) ) { 
	function boc_comment($comment, $args, $depth) {
		$GLOBALS['comment'] = $comment; ?>
		<?php $add_below = ''; ?>
		<li <?php comment_class(); ?> id="comment-<?php comment_ID() ?>">
		
			<div class="single_comment">
				<div class="comment_avatar">
					<div class="avatar">
						<?php echo get_avatar($comment, 50); ?>
					</div>
					<?php edit_comment_link(esc_html__('Edit','alea'),'  ','') ?>
				</div>
				<div class="comment_content">
				
					<div class="comment-author meta">
						<div class="comment_name heading_font">
							<?php
								$author_link = wp_kses_post(get_comment_author_link());
								$reply_link = get_comment_reply_link(array_merge($args, array('reply_text' => 'Reply', 'add_below' => $add_below, 'depth' => $depth, 'max_depth' => $args['max_depth'])));
							?>
							<?php echo ((is_rtl()) ? $reply_link : $author_link); ?><?php echo (comments_open() ? '<span>-</span>' : '');?><?php echo ((is_rtl()) ? $author_link : $reply_link); ?>
						</div>
						<div class="comment_desc"><?php printf(esc_html__('%1$s at %2$s', 'alea'), esc_html(boc_post_date()),  esc_html(get_comment_time())) ?></div>
						
					</div>
				
					<div class="comment_text">
						<?php if ($comment->comment_approved == '0') : ?>
						<em><?php esc_html_e('Your comment is awaiting moderation.', 'alea') ?></em>
						<br />
						<?php endif; ?>
						<?php esc_html(comment_text()) ?>
					</div>
				
				</div>
				
			</div>

	<?php } 
}



// Remove VC shortcodes from Excerpt
if(!function_exists('boc_remove_vc_from_excerpt'))  {
  function boc_remove_vc_from_excerpt( $excerpt ) {
    $patterns = "/\[[\/]?vc_[^\]]*\]/";
    $replacements = "";
    return preg_replace($patterns, $replacements, $excerpt);
  }
}

if(!function_exists('boc_excerpt')) {
  function boc_excerpt($excerpt_length = 20) {
 
    global $word_count, $post;

    $word_count = isset($word_count) && $word_count != "" ? $word_count : $excerpt_length;

    $post_excerpt = $post->post_excerpt != "" ? $post->post_excerpt : strip_tags($post->post_content); $clean_excerpt = strpos($post_excerpt, '...') ? strstr($post_excerpt, '...', true) : $post_excerpt;
 
    $clean_excerpt = strip_shortcodes(boc_remove_vc_from_excerpt($clean_excerpt));

    $excerpt_word_array = explode (' ',$clean_excerpt);
    $excerpt_word_array = array_slice ($excerpt_word_array, 0, $word_count);
    $excerpt = implode (' ', $excerpt_word_array).'...';
	echo wp_kses_post($excerpt);
  }
}


/*
 * Mod category counters 
*/
if( ! function_exists( 'boc_category_list' ) ) { 
	function boc_category_list( $list ) {
		//move count inside a tags
		$list = str_replace( '</a> (', ' (', $list );
		$list = str_replace( ')', ')</a>', $list );
		return $list;
	}
}
add_filter( 'wp_list_categories', 'boc_category_list' );

/*
 * Mod archive counters 
*/
if( ! function_exists( 'boc_get_archives_link' ) ) { 
	function boc_get_archives_link( $output ) { 
		//move count inside a tags
		$output = str_replace( '</a>&nbsp;(', ' (', $output );
		$output = str_replace( ')', ')</a>', $output );
		return $output;
	};
}
add_filter( 'get_archives_link', 'boc_get_archives_link', 10, 6 );

/**
	BOC Global Query Pagination
**/
if( ! function_exists( 'boc_pagination' ) ) { 
	function boc_pagination($pages = '', $range = 2, $echo = true)
	{  
		 $showitems = ($range * 2)+1;  

		 global $paged;

		 if(empty($paged)) $paged = 1;

		 if($pages == '')
		 {
			 global $wp_query;
			 $pages = $wp_query->max_num_pages;
			 if(!$pages)
			 {
				 $pages = 1;
			 }
		 }

		 $str = '';
		 if(1 != $pages)
		 {
			$left 	= 'left';
			$right 	= 'right';
			if(is_rtl()) {
				$left 	= 'right';
				$right 	= 'left';
			}
		
			$str .= "<div class='pagination section'>";
			$str .= '<div class="links">';
			if($paged > 1){
				$str .= "<a href='".esc_url(get_pagenum_link($paged - 1))."'><span class='boc_i-arrow-point-to-".$left."'></span></a>";
			}
			for ($i=1; $i <= $pages; $i++){
				if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems )){
					$str .= ($paged == $i)? " <a href='javascript:void(0)' class='curr_page'>".esc_html($i)."</a>":" <a href='".esc_url(get_pagenum_link($i))."'>".esc_html($i)."</a>";
				}
			}

			if ($paged < $pages){ 
				$str .= " <a href='".esc_url(get_pagenum_link($paged + 1))."'><span class='boc_i-arrow-point-to-".$right."'></span></a>";
			}
			$str .= "</div></div>\n";
		 }
		 
		 if($echo) echo wp_kses_post($str);
		 else return $str;
	}
}
/**
	BOC Custom Query Pagination
**/
if( ! function_exists( 'boc_pagination_custom' ) ) { 
	function boc_pagination_custom($wp_query, $pages = '', $range = 2, $echo = true)
	{  
		 $showitems = ($range * 2)+1;  

		 global $paged;

		 if(empty($paged)) $paged = 1;

		 if($pages == '')
		 {
			 $pages = $wp_query->max_num_pages;
			 if(!$pages)
			 {
				 $pages = 1;
			 }
		 }   

		 $str = '';
		 if(1 != $pages)
		 {
			 $str .= "<div class='pagination section'>";
			 $str .= '<div class="links">';
			 if($paged > 1){
				$str .= "<a href='".esc_url(get_pagenum_link($paged - 1))."'><span class='boc_i-arrow-point-to-left'></span></a>";
			 }
			 for ($i=1; $i <= $pages; $i++)
			 {
				 if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
				 {
					 $str .= ($paged == $i)? " <a href='javascript:void(0)' class='curr_page'>".esc_html($i)."</a>":" <a href='".esc_url(get_pagenum_link($i))."'>".esc_html($i)."</a>";
				 }
			 }

			 if ($paged < $pages){ 
				$str .= " <a href='".esc_url(get_pagenum_link($paged + 1))."'><span class='boc_i-arrow-point-to-right'></span></a>";
			 }
			 $str .= "</div></div>\n";
		 }
		 
		 if($echo) echo wp_kses_post($str);
		 else return $str;
	}
}



/**	
	Hook that retrieves Google Fonts API key from TO
**/
add_filter( 'ot_google_fonts_api_key', 'boc_set_google_fonts_api_key');

if( ! function_exists( 'boc_set_google_fonts_api_key' ) ) { 
	function boc_set_google_fonts_api_key( $string ) {
		
		// Get from TO, default is the default theme's one
		$google_fonts_api_key = ot_get_option('google_fonts_api_key','AIzaSyDa0HrLigKw2-WpxYzhggeLNDV8qV4V9GQ');
		return $google_fonts_api_key;
	}
}


/**	
	Hook that adds an overflow-y to body when we have a preloader
**/
add_filter('body_class', 'boc_preloader_class');

function boc_preloader_class($classes) {
	$has_page_preloader = boc_has_page_preloader();
	if($has_page_preloader){
		$classes[] = 'has_preloader';
	}
    return $classes;
}




// Preloader
if( ! function_exists( 'boc_has_page_preloader' ) ) { 
	function boc_has_page_preloader() {
		global $post;
		$has_page_preloader 	= ot_get_option('has_page_preloader','off') == 'on';
		if(!$has_page_preloader && isset($post->ID)){
			// Check Page Settings also
			$has_page_preloader = get_post_meta($post->ID, 'has_page_preloader_set', true)=='on' ? true : false;
		}
		return $has_page_preloader;
	}
}


/**
	Expanded allowed params for wp_kses
**/
if( ! function_exists( 'boc_expand_allowed_tags' ) ) { 
	function boc_expand_allowed_tags() {
		$allowed = wp_kses_allowed_html( 'post' );
		// iframe
		$allowed['iframe'] = array(
			'src'             => array(),
			'height'          => array(),
			'width'           => array(),
			'frameborder'     => array(),
			'allowfullscreen' => array(),
		);
		return $allowed;
	}
}

/**
	Add some style attribute allowed rule items
**/
function boc_extend_safe_style_tags( $styles ) {
    $styles[] = 'display';
    $styles[] = 'opacity';
    return $styles;
}
add_filter( 'safe_style_css', 'boc_extend_safe_style_tags',0);


/**
	BOC Hex to RGB conversion
**/
if( ! function_exists( 'boc_HexToRGB' ) ) { 
	function boc_HexToRGB($hex, $transparency=1) {
		
			// Check if RGB value was passed accidentally
			if(substr( $hex, 0, 3 ) === "rgb") {
				if(substr( $hex, 0, 4 ) === "rgba") {
					sscanf($hex, 'rgba(%d,%d,%d,%d)', $red, $green, $blue, $transparency);
				}else {
					sscanf($hex, 'rgb(%d,%d,%d)', $red, $green, $blue);
				}
				return 'rgba('.$red.', '.$green.', '.$blue.', '.$transparency.')';
			}
		
			$hex = str_replace("#", "", $hex);
			$color = array();

			if(strlen($hex) == 3) {
				$color['r'] = hexdec(substr($hex, 0, 1) . $r);
				$color['g'] = hexdec(substr($hex, 1, 1) . $g);
				$color['b'] = hexdec(substr($hex, 2, 1) . $b);
			}
			else if(strlen($hex) == 6) {
				$color['r'] = hexdec(substr($hex, 0, 2));
				$color['g'] = hexdec(substr($hex, 2, 2));
				$color['b'] = hexdec(substr($hex, 4, 2));
			}

			return 'rgba('.$color['r'].','.$color['g'].', '.$color['b'].', '.$transparency.')';
	}
}


/**
	BOC WooCommerce methods
**/
if( ! function_exists( 'boc_cart_in_header' ) ) {
	function boc_cart_in_header() {
			global $woocommerce;
			$woocommerce_cart_in_header = ot_get_option('woocommerce_cart_in_header', 'on');		
			if ($woocommerce_cart_in_header == 'on') { 		
				if ($woocommerce) { 
					return true;
				}
			}else return false;
	}
}

/**
	Generate the Cart in Header Drop Down Content
**/

if( ! function_exists( 'boc_render_cart_in_header' ) ) {
	function boc_render_cart_in_header () {
		
		global $woocommerce;
		$cart_classes = 'is_empty';
		if($woocommerce->cart->cart_contents_count > 0) {
			$cart_classes = 'is_not_empty';
		}
		if("style_dark" == ot_get_option('woocommerce_cart_in_header_bgr_color', 'style_dark')) {
			$cart_classes .= ' style_dark';
		}
		$link = function_exists( 'wc_get_cart_url' ) ? wc_get_cart_url() : $woocommerce->cart->get_cart_url();
	?>
				<div class="header_cart <?php echo esc_attr($cart_classes);?>">
					<div class="cart_widget_holder">
					
						<a class="cart-contents header_cart_icon boc_i-cart2" href="<?php echo esc_url($link); ?>">
							<p class="cart-wrap"><span><?php echo esc_html($woocommerce->cart->cart_contents_count); ?></span></p>
						</a>
						
						<div class="cart-notification">
							<span class="item-name"></span> <?php echo esc_html__('was successfully added to your cart.','alea'); ?>
						</div>
						
						<?php
							// Check for WooCommerce 2.0 and display the cart widget
							if ( version_compare( WOOCOMMERCE_VERSION, "2.0.0" ) >= 0 ) {
								the_widget( 'WC_Widget_Cart', 'title= ' );
							} else {
								the_widget( 'WooCommerce_Widget_Cart', 'title= ' );
							}
						?>
					</div>
				</div>
	<?php
	}
}





/**
	Page Background
**/
if( ! function_exists( 'boc_get_BGR_css' ) ) {
	function boc_get_BGR_css(){

		$custom_background_css = '';

		$global_bgr_set = false;
		
		// Per Page background in Page Settings
		if ( is_single() || is_page() ) {
			
			$background = get_post_meta( get_the_ID(), 'boc_page_bgr', true );
			if ( !empty( $background ) /* && $background['background-image']*/ ) {
				$background_color       = ( $background['background-color'] != '' ) ? $background['background-color'] . ' ' : '';
				$background_image       = ( $background['background-image'] != '' ) ? 'url('.$background['background-image'].') ' : '';
				$background_repeat      = ( $background['background-repeat'] != '' ) ? $background['background-repeat']. ' ' : '';
				$background_positon     = ( $background['background-position'] != '' ) ? $background['background-position']. ' ' : '';
				$background_attachment  = ( $background['background-attachment'] != '' ) ? $background['background-attachment']. ' ' : '';
				$background_size        = ( $background['background-size'] != '' ) ? 'background-size: '. $background['background-size']. ';' : '';
				
				$custom_background_css .= 
					'/* Custom Background for: ' . get_the_title() . ' */' . "\n" .
					'body { background: '.wp_kses_post($background_color.$background_image.$background_repeat.$background_attachment.$background_positon).';'."\n". wp_kses_post($background_size) .'}';
				
				$global_bgr_set = true;
			}
		}

		// If not yet set, search for global setting
		if (!$global_bgr_set){
			
			// Global BGR in Theme Options
			$global_background = ot_get_option('boc_page_global_bgr', array());
			if ( (isset($global_background['background-color']) && $global_background['background-color']) || 
						(isset($global_background['background-image']) && $global_background['background-image'])) {
							
				$background_color       = ( $global_background['background-color'] != '' ) ? $global_background['background-color'] . ' ' : '';
				$background_image       = ( $global_background['background-image'] != '' ) ? 'url('.$global_background['background-image'].') ' : '';
				$background_repeat      = ( $global_background['background-repeat'] != '' ) ? $global_background['background-repeat']. ' ' : '';
				$background_positon     = ( $global_background['background-position'] != '' ) ? $global_background['background-position']. ' ' : '';
				$background_attachment  = ( $global_background['background-attachment'] != '' ) ? $global_background['background-attachment']. ' ' : '';
				$background_size        = ( $global_background['background-size'] != '' ) ? 'background-size: '. $global_background['background-size']. ';' : '';
				
				$custom_background_css .= 
					'/* Global Background */' . "\n" .
					'body { background: '.wp_kses_post($background_color.$background_image.$background_repeat.$background_attachment.$background_positon).';'."\n". wp_kses_post($background_size) .'}';
			}
		}
		

		$custom_page_heading_bgr_set = false;
		
		// Per Page Heading BGR in Page Settings
		if ( is_single() || is_page() || is_home() ) {
			
			
			if(is_home()) {
				$post_id = get_option( 'page_for_posts' );
			}else {
				$post_id = get_the_ID();
			}
			
			$page_heading_bgr_meta = get_post_meta( $post_id, 'boc_page_heading_bgr_meta', true );
			if ( !empty( $page_heading_bgr_meta ) /* && $page_heading_bgr_meta['background-image']*/ ) {
				$ph_background_color_meta       = ( $page_heading_bgr_meta['background-color'] != '' ) ? $page_heading_bgr_meta['background-color'] . ' ' : '';
				$ph_background_image_meta       = ( $page_heading_bgr_meta['background-image'] != '' ) ? 'url('.$page_heading_bgr_meta['background-image'].') ' : '';
				$ph_background_repeat_meta      = ( $page_heading_bgr_meta['background-repeat'] != '' ) ? $page_heading_bgr_meta['background-repeat']. ' ' : '';
				$ph_background_positon_meta     = ( $page_heading_bgr_meta['background-position'] != '' ) ? $page_heading_bgr_meta['background-position']. ' ' : '';
				$ph_background_attachment_meta  = ( $page_heading_bgr_meta['background-attachment'] != '' ) ? $page_heading_bgr_meta['background-attachment']. ' ' : '';
				$ph_background_size_meta        = ( $page_heading_bgr_meta['background-size'] != '' ) ? 'background-size: '. $page_heading_bgr_meta['background-size']. ';' : '';
				
				$custom_background_css .= 
					'/* Custom Background for: ' . get_the_title() . ' */' . "\n" .
					'.page_title_bgr .full_container_page_title,
					 .page_title_bgr.bgr_style1 .full_container_page_title { 
						background: '.wp_kses_post($ph_background_color_meta.$ph_background_image_meta.$ph_background_repeat_meta.$ph_background_attachment_meta.$ph_background_positon_meta).';'."\n". wp_kses_post($ph_background_size_meta) .'}';
						
				$custom_page_heading_bgr_set = true;
			}
			
			// Heading Text Color white?
			if(get_post_meta( $post_id, 'boc_page_heading_white_text_meta', true ) == 'on'){
				$custom_background_css .= 
					'/* Page Heading Text Color - White */' . "\n" .
					'.page_heading h1,
					 .breadcrumb a{ 
						color: #fff;
					}';
			}			
			
		
		}
		
		// If not yet set, search for global setting
		if(!$custom_page_heading_bgr_set){
			
			// Heading BGR Global		
			$page_heading_style = ot_get_option('page_heading_style','page_title_bgr bgr_style1');
			if($page_heading_style == "page_title_bgr custom_bgr") {
				$page_heading_bgr = ot_get_option('boc_page_heading_style_bgr', array());
				if ( !empty( $page_heading_bgr)) {
					$ph_background_color       = ( $page_heading_bgr['background-color'] != '' ) ? $page_heading_bgr['background-color'] . ' ' : '';
					$ph_background_image       = ( $page_heading_bgr['background-image'] != '' ) ? 'url('.$page_heading_bgr['background-image'].') ' : '';
					$ph_background_repeat      = ( $page_heading_bgr['background-repeat'] != '' ) ? $page_heading_bgr['background-repeat']. ' ' : '';
					$ph_background_positon     = ( $page_heading_bgr['background-position'] != '' ) ? $page_heading_bgr['background-position']. ' ' : '';
					$ph_background_attachment  = ( $page_heading_bgr['background-attachment'] != '' ) ? $page_heading_bgr['background-attachment']. ' ' : '';
					$ph_background_size        = ( $page_heading_bgr['background-size'] != '' ) ? 'background-size: '. $page_heading_bgr['background-size']. ';' : '';
					
					$custom_background_css .= 
						'/* Page Heading Background */' . "\n" .
						'.page_title_bgr .full_container_page_title { 
							background: '.wp_kses_post($ph_background_color.$ph_background_image.$ph_background_repeat.$ph_background_attachment.$ph_background_positon).';'."\n". wp_kses_post($ph_background_size) .'}';
				}
			}
			
			// Heading Text Color white?
			if(ot_get_option('boc_page_heading_white_text','off') == 'on'){
				$custom_background_css .= 
					'/* Page Heading Text Color - White */' . "\n" .
					'.page_heading h1,
					 .breadcrumb a{ 
						color: #fff;
					}';
			}
			
		}
		
		return $custom_background_css;
	}
}

/**
	BOC Inline CSS Generation
**/
if( ! function_exists( 'boc_get_inline_CSS' ) ) { 
	function boc_get_inline_CSS() {


		global $boc_js_params;

		$fonts_available = 	array_merge(get_theme_mod( 'ot_google_fonts', array() ) , boc_get_system_fonts());
		
		// Inline CSS to be included
		$inline_css = '';

		// Page Background image
		$inline_css .= boc_get_BGR_css();
		
		
		//---- MAIN MENU ITEMS (Top Level)
	
		// Nav Font Family
		$nav_font = ot_get_option('nav_font');
		if(is_array($nav_font) && ($nav_font['font-family'] != 'montserrat')  && ($nav_font['font-family'])) {
			$inline_css .="
				#menu > ul > li > a,
				.mobile_menu_ul li a,
				.header_search_form input{
					font-family: '".wp_kses_post($fonts_available[$nav_font['font-family']]['family'])."', Montserrat, Arial, Helvetica, sans-serif;
				}\n";
		}
		// Nav font size
		if(is_array($nav_font) && ($nav_font['font-size']!="14px") && ($nav_font['font-size'])){
			$inline_css .="
				#menu > ul > li > a {
					font-size: ".wp_kses_post($nav_font['font-size']).";
				}\n";
		}
		// Nav font weight
		if(is_array($nav_font) && (!in_array($nav_font['font-weight'],array('500'))) && ($nav_font['font-weight'])){
			$inline_css .="
				#menu > ul > li > a {
					font-weight: ".wp_kses_post($nav_font['font-weight']).";
				}\n";
		}	
		// Nav text transform
		if(is_array($nav_font) && ($nav_font['text-transform']!="capitalize") && ($nav_font['text-transform'])){
			$inline_css .="
				#menu > ul > li > a {
					text-transform: ".wp_kses_post($nav_font['text-transform']).";
				}\n";
		}		
		// Nav letter spacing
		if(is_array($nav_font) && ($nav_font['letter-spacing']!='0em') && ($nav_font['letter-spacing'])){
			$inline_css .="
				#menu > ul > li > a {
					letter-spacing: ".wp_kses_post($nav_font['letter-spacing']).";
				}\n";
		}	

		
		//---- SUBMENU ITEMS 
		
		// Nav Font Family
		$sub_nav_font = ot_get_option('sub_nav_font');
		if(is_array($sub_nav_font) && ($sub_nav_font['font-family'] != 'montserrat')  && ($sub_nav_font['font-family'])) {
			
			$inline_css .="
				#menu > ul > li ul > li > a {
					font-family: '".wp_kses_post($fonts_available[$sub_nav_font['font-family']]['family'])."', Montserrat, Arial, Helvetica, sans-serif;
				}\n";
		}
		// Nav font size
		if(is_array($sub_nav_font) && ($sub_nav_font['font-size']!="13px") && ($sub_nav_font['font-size'])){
			$inline_css .="
				#menu > ul > li ul > li > a {
					font-size: ".wp_kses_post($sub_nav_font['font-size']).";
				}\n";
		}
		// Nav font weight
		if(is_array($sub_nav_font) && (!in_array($sub_nav_font['font-weight'],array('normal','400'))) && ($sub_nav_font['font-weight'])){
			$inline_css .="
				#menu > ul > li ul > li > a {
					font-weight: ".wp_kses_post($sub_nav_font['font-weight']).";
				}\n";
		}
		// Nav text transform
		if(is_array($sub_nav_font) && ($sub_nav_font['text-transform']!="capitalize") && ($sub_nav_font['text-transform'])){
			$inline_css .="
				#menu > ul > li ul > li > a {
					text-transform: ".wp_kses_post($sub_nav_font['text-transform']).";
				}\n";
		}
		// Nav letter spacing
		if(is_array($sub_nav_font) && ($sub_nav_font['letter-spacing']!='0em') && ($sub_nav_font['letter-spacing'])){
			$inline_css .="
				#menu > ul > li ul > li > a {
					letter-spacing: ".wp_kses_post($sub_nav_font['letter-spacing']).";
				}\n";
		}



		//---- Headings
			
		// Headings Font Family
		$heading_font = ot_get_option('heading_font');
		if(is_array($heading_font) && ($heading_font['font-family'] != 'montserrat')  && ($heading_font['font-family'])) {
			$inline_css .="
				h1, h2, h3, h4, h5, h6, .title, .heading_font, .htabs a, .boc_side_widget ul.menu li a{
					font-family: '".wp_kses_post($fonts_available[$heading_font['font-family']]['family'])."', Montserrat, Arial, Helvetica, sans-serif;
				}\n";
		}
		// Headings font weight
		if(is_array($heading_font) && ($heading_font['font-weight']!='500') && ($heading_font['font-weight'])){
			$inline_css .="
				h1, h2, h3, h4, h5, h6, .title, .heading_font, .htabs a, .boc_side_widget ul.menu li a{
					font-weight: ".wp_kses_post($heading_font['font-weight']).";
				}\n";
		}
		// Headings text transform
		if(is_array($heading_font) && ($heading_font['text-transform']!="uppercase") && ($heading_font['text-transform'])){
			$inline_css .="
				h1, h2, h3, h4, h5, h6, .title, .heading_font, .htabs a, .boc_side_widget ul.menu li a{
					text-transform: ".wp_kses_post($heading_font['text-transform']).";
				}\n";
		}
		// Headings letter spacing
		if(is_array($heading_font) && ($heading_font['letter-spacing']!='-0.02em') && ($heading_font['letter-spacing'])){
			$inline_css .="
				h1, h2, h3, h4, h5, h6, .title, .heading_font, .htabs a, .boc_side_widget ul.menu li a{
					letter-spacing: ".wp_kses_post($heading_font['letter-spacing']).";
				}\n";
		}

		


		//---- Body
			
		// Body Font Family
		$body_font = ot_get_option('body_font');
		if(is_array($body_font) && ($body_font['font-family'] != 'opensans')  && ($body_font['font-family'])) {
			$inline_css .="
				body, .body_font, .body_font h1, .body_font h2, .body_font h3, .body_font h4, .body_font h5 {
					font-family: '".wp_kses_post($fonts_available[$body_font['font-family']]['family'])."', Arial, Helvetica, sans-serif;
				}\n";
		}
		// Body font size
		if(is_array($body_font) && ($body_font['font-size']!="16px") && ($body_font['font-size'])){
			$inline_css .="
				body {
					font-size: ".wp_kses_post($body_font['font-size']).";
				}\n";
		}	
		// Body font weight
		if(is_array($body_font) && (!in_array($body_font['font-weight'],array('normal','400'))) && ($body_font['font-weight'])){
			$inline_css .="
				body {
					font-weight: ".wp_kses_post($body_font['font-weight']).";
				}\n";
		}

		
		//---- Buttons
			
		// Button Font Family
		$button_font = ot_get_option('button_font');
		if(is_array($button_font) && ($button_font['font-family'] != 'opensans')  && ($button_font['font-family'])) {
			$inline_css .="
				.button, a.button, button, input[type='submit'], input[type='reset'], input[type='button'] {
					font-family: '".wp_kses_post($fonts_available[$button_font['font-family']]['family'])."', Arial, Helvetica, sans-serif;
				}\n";
		}
		// Button text transform
		if(is_array($button_font) && ($button_font['text-transform']!="none") && ($button_font['text-transform'])){
			$inline_css .="
				.button, a.button, button, input[type='submit'], input[type='reset'], input[type='button'] {
					text-transform: ".wp_kses_post($button_font['text-transform']).";
				}\n";
		}
		// Button font weight
		if(is_array($button_font) && ($button_font['font-weight']!='600') && ($button_font['font-weight'])){
			$inline_css .="
				.button, a.button, button, input[type='submit'], input[type='reset'], input[type='button'],
				.woocommerce #respond input#submit, .woocommerce a.button, .woocommerce button.button, .woocommerce input.button {
					font-weight: ".wp_kses_post($button_font['font-weight']).";
				}\n";
		}
		// Button letter spacing
		if(is_array($button_font) && isset($button_font['letter-spacing']) && ($button_font['letter-spacing']!='0.05em') && ($button_font['letter-spacing'])){
			$inline_css .="
				.button, a.button, button, input[type='submit'], input[type='reset'], input[type='button'] {
					letter-spacing: ".wp_kses_post($button_font['letter-spacing']).";
				}\n";
		}


		// Header Height
		$boc_js_params['header_height'] = 92;
		if((($header_height = boc_header_height())!=92)) {
			$inline_css .="
			  @media only screen and (min-width: 1018px){
				.menu_regular_style #menu > ul > li > a, #header .menu_regular_style .header_cart_icon { line-height: ".(int)($header_height - 4)."px; }
				.menu_regular_style .header_cart .widget_shopping_cart { top: ".(int)($header_height - 4)."px; }
				.menu_regular_style #menu > ul > li.boc_nav_button { height: ".(int)($header_height - 4)."px; }
				#logo .logo_img,
				.menu_toplogo #logo .logo_img { height: ".(int)$header_height."px; }
				.menu_regular_style #boc_menu_icon { top:".round((int)($header_height - 12)/2)."px; }
			  }\n";
			  $boc_js_params['header_height'] = (int)$header_height;
		}
		// Header BGR color
		$header_bgr_color = boc_get_header_bgr_color();
		if($header_bgr_color!='#ffffff') {
			$inline_css .='	
				#header, .boc_subheader_widget {
					background: '.$header_bgr_color.';
				}
			';
		}
		
		// Normal/Sticky Header
		if(!($sticky_header = boc_is_header_sticky())){
			$inline_css .="
				#header { 
					position: relative;
					-webkit-transition: none;
					-moz-transition: none;
					-ms-transition: none;
					-o-transition: none;
					transition: none;
				}\n";
			$boc_js_params['sticky_header'] = 0;
		}else {
			$boc_js_params['sticky_header'] = 1;
		}
		
		
		// MegaMenu bordered columns
		if(!($mm_bordered_columns = boc_is_mm_bordered_columns())){
			$inline_css .='	
				#menu > ul > li.megamenu  > div > ul.sub-menu > li{ 
					border-left: none!important; 
				}
			';
			$boc_js_params['mm_bordered_columns'] = 0;
		}else {
			$boc_js_params['mm_bordered_columns'] = 1;
		}
		
		// If using Sticky Header overwrite Sticky BGR if any of the 2 values have been changed
		if($sticky_header){
			$sticky_header_opacity = boc_get_sticky_header_opacity();
			$header_bgr_color = boc_get_header_bgr_color();
			$sticky_header_color = boc_get_sticky_header_color();
			if(($sticky_header_opacity != 0.97) || ($sticky_header_color!= '#ffffff')){
				$inline_css .='
					#header.scrolled {
						background: '.boc_HexToRGB(esc_attr($header_bgr_color), esc_attr($sticky_header_opacity)).';
					}
				';
			}
		}
		
		// Sticky Header Height
		if($sticky_header){
			// If Nav only sticky header
			$only_nav_sticky_header = boc_is_only_nav_sticky_header();
			if($only_nav_sticky_header){
				$inline_css .="
					#header.scrolled.sticky_header {
						top: -".(boc_header_height()+38)."px !important;
						transition: top 0.3s ease-out, background-color 0.6s ease;
					}
					#header.scrolled.sticky_header .menu_stripe_style { bottom: -46px; }
					\n";
					
			}elseif((($sticky_header_height = boc_sticky_header_height())!=64) && $sticky_header) {
				$sticky_header_height = esc_attr($sticky_header_height);
				$inline_css .="
				  @media only screen and (min-width: 1018px){	
					#header.scrolled .menu_regular_style #menu > ul > li > a, 
					#header.scrolled .menu_regular_style .header_cart .header_cart_icon { line-height: ".(int)($sticky_header_height - 4)."px; }
					#header.scrolled .menu_regular_style .header_cart .widget_shopping_cart { top: ".(int)($sticky_header_height - 4)."px; }
					#header.scrolled .menu_regular_style #menu > ul > li.boc_nav_button { height: ".($sticky_header_height - 4)."px; }
					#header.scrolled #logo .logo_img { height: ".$sticky_header_height."px;}
					.menu_midlogo #header.scrolled #logo .logo_img > a { height: ".$sticky_header_height."px !important;}
					#header.scrolled .menu_regular_style #boc_menu_icon { top:".round(($sticky_header_height - 12)/2)."px; }
				  }\n";
				  
			}
		}
		
		// Override mobile header bgr
		$mobile_header_bgr = ot_get_option('mobile_header_bgr','#ffffff');
		if($mobile_header_bgr != '#ffffff'){
			$inline_css .="
					#mobile_header {
						background: ".$mobile_header_bgr.";
						border-bottom: 1px solid ".$mobile_header_bgr.";
					}\n";
		}
		// Override mobile header text color
		$mobile_header_text_color = ot_get_option('mobile_header_text_color','#333333');
		if($mobile_header_text_color != '#333333'){
			$inline_css .="
					.m_nav_ham, .boc_menu_icon_ham {
						background: ".$mobile_header_text_color.";
					}
					#mobile_header .header_cart a.header_cart_icon {
						color: ".$mobile_header_text_color.";
					}\n";
		}
		
		// Hide Admin bar in mobile for sticky header?
		$hide_admin_bar = ot_get_option('hide_admin_bar','on');
		if($hide_admin_bar == 'on'){
			$inline_css .="
					@media only screen and (max-width: 1018px){
						#wpadminbar {display: none;}
					}\n";
		}		
		
		// Transparent Header
		if(boc_is_transparent_header()){
			$boc_js_params['transparent_header'] = 1;
			if(!boc_is_header_sticky()){
				$inline_css .="
					@media only screen and (min-width: 1018px){
							#header {
								position: absolute;
								margin-top: 0!important;
								-webkit-transition: none;
								-moz-transition: none;
								-ms-transition: none;
								-o-transition: none;
								transition: none;
							}
					}\n";
			}
		}else {
			$boc_js_params['transparent_header'] = 0;
		}
		
		
		
		
		// Update Main Nav underline effect Color
		if(boc_is_main_nav_underline_effect()){
			$inline_css .="
				.main_menu_underline_effect > li:after{ background-color: ".esc_attr(boc_main_nav_underline_effect_color())."; }\n";
		}
		
		// Global Border Radius
		if($rounded_images = ot_get_option('rounded_images',1)){
			$inline_css .="
				img,
				.pic,
				.pic_info.type7 .info_overlay {
					-moz-border-radius: 3px; -webkit-border-radius: 3px; border-radius: 3px;
				}
				.post_item_block.boxed {
					-moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px;
				}

				.pic_info.type1 img,
				.pic_info.type2 .pic, .pic_info.type2 img,
				.pic_info.type3 .pic,
				.pic_info.type4 .pic,
				.pic_info.type5 .pic,
				.pic_info.type5 .pic img,
				.post_item_block.boxed .pic,
				.post_item_block.boxed .pic img {
					-moz-border-radius: 3px 3px 0 0; -webkit-border-radius: 3px 3px 0 0; border-radius: 3px 3px 0 0;
				}\n";
		}


		// Main Color
		$boc_main_color = boc_get_main_color();
		$boc_default_color = boc_get_default_color();
		
		if($boc_main_color != $boc_default_color){
			$boc_main_color = esc_attr($boc_main_color);
			$inline_css .='	
				a:hover, a:focus,
				.post_content a:not(.button),
				.post_content .post_block_post_meta a:not(.button):hover,
				.post_content .wpb_widgetised_column a:not(.button):hover,
				a:hover .boc_social_icon_style_minimal .boc_social_icon,
				.boc_social_sharing_icons a:hover span,
				.post_content .team_block h4 a:hover,
				.team_block .team_icons a:hover,
				.breadcrumb a:hover,
				h1 strong, h2 strong, h3 strong, h4 strong, h5 strong,
				.top_icon_box h3 a:hover,
				.header_contacts span,
				.boc_icon_text_item .icon,
				a:hover.button.btn_no_bgr,
				a:hover.button.btn_no_bgr_white,
				.post_meta a:hover,
				.blog_icon,
				a .blog_icon,
				.blog_icon.liked,
				.boc_prev_next_posts div p,
				.counter-digit,
				.counter_post_text,
				.tp-caption a:not(.button):hover,
				#sidebar .boc_contact_icon span,
				.more-link1:before,
				.image_featured_text .pos,
				.side_icon_box .icon_feat i.icon,
				.boc_list_item .li_icon i.icon,
				h2.title strong,
				ul.theme_color_ul li:before,
				#footer a:hover,
				.boc_side_widget h4.boc_heading,
				.widget.widget_rss li a,
				.widget.widget_recent_comments li a {
					color: '.$boc_main_color.'; 
				}
				
				.post_content a:not(.button):hover,
				.post_content .wpb_widgetised_column .side_bar_menu a:not(.button):hover { color: #333; }
				
				::selection { background-color: '.$boc_main_color.';}
				
				#boc_page_preloader .spinner .path { stroke: '.$boc_main_color.'; }
				
				a.dark_links:hover, .dark_links a:hover, .white_links a:hover, 
				.dark_links a:hover h2, .dark_links a:hover h3,
				.full_width_feature .post_meta .post_comments a:hover .blog_icon,
				.full_width_feature .post_meta .boc_like_wrapper  a:hover .blog_icon { color: '.$boc_main_color.' !important; }
				
				#boc_vertical-nav .is-selected a .boc_dot,
				#sidebar .widget:not(.woocommerce):not(.widget_rss):not(.widget_recent_comments) > ul li:hover:before,
				#sidebar .widget:not(.woocommerce):not(.widget_rss):not(.widget_recent_comments) .menu > li:hover:before,
				#sidebar .widget:not(.woocommerce):not(.widget_rss):not(.widget_recent_comments) > ul li a:hover:before, 
				#sidebar .widget:not(.woocommerce):not(.widget_rss):not(.widget_recent_comments) .menu > li a:hover:before	{ 
					background-color: '.$boc_main_color.';
				}





				.small_video_link:before { background-color: '.$boc_main_color.'; }
				.small_video_link:hover:before { box-shadow: 0px 0px 0px 2px '.$boc_main_color.';}

				.button:hover, a:hover.button, button:hover, input[type="submit"]:hover, input[type="reset"]:hover,	input[type="button"]:hover, .btn_theme_color, a.btn_theme_color { color: #fff; background-color:'.$boc_main_color.';}
				input.btn_theme_color, a.btn_theme_color, .btn_theme_color { color: #fff; background-color:'.$boc_main_color.';}
				.btn_theme_color:hover, input.btn_theme_color:hover, a:hover.btn_theme_color { color: #fff; background-color: #333;}

				#sidebar #s:active, #sidebar #s:focus { border: 1px solid '.$boc_main_color.'; }
				input.btn_theme_color.btn_outline, a.btn_theme_color.btn_outline, .btn_theme_color.btn_outline {
					color: '.$boc_main_color.' !important;
					border: 2px solid '.$boc_main_color.';
				}
				input.btn_theme_color.btn_outline:hover, a.btn_theme_color.btn_outline:hover, .btn_theme_color.btn_outline:hover{
					background-color: '.$boc_main_color.' !important;
				}

				.htabs a.selected  { border-top: 2px solid '.$boc_main_color.';}
				.buttons_boxed_style.resp-vtabs .resp-tabs-list li.resp-tab-active { border-left: 2px solid '.$boc_main_color.';}
				.button_style.horizontal .resp-tabs-list li.resp-tab-active,
				.button_style.resp-vtabs .resp-tabs-list li.resp-tab-active,
				.minimal_style.resp-vtabs .resp-tabs-list li.resp-tab-active { background: '.$boc_main_color.';}
				.minimal_style.horizontal .resp-tabs-list li.resp-tab-active { border-bottom: 2px solid '.$boc_main_color.';}
				
				#s:focus {	border: 1px solid '.$boc_main_color.';}

				.tagcloud a:hover { background-color: '.$boc_main_color.';}
				.month { background-color: '.$boc_main_color.';}
				.small_month  { background-color: '.$boc_main_color.';}

				.buttons_boxed_style.horizontal .resp-tabs-list li.resp-tab-active { border-top: 2px solid '.$boc_main_color.';}
				.resp-vtabs li.resp-tab-active { border-left: 2px solid '.$boc_main_color.'; }

				#portfolio_filter { background-color: '.$boc_main_color.';}
				#portfolio_filter ul li div:hover { background-color: '.$boc_main_color.';}
				.portfolio_inline_filter ul:not(.minimal_filter_style) li div:hover { background-color: '.$boc_main_color.';}
				.portfolio_inline_filter ul.minimal_filter_style li div:after,
				.post_item_block.metro h4:after	{ background-color: '.$boc_main_color.';}

				.side_icon_box .icon_feat.icon_solid { background-color: '.$boc_main_color.'; }
				.boc_list_item .li_icon.icon_solid { background: '.$boc_main_color.'; }

				.top_icon_box.type1 .icon_holder .icon_bgr { background-color: '.$boc_main_color.'; }
				.top_icon_box.type1:hover .icon_holder .icon_bgr { border: 2px solid '.$boc_main_color.'; }
				.top_icon_box.type1 .icon_holder .icon_bgr:after,
				.top_icon_box.type1:hover .icon_holder .icon_bgr:after { border: 2px solid '.$boc_main_color.'; }
				.top_icon_box.type1:hover .icon_holder i { color: '.$boc_main_color.';}

				.top_icon_box.type2 .icon_holder .icon_bgr { background-color: '.$boc_main_color.'; }
				.top_icon_box.type2:hover .icon_holder .icon_bgr { background-color: #fff; }
				.top_icon_box.type2:hover .icon_holder i { color: '.$boc_main_color.';}

				.top_icon_box.type3 .icon_holder .icon_bgr:after { border: 2px solid '.$boc_main_color.'; }
				.top_icon_box.type3:hover .icon_holder .icon_bgr { background-color: '.$boc_main_color.'; }
				.top_icon_box.type3:hover .icon_holder .icon_bgr:after { border: 2px solid '.$boc_main_color.'; }
				.top_icon_box.type3 .icon_holder i { color: '.$boc_main_color.';}
				.top_icon_box.type3:hover .icon_holder i { color: #fff; }

				.top_icon_box.type4:hover .icon_holder .icon_bgr { border: 2px solid '.$boc_main_color.'; }
				.top_icon_box.type4:hover .icon_holder .icon_bgr:after { border: 2px solid '.$boc_main_color.'; }
				
				.top_icon_box.type4 .icon_holder i,
				.top_icon_box.type4:hover .icon_holder i,
				.top_icon_box.type5 .icon_holder i,
				.top_icon_box.type10 .icon_holder i { color: '.$boc_main_color.'; }
				
				a:hover .boc_icon {	color: '.$boc_main_color.'!important;}
				
				.icon_3d .boc_sticky .back .circle,
				.boc_sticky .front .circle { background-color: '.$boc_main_color.'; }
				
				a .pic_info.type11 .plus_overlay { border-bottom: 50px solid '.boc_HexToRGB($boc_main_color, 0.8).'; }
				a:hover .pic_info.type11 .plus_overlay { border-bottom: 1000px solid '.boc_HexToRGB($boc_main_color, 0.8).';}
				
				a .pic_info.type12 .img_overlay_icon,
				a:hover .pic_info.type12 .img_overlay_icon { background: '.boc_HexToRGB($boc_main_color, 0.8).';}

				.custom_slides.nav_design_1 .cs_nav_item.active .cs_nav_icon i.icon{ color: '.$boc_main_color.';}
				.custom_slides.nav_style_1.nav_design_1 .cs_nav_item:hover .cs_nav_icon i.icon,
				.custom_slides.nav_style_1.nav_design_2 .cs_nav_item:hover .cs_nav_icon i.icon { color: '.$boc_main_color.';}
				.custom_slides.nav_design_2 .cs_nav_item.active .cs_nav_icon { background: '.$boc_main_color.';}
				.cs_nav_item.has_no_text:hover .cs_nav_icon i.icon { color: '.$boc_main_color.';}
				.custom_slides.nav_style_2 .cs_txt { color: '.$boc_main_color.';}
				
				.acc_control, .active_acc .acc_control,
				.acc_holder.with_bgr .active_acc .acc_control { background-color: '.$boc_main_color.';}

				.text_box.left_border {	border-left: 3px solid '.$boc_main_color.'; }

				.owl-theme .owl-controls .owl-nav div:hover { color: '.$boc_main_color.';}
				.owl-theme .owl-dots .owl-dot.active span { background: '.$boc_main_color.';}		

				.testimonial_style_big.owl-theme .owl-controls .owl-nav div:hover,
				.posts_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover, 
				.img_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover,
				.content_slides_arrowed.owl-theme .owl-controls .owl-nav div:hover,
				.portfolio_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover	{ color: '.$boc_main_color.';}
				
				.owl-next:not(.disabled) .boc_arrow_right:hover { border-top-color: '.$boc_main_color.'; border-right-color: '.$boc_main_color.';}
				.owl-prev:not(.disabled) .boc_arrow_left:hover { border-bottom-color: '.$boc_main_color.'; border-left-color: '.$boc_main_color.';}
				
				.white_text .quote_author_description { color: '.$boc_main_color.';}
				.testimonial_style_big .quote_author_description { color: '.$boc_main_color.';}
				.white_text .face_nav_item.active_face img{ border: 3px solid '.$boc_main_color.';}
				
				.boc_text_slider_word, .boc_text_slider_word_start { background: '.$boc_main_color.'; }

				.post_item_block.boxed .pic { border-bottom: 2px solid '.$boc_main_color.'; }

				.team_block .team_desc { color: '.$boc_main_color.';}

				.bar_graph span, .bar_graph.thin_style span { background-color: '.$boc_main_color.'; }

				.pagination .links .curr_page { background-color: '.$boc_main_color.';}
				.hilite:before,.hilite:after { background: '.boc_HexToRGB($boc_main_color,0.2).';}
				.price_column.price_column_featured ul li.price_column_title{ background: '.$boc_main_color.';}

				blockquote{ border-left: 3px solid '.$boc_main_color.'; }
				.text_box.left_border { border-left: 3px solid '.$boc_main_color.'; }

				.alea_table tr:hover td { background: '.boc_HexToRGB($boc_main_color, 0.08).';}
				
				a .img_overlay.theme_color { background: '.boc_HexToRGB($boc_main_color, 0.85).'; } 
				
				.header_cart ul.cart_list li a, .header_cart ul.product_list_widget li a { color: '.$boc_main_color.';}
				.header_cart .cart-notification { background-color: '.$boc_main_color.';}
				.header_cart .cart-notification:after { border-bottom-color: '.$boc_main_color.';}
				
				.info h2{ background-color: '.$boc_main_color.';}

				a .pic_info.type1 .plus_overlay {	border-bottom: 50px solid '.boc_HexToRGB($boc_main_color,0.8).';}
				a:hover .pic_info.type1 .plus_overlay { border-bottom: 1000px solid '.boc_HexToRGB($boc_main_color,0.8).'; }
				
				a .pic_info.type2 .img_overlay_icon,
				a:hover .pic_info.type2 .img_overlay_icon {	background: '.boc_HexToRGB($boc_main_color,0.8).'; }
				
				a .pic_info.type3  .img_overlay_icon,
				a:hover .pic_info.type3 .img_overlay_icon {	background: '.boc_HexToRGB($boc_main_color,0.8).';}
				a .pic_info.type3 .info_overlay { border-top: 2px solid '.$boc_main_color.'; }
				
				a .pic_info.type4 .img_overlay_icon { border-bottom: 2px solid '.boc_HexToRGB($boc_main_color,0.9).';}
				a .pic_info.type4 .img_overlay_icon .portfolio_icon { background-color: '.boc_HexToRGB($boc_main_color,0.8).'; }
				
				a:hover .pic_info.type5 .info_overlay {	background: '.$boc_main_color.';}
				a .pic_info.type5 .info_overlay { border-top: 2px solid '.$boc_main_color.'; }
				
				.pic_info.type6 .info_overlay {	background: '.$boc_main_color.';}
				a .pic_info.type6 .plus_overlay { border-bottom: 50px solid '.$boc_main_color.'; }	

				.pic_info.type7 .info_overlay { background-color: '.boc_HexToRGB($boc_main_color,0.9).'; } 
				.pic_info.type8 .info_overlay h3:after { border-top: 2px solid '.$boc_main_color.'; }
				
				.cd-headline.loading-bar .cd-words-wrapper::after { background: '.$boc_main_color.';}
				.cd-headline.type .cd-words-wrapper.selected { background-color: '.$boc_main_color.';}
				
				.woocommerce a.button, .woocommerce button.button, .woocommerce input.button, .woocommerce #respond input#submit, .woocommerce #content input.button, .woocommerce-page a.button, .woocommerce-page button.button, .woocommerce-page input.button, .woocommerce-page #respond input#submit, .woocommerce-page #content input.button, .header_cart .cart-wrap, #boc_header_cart_li .cart-wrap,
				.woocommerce nav.woocommerce-pagination ul li span.current,
				.woocommerce .widget_price_filter .ui-slider .ui-slider-range, .woocommerce-page .widget_price_filter .ui-slider .ui-slider-range,
				.widget.woocommerce .product-categories li .count.cat_hovered { background:'.$boc_main_color.'!important; }
				
				@media only screen and (max-width: 768px) {
					.cs_nav .cs_nav_item.active { background: '.$boc_main_color.' !important;}
				}
			';
			
		}

		
		// Woocommerce Responsive
		if(function_exists('is_woocommerce') && is_woocommerce() && wp_is_mobile()) {
			$inline_css .="
			
				.woocommerce .product_meta a, .woocommerce p.stars a { color: '.$boc_main_color.';}
				.woocommerce a.button, .woocommerce button.button, .woocommerce input.button, .woocommerce #respond input#submit, .woocommerce #content input.button, .woocommerce-page a.button, .woocommerce-page button.button, .woocommerce-page input.button, .woocommerce-page #respond input#submit, .woocommerce-page #content input.button { background-color: '.$boc_main_color.'!important; }
				.header_cart .cart-wrap	{ background-color: '.$boc_main_color.'; }
				.header_cart .cart-wrap:before { border-color: transparent '.$boc_main_color.' transparent; }
				.woocommerce .widget_price_filter .ui-slider .ui-slider-range, .woocommerce-page .widget_price_filter .ui-slider .ui-slider-range{ background-color: '.$boc_main_color.' !important;}

				.woocommerce nav.woocommerce-pagination ul li span.current, .woocommerce #content nav.woocommerce-pagination ul li span.current, .woocommerce-page nav.woocommerce-pagination ul li span.current, .woocommerce-page #content nav.woocommerce-pagination ul li span.current { background-color: '.$boc_main_color.' !important;}
				
				.woocommerce ul.products li.product:hover .price, 
				.woocommerce-page ul.products li.product:hover .price {	opacity: 1;	transform: translateY(0);}

				.woocommerce ul.products li.product a.add_to_cart_button { opacity: 1; transform: translateY(0px); margin: 6px 0 !important;}
				.woocommerce ul.products li.product:hover a.add_to_cart_button { transform: translateY(0);}
				";
		}	



		// Custom SubMenu top border color
		if(get_submenu_top_border()){
			$submenu_top_border_color = get_submenu_top_border_color();
			$inline_css .="
					.boc_main_menu.submenu_top_border ul { border-top: 2px solid ".$submenu_top_border_color."; }
				";
		}

		
		/////////////////////////////////////////////
		//     Regular Menu Style specific CSS
		/////////////////////////////////////////////
		if((boc_get_navigation_style() == "menu_regular_style") || (boc_get_navigation_style() == "menu_regular_style menu_midlogo")|| (boc_get_navigation_style() == "menu_regular_style menu_toplogo")){
			
			// Top Level Main Menu Top level Item Colors
			if(($boc_main_nav_color = boc_get_main_navigation_color())!='#333333'){
				$boc_main_nav_color = esc_attr($boc_main_nav_color);
				$inline_css .="
					#menu > ul > li > a, #header .header_cart a.header_cart_icon, .boc_subheader_widget a { color: ".$boc_main_nav_color."; }
					.menu_regular_style #menu > ul > li.boc_nav_button a{ color: ".$boc_main_nav_color."; border: 2px solid ".$boc_main_nav_color."; }
					.menu_regular_style .boc_menu_icon_ham { background: ".$boc_main_nav_color."; } \n";
			}
			if(($boc_main_nav_hover_color = boc_get_main_navigation_hover_color())!='#333333'){
				$boc_main_nav_hover_color = esc_attr($boc_main_nav_hover_color);
				$inline_css .="
					.menu_regular_style #menu > ul > li:not(.boc_nav_button):hover > a, #header .header_cart a.header_cart_icon:hover, .boc_subheader_widget a:hover, .menu_regular_style #menu > ul > li.is-selected > a { color: ".$boc_main_nav_hover_color."; }
					.menu_regular_style #menu > ul > li.boc_nav_button a:hover{ background: ".$boc_main_nav_hover_color."; border: 2px solid ".$boc_main_nav_hover_color."; }
					#boc_menu_icon:hover .boc_menu_icon_ham { background: ".$boc_main_nav_hover_color.";} \n";
			}
		}
		

		/////////////////////////////////////////////
		//      Striped Menu Style specific CSS
		/////////////////////////////////////////////
		if(boc_get_navigation_style() == "menu_stripe_style"){

			$inline_css .="
				#logo { margin: 10px 0 20px; }
			";
			if(($boc_main_nav_color = boc_get_main_navigation_color())!='#333333') {
				$boc_main_nav_color = esc_attr($boc_main_nav_color);
				$inline_css .="
					.boc_icon_text_item .text strong,
					.boc_icon_text_item .text span,
					a.header_search_icon, a.header_cart_icon,
					.boc_subheader_widget a	{ color: ".$boc_main_nav_color."; } \n";
			}
			if(($boc_main_nav_hover_color = boc_get_main_navigation_hover_color())!='#333333'){
				$boc_main_nav_hover_color = esc_attr($boc_main_nav_hover_color);
				$inline_css .="
					a.header_search_icon:hover,
					a.header_cart_icon:hover,
					.boc_subheader_widget a:hover { color: ".$boc_main_nav_hover_color."; } \n";
			}
			// Hover BGR
			if(($striped_main_navigation_hover_color = boc_get_striped_main_navigation_hover_color()) != "#0bafc7"){
				$inline_css .="
					.menu_stripe_style #menu > ul > li:hover > a, 
					.menu_stripe_style #menu > ul > li > a:hover,
					.menu_stripe_style #menu .boc_main_menu > li.boc_nav_button	{ background: ".$striped_main_navigation_hover_color.";} \n
					
					.menu_stripe_style #menu .boc_main_menu > li.boc_nav_button:hover,
					.menu_stripe_style #menu .boc_main_menu > li.boc_nav_button:hover a	{ background: ".boc_HexToRGB($striped_main_navigation_hover_color, '0.65').";} \n";
			}
		}


		/////////////////////////////////////////////
		//      Solid Menu Style specific CSS
		/////////////////////////////////////////////
		elseif(boc_get_navigation_style() == "menu_solid_style"){
			$inline_css .="
				#logo { margin: 8px 0 8px; }
				#header { padding-bottom: 46px;}
			";
			// Top Level Main Menu Top level Item Colors
			if(($boc_main_nav_color = boc_get_main_navigation_color())!='#333333'){
				$boc_main_nav_color = esc_attr($boc_main_nav_color);
				$inline_css .="
					.menu_solid_style #menu > ul > li > a, 
					#header .header_cart a.header_cart_icon, 
					.boc_subheader_widget, .boc_subheader_widget a { color: ".$boc_main_nav_color."; } 
					
					.menu_solid_style .boc_menu_icon_ham { background: ".$boc_main_nav_color."; }
					.boc_icon_text_item .text strong,
					.boc_icon_text_item .text span,
					a.header_search_icon,
					a.header_cart_icon { color: ".$boc_main_nav_color."; } \n";
			}
			if(($boc_main_nav_hover_color = boc_get_main_navigation_hover_color())!='#333333'){
				$boc_main_nav_hover_color = esc_attr($boc_main_nav_hover_color);
				$inline_css .="
					.menu_solid_style #menu > ul > li:hover > a, 
					#header .header_cart a.header_cart_icon:hover,
					a.header_search_icon:hover,	a.header_cart_icon:hover,
					.boc_subheader_widget a:hover { color: ".$boc_main_nav_hover_color."; }
					#boc_menu_icon:hover .boc_menu_icon_ham { background: ".$boc_main_nav_hover_color.";} \n";
			}

		}


		/////////////////////////////////////////////
		//     Angular Menu Style specific CSS
		/////////////////////////////////////////////
		if(boc_get_navigation_style() == "menu_angular_style"){
			
			// Logo Background Section
			$logo_background_color = get_angular_main_navigation_logo_background();
			if($logo_background_color != "#ffffff"){
				$inline_css .="
					.wrapper_menu_angular_style #logo:after { background: ".$logo_background_color."; }\n";
			}
			$transparent_logo_background_color = get_transparent_angular_main_navigation_logo_background();
			if($transparent_logo_background_color != "#ffffff"){
				$inline_css .="
					.wrapper_menu_angular_style #header.transparent_header:not(.scrolled) #logo:after { background: ".$transparent_logo_background_color."; }\n";
			}


			// Top Level Main Menu Top level Item Colors
			if(($boc_main_nav_color = boc_get_main_navigation_color())!='#333333'){
				$boc_main_nav_color = esc_attr($boc_main_nav_color);
				$inline_css .="
					#menu > ul > li > a, #header .header_cart a.header_cart_icon, .boc_subheader_widget a { color: ".$boc_main_nav_color."; }
					.menu_angular_style #menu > ul > li.boc_nav_button a{ color: ".$boc_main_nav_color."; border: 2px solid ".boc_HexToRGB($boc_main_nav_color,'0.6')."; }
					.menu_angular_style .boc_menu_icon_ham { background: ".$boc_main_nav_color."; } \n";
			}
			if(($boc_main_nav_hover_color = boc_get_main_navigation_hover_color())!='#333333'){
				$boc_main_nav_hover_color = esc_attr($boc_main_nav_hover_color);
				$inline_css .="
					.menu_angular_style #menu > ul > li:not(.boc_nav_button):not(.boc_search_border):hover > a, 
					#header .header_cart a.header_cart_icon:hover, .boc_subheader_widget a:hover,
					.menu_angular_style #menu > ul > li.is-selected:not(.boc_nav_button):not(.boc_search_border) > a { color: ".$boc_main_nav_hover_color."; }
					.menu_angular_style #menu > ul > li.boc_nav_button a:hover{ background: ".$boc_main_nav_hover_color."; border: 2px solid ".$boc_main_nav_hover_color."; }
					.wrapper_menu_angular_style #boc_menu_icon:hover .boc_menu_icon_ham,
					.header_cart .cart-wrap, #boc_header_cart_li .cart-wrap	{ background: ".$boc_main_nav_hover_color.";} \n";
			}
		}		
		
		
		

		/////////////////////////////////////////////
		//      SubMenu Hover Color
		/////////////////////////////////////////////
		if(get_submenu_item_hover_style() == 'submenu_bgr_swap'){
			$submenu_item_hover_color = get_submenu_item_hover_color();
			$inline_css .="
				.boc_main_menu.submenu_bgr_swap ul li:not(.mm_col_title):hover,
				.boc_main_menu.submenu_bgr_swap #menu > ul > li:not(.mm_col_title).sf-hover > a,
				.boc_main_menu.submenu_bgr_swap > ul > li:not(.mm_col_title) > a:hover,
				.boc_main_menu.submenu_bgr_swap li li:before,
				.boc_main_menu.submenu_bgr_swap li li:after{
					background: ".$submenu_item_hover_color.";
				}";
		}

	
		// If using Transparent Header overwrite Main Nav Color
		if(boc_is_transparent_header()){	
			$transparent_header_color 		= boc_get_transparent_header_color();
			$transparent_header_opacity 	= boc_get_transparent_header_opacity();
			$transparent_header_nav_color 	= boc_get_transparent_header_nav_color();
			$transparent_header_nav_hover_color = boc_get_transparent_header_nav_hover_color();
			// Subheader
			$subheader_transparent_header_bgr_color	= boc_get_subheader_transparent_header_bgr_color();
			$subheader_transparent_header_text_color = boc_get_subheader_transparent_header_text_color();
			
			$inline_css .='	
				@media only screen and (min-width: 1018px){
					#header.transparent_header:not(.scrolled) { background: '.esc_attr(boc_HexToRGB($transparent_header_color, $transparent_header_opacity)).'; }

					#header.transparent_header:not(.scrolled) #subheader, 
	'.(boc_get_navigation_style()!="menu_stripe_style" ? '
					#header.transparent_header:not(.scrolled) #menu > ul > li > a,' :'').' 
					
					#header.transparent_header:not(.scrolled) .header_cart a.header_cart_icon, 
					#header.transparent_header:not(.scrolled) .header_search_icon, 
					#header.transparent_header:not(.scrolled) .header_cart_icon, 
					#header.transparent_header:not(.scrolled) .boc_icon_text_item .text, 
					#header.transparent_header:not(.scrolled) .boc_icon_text_item .text strong, 
					#header.transparent_header:not(.scrolled) .boc_icon_text_item .text span, 
					#header.transparent_header:not(.scrolled) #menu > ul > li.boc_search_border > a:hover  { 
						color:'.esc_attr($transparent_header_nav_color).'; }	
					
					#header.transparent_header:not(.scrolled) .search_sep{
						border-right: 2px solid '.esc_attr($transparent_header_nav_color).';
					}

					#header.transparent_header:not(.scrolled) .menu_regular_style #boc_menu_icon .boc_menu_icon_ham, 
					#header.transparent_header:not(.scrolled) .menu_solid_style #boc_menu_icon .boc_menu_icon_ham, 
					#header.transparent_header:not(.scrolled) .menu_angular_style #boc_menu_icon .boc_menu_icon_ham { 
						background:'.esc_attr($transparent_header_nav_color).'; }
					#header.transparent_header:not(.scrolled) .menu_regular_style #boc_menu_icon:hover .boc_menu_icon_ham,
					#header.transparent_header:not(.scrolled) .menu_angular_style #boc_menu_icon:hover .boc_menu_icon_ham  { 
						background:'.esc_attr($transparent_header_nav_hover_color).'; }


					#header.transparent_header:not(.scrolled) .menu_regular_style #menu > ul > li:not(.boc_search_border) > a:hover,
					#header.transparent_header:not(.scrolled) .menu_solid_style #menu > ul > li:not(.boc_search_border) > a:hover,
					#header.transparent_header:not(.scrolled) .menu_angular_style #menu > ul > li:not(.boc_search_border) > a:hover,

					#header.transparent_header:not(.scrolled) .menu_regular_style #menu .boc_main_menu > li:not(.boc_nav_button):not(.boc_search_border):hover > a,
					#header.transparent_header:not(.scrolled) .menu_solid_style #menu .boc_main_menu > li:not(.boc_nav_button):not(.boc_search_border):hover > a,
					#header.transparent_header:not(.scrolled) .menu_angular_style #menu .boc_main_menu > li:not(.boc_nav_button):not(.boc_search_border):hover > a,

					#header.transparent_header:not(.scrolled) a.header_search_icon:hover,
					#header.transparent_header:not(.scrolled) a.header_cart_icon:hover,
					#header.transparent_header:not(.scrolled) #subheader a:hover,
					
					#header.transparent_header:not(.scrolled) #menu .boc_main_menu > li.is-selected > a {
						color:'.esc_attr($transparent_header_nav_hover_color).'; }


					#header.transparent_header:not(.scrolled) .menu_regular_style #menu > ul > li.boc_nav_button a,
					#header.transparent_header:not(.scrolled) .menu_angular_style #menu > ul > li.boc_nav_button a {
						color:'.esc_attr($transparent_header_nav_color).';
						border: 2px solid '.esc_attr($transparent_header_nav_color).';
					}
					#header.transparent_header:not(.scrolled) .menu_regular_style #menu > ul > li.boc_nav_button a:hover,
					#header.transparent_header:not(.scrolled) .menu_angular_style #menu > ul > li.boc_nav_button a:hover {
						background:'.esc_attr($transparent_header_nav_hover_color).';
						border: 2px solid '.esc_attr($transparent_header_nav_hover_color).';
					'.(($transparent_header_nav_hover_color=="#ffffff") ? '	color: #333 !important;' : '').'
					}

					#header.transparent_header .full_header,
					#header.transparent_header .boc_subheader_widget{ background: '.$subheader_transparent_header_bgr_color.'; box-shadow: none;}

					#subheader, a.header_soc_icon,
					#header.transparent_header:not(.scrolled) #subheader,
					#header.transparent_header:not(.scrolled) #subheader a,
					#header.transparent_header.scrolled #subheader,
					#header.transparent_header.scrolled #subheader a,
					a.header_soc_icon:visited,
					.header_soc_icon:hover,
					#header.transparent_header:not(.scrolled) .header_contacts span { color: '.$subheader_transparent_header_text_color.'; }
				}
			';
		}


		// SubHeader BGR
		if(boc_get_is_subheader_on() && (boc_get_subheader_bgr_color() != '#e9f3fc')){			
			$inline_css .="
			.full_header {
				background: ".boc_get_subheader_bgr_color().";
			}\n";
		}

		// SubHeader text color
		if(boc_get_is_subheader_on() && (boc_get_subheader_text_color()!="#ffffff")){
			$inline_css .="
			#subheader, .header_soc_icon, .header_soc_icon:hover,
			.header_contacts span {
				color: ".boc_get_subheader_text_color().";
			}\n";
		}

		// SubHeader contact icon color override with Main theme color
		$subheader_contact_icons_color_override = ot_get_option('subheader_contact_icons_color_override','off');
		if($subheader_contact_icons_color_override != 'off'){
			$inline_css .="
			.header_contacts span,
			#header.transparent_header:not(.scrolled) .header_contacts span {
				color: ".boc_get_main_color().";
			}\n";
		}


		// Footer Position
		if(!$footer_position = ot_get_option('footer_position',1)){
			$inline_css .="
			#footer {
				position: relative;
			}
			#wrapper.boxed_wrapper.wrapper_menu_stripe_style #footer {
				top: 56px;
			}\n";
			$boc_js_params['fixed_footer'] = 0;
		} else {
			$boc_js_params['fixed_footer'] = 1;
		}

		// Custom CSS
		if($boc_custom_css = ot_get_option('custom_css')){
			$inline_css .="\n\n".esc_attr($boc_custom_css)."\n";
		}

		return html_entity_decode($inline_css);
	}
}

if( ! function_exists( 'boc_get_system_fonts' ) ) {
	function boc_get_system_fonts() {

		$families = array(
		  'arial'     =>  array(
							'family' => 'Arial',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'georgia'   => array(
							'family' => 'Georgia',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'helvetica' => array(
							'family' => 'Helvetica',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'tahoma'    => array(
							'family' => 'Tahoma',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'times'     => array(
							'family' => '"Times New Roman", sans-serif',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'trebuchet' => array(
							'family' => 'Trebuchet',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		  'verdana'   => array(
							'family' => 'Verdana',
							'variants' => array("regular", "italic", "700"),
							'subsets' => array(),
						  ),
		);

		return $families;
	}
}

if( ! function_exists( 'boc_get_attachment_data' ) ) {
	function boc_get_attachment_data( $attachment_id ) {  
		$attachment = get_post( $attachment_id );  
		return array(  
		   'alt' => get_post_meta( $attachment->ID, '_wp_attachment_image_alt', true ),  
		   'caption' => $attachment->post_excerpt,  
		   'description' => $attachment->post_content,  
		   'href' => get_permalink( $attachment->ID ),  
		   'src' => $attachment->guid,  
		   'title' => $attachment->post_title  
		);  
	}  
}

/**
	Get available Menus and create an array to populate Meta Box in Page Settings
**/
if( ! function_exists( 'boc_get_available_menus' ) ) {
	function boc_get_available_menus() {  
		$menus = get_terms('nav_menu', array( 'hide_empty' => true ));
		$meta_menus = 	array(
							array(
								'label' => '-',
								'value' => '0'
						));
		foreach($menus as $i=>$obj_menu) {
			$meta_menus[] = array(
				'label' => $obj_menu->name,
				'value' => $obj_menu->slug
			);
		}
		
		return $meta_menus;
	}
}


/**
	Generate Side Nav (only for custom pages)
**/
if( ! function_exists( 'boc_get_side_nav' ) ) {
	function boc_get_side_nav() {  
		
		global $post;
		//$side_nav = '';
		
		if(empty($post))
			return;
		
		$post_id = $post->ID;
		// Do we have a Side Nav set for this page
		$side_nav = get_post_meta($post_id, 'boc_page_side_nav', true);
		$menu_items_arr = wp_get_nav_menu_items($side_nav);
		if($menu_items_arr && !empty($menu_items_arr)){
			
			$side_nav = '<nav id="boc_vertical-nav">
							<ul>';
							
			foreach($menu_items_arr as $i=>$menu_item_obj) {
				$side_nav .= '
				<li>
					<a href="'.$menu_item_obj->url.'" data-number="'.($i+1).'" rel="gumshoe_scroll">
						<span class="boc_dot"></span>
						<span class="boc_label">'.$menu_item_obj->title.'</span>
					</a>
				</li>';
			}
			
			$side_nav .= '
				</ul>
			</nav>';
		
		}
		//vd($menu_items );
		//vd($side_nav );
	
		return $side_nav;
	}  
}

/**
	Generate Cats list 
**/
if( ! function_exists( 'boc_get_cats' ) ) {
	function boc_get_cats_list($post_id) {  
		
		$str = '';
		$cats = get_the_category($post_id);
		foreach ($cats as $category) {
			$str .= (!$str ? $category->name : ', '.$category->name);
		}
	
		return $str;
	}  
}


function boc_post_date( $type = 'post' ) {

	// If regular date or Time ago:
	if(ot_get_option('post_date_format','1') == 1) {
		return get_the_date();
	}else{
		$d = 'comment' == $type ? 'get_comment_time' : 'get_post_time';
		return human_time_diff($d('U'), current_time('timestamp')) . " " . esc_html__('ago','alea');
	}

}


if( ! function_exists( 'boc_theme_register_required_plugins' ) ) {
	function boc_theme_register_required_plugins() {

		$plugins = array(
			array(
				'name'					=> 'WPBakery Page Builder', 
				'slug'					=> 'js_composer',
				'source'				=> get_template_directory() . '/plugins/js_composer.zip',
				'required'				=> true, 
			),
			array(
				'name'					=> 'Alea Shortcodes & Widgets',
				'slug'					=> 'boc_shortcodes_and_widgets', 
				'source'				=> get_template_directory() . '/plugins/boc_shortcodes_and_widgets.zip',
				'required'				=> true, 
			),
			array(
				'name'					=> 'Parallax & Video Backgrounds for Visual Composer',
				'slug'					=> 'parallax_video_backgrounds_vc', 
				'source'				=> get_template_directory() . '/plugins/parallax_video_backgrounds_vc.zip', 
			),
			array(
				'name'					=> 'Alea Portfolio CPT',
				'slug'					=> 'alea_portfolio_cpt',
				'source'				=> get_template_directory() . '/plugins/alea_portfolio_cpt.zip',
			),
			array(
				'name'					=> 'Revolution Slider',
				'slug'					=> 'revslider',
				'source'				=> get_template_directory() . '/plugins/revslider.zip',
			),
			array(
				'name' 		=> 'One Click Demo Import',
				'slug' 		=> 'one-click-demo-import',
			),
			array(
				'name' 		=> 'Contact Form 7',
				'slug' 		=> 'contact-form-7',
			),
			array(
				'name' 		=> 'Really Simple CAPTCHA',
				'slug' 		=> 'really-simple-captcha',
			),	

		);

		// Change this to your theme text domain, used for internationalising strings
		$theme_text_domain = 'alea';

		$config = array(
			'domain'       		=> $theme_text_domain,         	// Text domain - likely want to be the same as your theme.
			'default_path' 		=> '',                         	// Default absolute path to pre-packaged plugins
			'parent_slug' 		=> 'themes.php', 				// Default parent menu slug
			'menu'         		=> 'install-required-plugins', 	// Menu slug
			'has_notices'      	=> true,                       	// Show admin notices or not
			'is_automatic'    	=> true,					   	// Automatically activate plugins after installation or not
			'message' 			=> '',							// Message to output right before the plugins table
		);

		tgmpa( $plugins, $config );
	}
}