<?php

function aqua_customize_register($wp_customize) {

	$default_color = boc_get_default_color();
	$wp_customize->add_setting( 'boc_main_color', array(
		'default'        => $default_color,
		'transport' =>'postMessage',
		'priority'       => 1,
		'sanitize_callback' => 'esc_attr',
	));

	$wp_customize->add_setting( 'nav_bgr_color', array(
		'default'        => $default_color,
		'transport' =>'postMessage',
		'priority'       => 3,
		'sanitize_callback' => 'esc_attr',
	));
	$wp_customize->add_section( 'alea_main_color_section' , array(
		'title'      => esc_html__('Main Color','alea'),
		'priority'   => 4,
	));   
    

  $wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'boc_main_color', array(
    'label'   => 'Set Main Color (Default: '.$default_color.')',
    'section' => 'alea_main_color_section',
    'settings'   => 'boc_main_color',
	'description' => 'Pick your primary color',
	'sanitize_callback' => 'esc_attr',
    )));

  // Get it on in preview  
  if ( $wp_customize->is_preview() && ! is_admin() )
	add_action( 'customize_preview_init', 'aqua_customize_preview' );

}


function aqua_customize_preview() {
 
	$js =
	"function convertHex(hex,opacity){
        hex = hex.replace('#','');
        r = parseInt(hex.substring(0,2), 16);
        g = parseInt(hex.substring(2,4), 16);
        b = parseInt(hex.substring(4,6), 16);

        result = 'rgba('+r+','+g+','+b+','+opacity+')';
        return result;
    }

    
    ( function( $ ){
	    wp.customize('boc_main_color',function( value ) {
	    	value.bind(function(to) {
				
				
				
				
			css = '	a:hover, a:focus, '+
			'	.post_content a:not(.button),'+
			'	.post_content .post_block_post_meta a:not(.button):hover,'+
			'	.post_content .wpb_widgetised_column a:not(.button):hover,'+
			'	a:hover .boc_social_icon_style_minimal .boc_social_icon,'+
			'	.boc_social_sharing_icons a:hover span,'+
			'	.post_content .team_block h4 a:hover,'+
			'	.team_block .team_icons a:hover,'+
			'	.breadcrumb a:hover,'+
			'	h1 strong, h2 strong, h3 strong, h4 strong, h5 strong,'+
			'	.top_icon_box h3 a:hover,'+
			'	#header.transparent_header:not(.scrolled) .header_contacts span,'+
			'	.header_contacts span { '+
			'		color: '+ to +'; '+
			'	}'+
				
			'	.post_content a:not(.button):hover,'+
			'	.post_content .wpb_widgetised_column .side_bar_menu a:not(.button):hover { color: #333; }'+
				
			'	::selection { background-color: '+ to +';}'+
				
			'	.boc_preloader_icon:before { border-color: '+ to +' rgba(0,0,0,0) rgba(0,0,0,0); }'+
				
			'	a.dark_links:hover, .dark_links a:hover, .white_links a:hover, .dark_links a:hover h2, .dark_links a:hover h3 { color: '+ to +' !important; }'+
				
			'	#boc_vertical-nav .is-selected a .boc_dot { background-color: '+ to +';}'+
							
			'	.small_video_link:before { background-color: '+ to +'; }'+
			'	.small_video_link:hover:before { box-shadow: 0px 0px 0px 2px '+ to +';}'+

			'	.button:hover, a:hover.button, button:hover, input[type=\"submit\"]:hover, input[type=\"reset\"]:hover,	input[type=\"button\"]:hover, .btn_theme_color, a.btn_theme_color { color: #fff; background-color:'+ to +';}'+
			'	input.btn_theme_color, a.btn_theme_color, .btn_theme_color { color: #fff; background-color:'+ to +';}'+
			'	.btn_theme_color:hover, input.btn_theme_color:hover, a:hover.btn_theme_color { color: #fff; background-color: #333;}'+
			'	a:hover.button.btn_no_bgr { color: '+ to +'; }'+
				
			'	input.btn_theme_color.btn_outline, a.btn_theme_color.btn_outline, .btn_theme_color.btn_outline {'+
			'		color: '+ to +' !important;'+
			'		border: 2px solid '+ to +';'+
			'	}'+
			'	input.btn_theme_color.btn_outline:hover, a.btn_theme_color.btn_outline:hover, .btn_theme_color.btn_outline:hover{'+
			'		background-color: '+ to +' !important;'+
			'	}'+

			'	.htabs a.selected  { border-top: 2px solid '+ to +';}'+
			'	.buttons_boxed_style.resp-vtabs .resp-tabs-list li.resp-tab-active { border-left: 2px solid '+ to +';}'+
			'	.button_style.horizontal .resp-tabs-list li.resp-tab-active,'+
			'	.button_style.resp-vtabs .resp-tabs-list li.resp-tab-active,'+
			'	.minimal_style.resp-vtabs .resp-tabs-list li.resp-tab-active { background: '+ to +';}'+
			'	.minimal_style.horizontal .resp-tabs-list li.resp-tab-active { border-bottom: 2px solid '+ to +';}'+
				
			'	#s:focus {	border: 1px solid '+ to +';}'+

			'	.tagcloud a:hover { background-color: '+ to +';}'+
			'	.month { background-color: '+ to +';}'+
			'	.small_month  { background-color: '+ to +';}'+

			'	.post_meta a:hover,'+
			'	.post_content .post_meta a:not(.button):hover,'+
			'	a:hover .blog_icon,'+
			'	.blog_icon.liked,'+
			'	.boc_prev_next_posts div p { color: '+ to +';}'+
				
			'	.buttons_boxed_style.horizontal .resp-tabs-list li.resp-tab-active { border-top: 2px solid '+ to +';}'+
			'	.resp-vtabs li.resp-tab-active { border-left: 2px solid '+ to +'; }'+

			'	#portfolio_filter { background-color: '+ to +';}'+
			'	#portfolio_filter ul li div:hover { background-color: '+ to +';}'+
			'	.portfolio_inline_filter ul:not(.minimal_filter_style) li div:hover { background-color: '+ to +';}'+
			'	.portfolio_inline_filter ul.minimal_filter_style li div:after,'+
			'	.post_item_block.metro h4:after	{ background-color: '+ to +';}'+

			'	.counter-digit,'+
			'	.tp-caption a:hover,'+
			'	#sidebar .boc_contact_icon span,'+
			'	.more-link1:before,'+
			'	.image_featured_text .pos,'+
			'	.side_icon_box .icon_feat i.icon,'+
			'	.boc_list_item .li_icon i.icon { color: '+ to +';}'+
				
			'	.side_icon_box .icon_feat.icon_solid { background-color: '+ to +'; }'+
			'	.boc_list_item .li_icon.icon_solid { background: '+ to +'; }'+

			'	.top_icon_box.type1 .icon_holder .icon_bgr { background-color: '+ to +'; }'+
			'	.top_icon_box.type1:hover .icon_holder .icon_bgr { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type1 .icon_holder .icon_bgr:after,'+
			'	.top_icon_box.type1:hover .icon_holder .icon_bgr:after { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type1:hover .icon_holder i { color: '+ to +';}'+

			'	.top_icon_box.type2 .icon_holder .icon_bgr { background-color: '+ to +'; }'+
			'	.top_icon_box.type2:hover .icon_holder .icon_bgr { background-color: #fff; }'+
			'	.top_icon_box.type2:hover .icon_holder i { color: '+ to +';}'+

			'	.top_icon_box.type3 .icon_holder .icon_bgr:after { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type3:hover .icon_holder .icon_bgr { background-color: '+ to +'; }'+
			'	.top_icon_box.type3:hover .icon_holder .icon_bgr:after { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type3 .icon_holder i { color: '+ to +';}'+
			'	.top_icon_box.type3:hover .icon_holder i { color: #fff; }'+

			'	.top_icon_box.type4:hover .icon_holder .icon_bgr { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type4:hover .icon_holder .icon_bgr:after { border: 2px solid '+ to +'; }'+
			'	.top_icon_box.type4 .icon_holder i{ color: '+ to +'; }'+
			'	.top_icon_box.type4:hover .icon_holder i { color:  '+ to +'; }'+

			'	.top_icon_box.type5 .icon_holder i{ color: '+ to +'; }'+
				
			'	.top_icon_box.type10 .icon_holder i { color: '+ to +'; }'+
				
			'	a:hover .boc_icon {	color: '+ to +'!important;}'+
				
			'	.icon_3d .boc_sticky .back .circle,'+
			'	.boc_sticky .front .circle { background-color: '+ to +'; }'+
				
			'	a .pic_info.type11 .plus_overlay { border-bottom: 50px solid '+ convertHex(to, .8) +'; }'+
			'	a:hover .pic_info.type11 .plus_overlay { border-bottom: 1000px solid '+ convertHex(to, .8) +';}'+
				
			'	a .pic_info.type12 .img_overlay_icon,'+
			'	a:hover .pic_info.type12 .img_overlay_icon { background: '+ convertHex(to, .8) +';}'+
				
			'	h2.title strong {  color: '+ to +';}'+
			'	ul.theme_color_ul li:before { color: '+ to +'; }'+

			'	.custom_slides.nav_design_1 .cs_nav_item.active .cs_nav_icon i.icon{ color: '+ to +';}'+
			'	.custom_slides.nav_style_1.nav_design_1 .cs_nav_item:hover .cs_nav_icon i.icon,'+
			'	.custom_slides.nav_style_1.nav_design_2 .cs_nav_item:hover .cs_nav_icon i.icon { color: '+ to +';}'+
			'	.custom_slides.nav_design_2 .cs_nav_item.active .cs_nav_icon { background: '+ to +';}'+
			'	.cs_nav_item.has_no_text:hover .cs_nav_icon i.icon { color: '+ to +';}'+
			'	.custom_slides.nav_style_2 .cs_txt { color: '+ to +';}'+
				
			'	.acc_control, .active_acc .acc_control,'+
			'	.acc_holder.with_bgr .active_acc .acc_control { background-color: '+ to +';}'+

			'	.text_box.left_border {	border-left: 3px solid '+ to +'; }'+

			'	.owl-theme .owl-controls .owl-nav div:hover { color: '+ to +';}'+
			'	.owl-theme .owl-dots .owl-dot.active span { background: '+ to +';}'+

			'	.testimonial_style_big.owl-theme .owl-controls .owl-nav div:hover,'+
			'	.posts_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover, '+
			'	.img_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover,'+
			'	.content_slides_arrowed.owl-theme .owl-controls .owl-nav div:hover,'+
			'	.portfolio_carousel_holder.owl_side_arrows .owl-theme .owl-controls .owl-nav div:hover	{ color: '+ to +';}'+
				
			'	.owl-next:not(.disabled) .boc_arrow_right:hover { border-top-color: '+ to +'; border-right-color: '+ to +';}'+
			'	.owl-prev:not(.disabled) .boc_arrow_left:hover { border-bottom-color: '+ to +'; border-left-color: '+ to +';}'+
				
			'	.white_text .quote_author_description { color: '+ to +';}'+
			'	.testimonial_style_big .quote_author_description { color: '+ to +';}'+
			'	.white_text .face_nav_item.active_face img{ border: 3px solid '+ to +';}'+
				
			'	.boc_text_slider_word, .boc_text_slider_word_start { background: '+ to +'; }'+

			'	.post_item_block.boxed .pic { border-bottom: 2px solid '+ to +'; }'+

			'	.team_block .team_desc { color: '+ to +';}'+

			'	.bar_graph span, .bar_graph.thin_style span { background-color: '+ to +'; }'+

			'	.pagination .links .curr_page { background-color: '+ to +';}'+
			'	.hilite:before,.hilite:after { background: '+ convertHex(to, .2) +';}'+
			'	.price_column.price_column_featured ul li.price_column_title{ background: '+ to +';}'+

			'	blockquote{ border-left: 3px solid '+ to +'; }'+
			'	.text_box.left_border { border-left: 3px solid '+ to +'; }'+

			'	.alea_table tr:hover td { background: '+ convertHex(to, .08) +';}'+
				
			'	a .img_overlay.theme_color { background: '+ convertHex(to, .85) +'; } '+
				
			'	.header_cart ul.cart_list li a, .header_cart ul.product_list_widget li a { color: '+ to +';}'+
			'	.header_cart .cart-notification { background-color: '+ to +';}'+
			'	.header_cart .cart-notification:after { border-bottom-color: '+ to +';}'+
				
			'	.info h2{ background-color: '+ to +';}'+
			'	#footer a:hover { color: '+ to +';}'+
				

			'	a .pic_info.type1 .plus_overlay {	border-bottom: 50px solid '+ convertHex(to, .8) +';}'+
			'	a:hover .pic_info.type1 .plus_overlay { border-bottom: 1000px solid '+ convertHex(to, .8) +'; }'+
				
			'	a .pic_info.type2 .img_overlay_icon,'+
			'	a:hover .pic_info.type2 .img_overlay_icon {	background: '+ convertHex(to, .8) +'; }'+
				
			'	a .pic_info.type3  .img_overlay_icon,'+
			'	a:hover .pic_info.type3 .img_overlay_icon {	background: '+ convertHex(to, .8) +';}'+
			'	a .pic_info.type3 .info_overlay { border-top: 2px solid '+ to +'; }'+
				
			'	a .pic_info.type4 .img_overlay_icon { border-bottom: 3px solid '+ convertHex(to, .9) +';}'+
			'	a .pic_info.type4 .img_overlay_icon .portfolio_icon { background-color: '+ convertHex(to, .8) +'; }'+
				
			'	a:hover .pic_info.type5 .info_overlay {	background: '+ to +';}'+
			'	a .pic_info.type5 .info_overlay { border-top: 2px solid '+ to +'; }'+
				
			'	.pic_info.type6 .info_overlay {	background: '+ to +';}'+
			'	a .pic_info.type6 .plus_overlay { border-bottom: 50px solid '+ to +'; }	'+

			'	.pic_info.type7 .info_overlay { background-color: '+ convertHex(to, .9) +'; } '+
			'	.pic_info.type8 .info_overlay h3:after { border-top: 2px solid '+ to +'; }'+

			'	.cd-headline.loading-bar .cd-words-wrapper::after { background: '+ to +';}'+
			'	.cd-headline.type .cd-words-wrapper.selected { background-color: '+ to +';}'+
				
			'	@media only screen and (max-width: 768px) {'+
			'		.cs_nav .cs_nav_item.active { background: '+ to +' !important;}'+
			'	}';
			
				style = document.createElement('style');
				style.type = 'text/css';
				style.appendChild(document.createTextNode(css));
				
	    		$('#footer').append(style);
				
		 	
	    	});
	    });
    

	} )( jQuery )";
	
	wp_register_script( 'boc_customizer_inline_script', false, array(), null, true);
	wp_enqueue_script( 'boc_customizer_inline_script');
	wp_add_inline_script( 'boc_customizer_inline_script', $js );
	
}