(function( $ ) {
	'use strict';
	$(document).on('click', '.boc_like_button', function() {
		var button = $(this);
		var post_id = button.attr('data-post-id');
		var security = button.attr('data-nonce');
		var iscomment = button.attr('data-iscomment');
		var allbuttons;
		if ( iscomment === '1' ) { 
			allbuttons = $('.sl-comment-button-'+post_id);
		} else {
			allbuttons = $('.boc_like_button-'+post_id);
		}

		if (post_id !== '') {
			$.ajax({
				type: 'POST',
				url: simpleLikes.ajaxurl,
				data : {
					action : 'process_simple_like',
					post_id : post_id,
					nonce : security,
					is_comment : iscomment,
				},
				beforeSend:function(){
					button.addClass('pressed');
					button.animate({opacity: "0"},'700', "easeOutCubic");
				},	
				success: function(response){
					var icon = response.icon;
					//alert(icon);
					var count = response.count;
					allbuttons.html(icon+count);
					if(response.status === 'unliked') {
						var like_text = simpleLikes.like;
						allbuttons.prop('title', like_text);
						allbuttons.removeClass('liked');
					} else {
						var unlike_text = simpleLikes.unlike;
						allbuttons.prop('title', unlike_text);
						allbuttons.addClass('liked');
					}
					button.removeClass('pressed');
					button.animate({opacity: "1"},'500');			
				}
			});
			
		}
		return false;
	});
})( jQuery );
