<?php get_header(); ?>



<!-- Post -->
<div <?php post_class('single_post'); ?> id="post-<?php the_ID(); ?>" >

<?php
	// Set appropriate template

	// From Theme Options
	$template_ot = ot_get_option('blog_post_format','regular');

	// From Editing the post
	$template_setting = get_post_meta(get_the_ID(), "boc_posts_template_select_option", true);

	// Which one to use
	$template_to_use = ($template_setting!='default')? ($template_setting ? $template_setting : 'regular') : $template_ot;

	// FULL WIDTH TEMPLATE
	if($template_to_use == 'full'){
		
		$attachment_image = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), 'full');

		$js =
			"
			jQuery(document).ready(function() {
				'use strict';
				function full_width_feature(){
					var scr_to_top = jQuery(document).scrollTop();

					//  Zoom
					jQuery('.full_width_feature .full_bgr_img').css('background-size', 100 + parseInt(scr_to_top / 20, 0) + '% ');

					jQuery('.full_width_feature .full_bgr_img').css('opacity', 1 - (scr_to_top / 500));

					jQuery('.full_width_feature .container').css('transform', 'translateY(' + (-50 + parseInt(scr_to_top / 2, 0)) + '%)');
					if(scr_to_top > 220){
						jQuery('.full_width_feature .container').addClass('faded');
					}else {
						jQuery('.full_width_feature .container').removeClass('faded');		  
					}
				}
				if(!boc_is_mobile){
					jQuery(document).ready(function($){
						full_width_feature();
						$(window).scroll(function(e) {
							full_width_feature();
						});
					});
				}
			});";
			
		wp_register_script( 'boc_single_inline_script', false, array('alea-common'));
		wp_enqueue_script('boc_single_inline_script');
		wp_add_inline_script( 'boc_single_inline_script', $js );
	?>
	
	<div class="full_width_feature post_content">		

		<div class="full_bgr_img" style="background-image: url(<?php echo esc_url($attachment_image[0]); ?>);"></div>
	
		<div class="container">
			<div class="section">
				<div class="post_details">
					<h1 class="entry-title"><?php echo esc_html(the_title('')); ?></h1>
					
					<?php // Breadcrumbs
						$blog_post_full_display_below_title = ot_get_option('blog_post_full_display_below_title','2');
						if($blog_post_full_display_below_title == 1){ ?>
						
							<div class="breadcrumb_centered white_text">
								<?php boc_breadcrumbs();?>
							</div>
					
					<?php // Meta
						}elseif($blog_post_full_display_below_title == 2){
							$id = $post->ID;
							$show_author 	= (ot_get_option('blog_post_meta_author', 'on') == 'on');
							$show_date 		= (ot_get_option('blog_post_meta_date', 'on') == 'on');
							$show_cats 		= ((ot_get_option('blog_post_meta_cats', 'on') == 'on') && has_category());
							$show_tags 		= ((ot_get_option('blog_post_meta_tags', 'on') == 'on') && has_tag());
							$show_comments 	= (ot_get_option('blog_post_meta_comments', 'on') == 'on');
							$show_like_button = (ot_get_option('blog_post_meta_like', 'on') == 'on');

						?>
							
						<div class="post_meta clearfix white_links">
						
						<?php if($show_author) { ?>	
								<span><a href="<?php echo get_author_posts_url($post->post_author);?>"><span class="post_author"><?php echo get_avatar(get_the_author_meta("user_email", $post->post_author), "24").' '.esc_html__('by','alea').' '.get_the_author_meta("nickname", $post->post_author);?></span></a></span>
						<?php } ?>
							
						<?php if($show_date) { ?>	
							<span class="post_date"><span class="blog_icon boc_i-clock-outline"></span><?php echo boc_post_date();?></span>
						<?php } ?>	
						
						<?php if($show_cats) { ?>	
							<span class="post_cats"><?php echo esc_html__('in','alea').'&nbsp; '; the_category(', '); ?></span>
						<?php } ?>
						
						<?php if($show_tags) { ?>	
							<span class="tags"><span class="blog_icon boc_i-tag-outline"></span> <?php the_tags('',', '); ?></span>
						<?php } ?>	
						
						<?php if($show_comments) { ?>	
							<span class="post_comments"><a href="<?php comments_link();?>" rel="smooth_scroll"><span class="blog_icon blog_icon boc_i-comment-bubble"></span><?php echo (int)$wp_query->post->comment_count;?></a></span>
						<?php } ?>	
						
						<?php if($show_like_button) {	
							echo (((ot_get_option('posts_like_functionality','on')=='on')&& function_exists( 'get_simple_likes_button' )) ? get_simple_likes_button( $id ) : '');
							} ?>			
							
						</div>

					<?php
						}
					?>

				</div>
			</div>	
		</div>	
			
	</div>

<?php	
	}

	// Check Sidebar Layout
	$sidebar_layout = boc_single_post_sidebar_layout();
?>

	<div class="container <?php echo 'template_'.$template_to_use;?> <?php echo 'layout_'.$sidebar_layout;?>">
		<div class="section">
			<?php 

			// IF Sidebar Left
			if($sidebar_layout == 'left-sidebar'){
				get_sidebar();
			}

			if($sidebar_layout != 'full-width'){
				echo "<div class='post_content col span_3_of_4'>";
			}else {
				echo "<div class='post_content no_sidebar'>";
			}
			?>


			<?php while (have_posts()) : the_post(); ?>
				
					<div class="section">

			<?php 
				// REGULAR TEMPLATE
				if(($template_to_use == 'regular') || ($template_to_use == 'side')){
						
					// Image thumb to use (from TO)
					$thumb_to_use = (ot_get_option('blog_post_full_img_height', 'on')=="on") ? "full" : "boc_thin";
						
					// IF Post type is Standard (false) 	
					if(function_exists( 'get_post_format' ) && get_post_format( $post->ID ) != 'gallery' && get_post_format( $post->ID ) != 'video' && has_post_thumbnail()) { 
							
							$attachment_image = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), $thumb_to_use);
							$att_full_img_link = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), 'full');
							$att_img_alt = get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true);
			?>
							<div class="pic mb30">
								<a href="<?php echo esc_url($att_full_img_link[0]);?>" class="mfp_popup" title="<?php echo esc_attr($post->post_title); ?>">
									<img src="<?php echo esc_url($attachment_image[0]); ?>" alt="<?php echo esc_attr($att_img_alt);?>"/><div class="img_overlay"><span class="icon_zoom"></span></div>
								</a>
							</div>
			
			<?php } // IF Post type is Standard :: END ?>
			
		
			<?php 	// IF Post type is Gallery
					if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'gallery' )) {
						
						$images = get_post_meta($post->ID, "gallery", true);

						if($images){

							$images_arr = explode( ',', $images);

							$str = "<div id='img_slider_single_template' class='img_slider mfp_gallery big_arrows opacity_0'>";
							foreach ( $images_arr as $img_id ){

								// Attachment VARS
								$att_img_link = wp_get_attachment_image_src( $img_id, $thumb_to_use);
								$att_full_img_link = wp_get_attachment_image_src( $img_id, 'full');
								$att_img_title = get_the_title($img_id);
								$att_img_alt = get_post_meta($img_id, '_wp_attachment_image_alt', true);

								$str .= '<div class="pic">
											<a href="'. esc_url($att_full_img_link[0]) .'" class="mfp_popup_gal" title="'. esc_attr($att_img_title) .'">
												<img src="'. esc_url($att_img_link[0]) .'" alt="'. esc_attr($att_img_alt) .'" class="boc_owl_lazy"/>
												<div class="img_overlay"><span class="hover_icon icon_zoom no_border"></span></div>
											</a>
										</div>';

							}
							$str .= '</div>';

							echo wp_kses_post($str);
							
							$js =
								"jQuery(document).ready(function($) {
									
									'use strict';
									boc_preloadImages($('#img_slider_single_template img'), function () {
										$('#img_slider_single_template').owlCarousel({
											items: 				1,
											lazyLoad:			true,
											nav: 				true,
											dots:				false,
											autoHeight: 			true,
											smartSpeed:			600,
											navText:			
											['<span class=\"icon boc_i-angle-left\"></span>','<span class=\"icon boc_i-angle-right\"></span>'],
											slideBy: 			1,
											rtl: 				".(is_rtl() ? 'true' : 'false').",
											navRewind: 			false,
											onInitialized: 		bocShowPostCarousel						
										});
									});
									
								});
								
								function bocShowPostCarousel() {
									jQuery('#img_slider_single_template').fadeTo(0,1);
									jQuery('#img_slider_single_template .owl-item .boc_owl_lazy').css('opacity','1');
								}";
							
							wp_register_script('boc_single_inline_script', false, array('alea-common'));
							wp_enqueue_script('boc_single_inline_script');
							wp_add_inline_script('boc_single_inline_script', $js);
						?>
						<!-- Image Slider :: END -->


					<?php } // If Images :: END ?> 

				<?php } // IF Post type is Gallery :: END ?>
			
			
			
				<?php	// IF Post type is Video 
						if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'video')  ) {				

							if($video_embed_code = get_post_meta($post->ID, 'video_embed_code', true)) {
								echo "<div class='video_max_scale'>";
								echo wp_kses($video_embed_code, boc_expand_allowed_tags());
								echo "</div>";
							}										
						} // IF Post type is Video :: END 
				?>
		
			
			
				<?php	// Meta Data
				
						$id = $post->ID;
						$show_author 	= (ot_get_option('blog_post_meta_author', 'on') == 'on');
						$show_date 		= (ot_get_option('blog_post_meta_date', 'on') == 'on');
						$show_cats 		= ((ot_get_option('blog_post_meta_cats', 'on') == 'on') && has_category());
						$show_tags 		= ((ot_get_option('blog_post_meta_tags', 'on') == 'on') && has_tag());
						$show_comments 	= (ot_get_option('blog_post_meta_comments', 'on') == 'on');
						$show_like_button = (ot_get_option('blog_post_meta_like', 'on') == 'on');				
				?>
				
				
						<div class="post_meta clearfix">
						
						<?php if($show_author) { ?>	
								<span><a href="<?php echo get_author_posts_url($post->post_author);?>"><span class="post_author"><?php echo get_avatar(get_the_author_meta("user_email", $post->post_author), ($template_to_use=='side')? "60" :"24").' '.esc_html__('by','alea').' '.get_the_author_meta("nickname", $post->post_author);?></span></a></span>
						<?php } ?>							
							
						<?php if($show_date) { ?>	
							<span class="post_date"><span class="blog_icon boc_i-clock-outline"></span><?php echo boc_post_date();?></span>
						<?php } ?>	
						
						<?php if($show_cats) { ?>	
							<span class="post_cats"><?php echo esc_html__('in','alea').'&nbsp; '; the_category(', '); ?></span>
						<?php } ?>
						
						<?php if($show_tags) { ?>	
							<span class="tags"><span class="blog_icon boc_i-tag-outline"></span> <?php the_tags('',', '); ?></span>
						<?php } ?>	
						
						<?php if($show_comments) { ?>	
							<span class="post_comments"><a href="<?php comments_link();?>" rel="smooth_scroll"><span class="blog_icon blog_icon boc_i-comment-bubble"></span><?php echo (int)$wp_query->post->comment_count;?></a>
							<?php echo (($template_to_use!='side')? "</span>" :"&nbsp; &nbsp; ");?>
						<?php } ?>	
						
						<?php if($show_like_button) {	
							echo (((ot_get_option('posts_like_functionality','on')=='on')&& function_exists( 'get_simple_likes_button' )) ? get_simple_likes_button( $id ) : '');
							echo (($template_to_use=='side')? "</span>" :"");
							} ?>			
							
						</div>
					
			<?php
			} // REGULAR TEMPLATE : END ?>

			
						<div class="post_description single_<?php echo esc_attr($template_to_use); ?>">
						<?php the_content(); ?>
						</div>
					
					
						<!-- Post End -->

			
			</div>

			
		<?php if('on' === ot_get_option('prev_next_posts','on')){ ?>
				
				<!-- Prev Next Posts -->
				<nav class="boc_prev_next_posts">
				<?php // Get previous post

					$prev_post = get_previous_post(); 

					if ( ! empty( $prev_post ) ){ ?>
					
						<a class="prev" href="<?php echo get_permalink( $prev_post->ID ); ?>">
							<span class="icon-wrap"><i class="boc_prev_next_arrow boc_i-arrow-pointing-to-left"></i></span>
							<div <?php echo has_post_thumbnail($prev_post->ID) ? 'class="with_feat_img"' : '';?>>
								<span><?php esc_html_e('Previous Post','alea');?></span>
								<h3><?php echo esc_html($prev_post->post_title); ?></h3>
								<?php echo get_the_post_thumbnail( $prev_post->ID, 'boc_thumb' );?>
								<p class="prev_next_cats"><?php echo boc_get_cats_list($prev_post->ID); ?></p>
							</div>
						</a>
					
				<?php } ?>

				<?php // Get next post
				
					// TODO
					$prev_post_link = get_next_posts_link();
					$next_post = get_next_post(); 

					if ( ! empty( $next_post ) ){ ?>
					
						
						<a class="next" href="<?php echo get_permalink( $next_post->ID ); ?>">
							<span class="icon-wrap"><i class="boc_prev_next_arrow boc_i-arrow-pointing-to-right"></i></span>
							<div <?php echo has_post_thumbnail($next_post->ID) ? 'class="with_feat_img"' : '';?>>
								<span><?php esc_html_e('Next Post','alea');?></span>
								<h3><?php echo esc_html($next_post->post_title); ?></h3>
								<?php echo get_the_post_thumbnail( $next_post->ID, 'boc_thumb' );?>
								<p class="prev_next_cats"><?php echo boc_get_cats_list($next_post->ID); ?></p>
							</div>
						</a>
					
				<?php } ?>
				</nav>
				<!-- Prev Next Posts::END -->
				
		<?php } ?>	
			
			
			<?php 	wp_link_pages( array(
					 'before'      => '<div class="post_pages"><span class="post_pages_title">' . esc_html__( 'Pages:', 'alea' ) . '</span>',
					 'after'       => '</div>',
					 'link_before' => '<span class="num">',
					 'link_after'  => '</span>',
					));
			?>

			<?php endwhile; // Loop End  ?>

			
			<?php comments_template('', true); ?>

			
			<?php 
			// Close "post_content"
			echo "</div>";


			// IF Sidebar Right
			if($sidebar_layout == 'right-sidebar'){
				get_sidebar();
			}
			?>
		</div>
	</div>
</div>
<!-- Post :: END -->	  

	
<?php get_footer(); ?>	