<?php
// Element that imitates the blog listing

// Register Shortcode
if( ! function_exists( 'boc_blog_list' ) ) {
	function boc_blog_list($atts, $content = null) {

		global $post;
		global $paged;
		
		// Query posts
		$wp_query = new WP_Query(
			array(
				'post_type'			=> 'post',
				'paged'				=> $paged,
			)
		);

		$output = '';
		
		// Loop Posts
		if( $wp_query->have_posts() ) { 
		
			foreach( $wp_query->posts as $post ){
				setup_postdata( $post );
				ob_start();
				get_template_part( 'templates/loop-post' );
				$output .= ob_get_contents();
				ob_end_clean();
			}
			
		}
		
		// Custom Pagination
		$GLOBALS['wp_query']->max_num_pages = $wp_query->max_num_pages;
		$output .= boc_pagination($pages = '', $range = 4, false);

		// Reset the custom query data
		wp_reset_postdata(); wp_reset_query();
		
		return $output;
	}
	
	add_shortcode('boc_blog_list', 'boc_blog_list');
} 


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Post Blog List", 'boc-shortcodes-and-widgets'),
	"base" =>  "boc_blog_list",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_blog_list",
	"weight"	=> 39,
	"params" => array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),			
	)
));
?>