<?php

/**
	Button Shortcode - part of the Theme Base -> shortcodes.php
**/



// Map Shortcode in Visual Composer
	

vc_map( array(
	"name" 		=> esc_html__("Button", 'boc-shortcodes-and-widgets'),
	"description" => esc_html__("A custom button", 'boc-shortcodes-and-widgets'),
	"base" 		=> "boc_button",
	"class" 	=> "boc_button",
	"icon" 		=> "boc_button",
	"category" 	=> "Alea Shortcodes",
	"weight"	=> 74,
	"params" 	=> array(
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Text", 'boc-shortcodes-and-widgets'),
			 "param_name" => "btn_content",
			 "value" => "Button Text",
			 "admin_label"	=> true,
			 "description" => esc_html__("Enter the text for your Button", 'boc-shortcodes-and-widgets'),
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("URL Link", 'boc-shortcodes-and-widgets'),
			 "param_name" => "href",
			 "admin_label"	=> true,
			 "value" => "",
			 "description" => esc_html__("Enter the link you want your button to take you to once clicked.", 'boc-shortcodes-and-widgets'),
		),
		array(
			 "type" => "dropdown",
			 "heading" => esc_html__("Target", 'boc-shortcodes-and-widgets'),
			 "param_name" => "target",
			 "value" => array('_self','_blank'),
			 "description" => esc_html__("Pick '_blank' if you want the button link to open in a new tab.", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Bottom Unroll", "boc-shortcodes-and-widgets")			=> "bottom-unroll",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			 "param_name" => "delay",
			 "value" => "",
			 "description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			 "edit_field_class" =>"vc_col-sm-6",
			 "dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			 "param_name" => "css_classes",
			 "value" => "",
			 "description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Smooth scroll for 'Same page' link?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "smooth_scroll",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Activate smooth scrolling for link if it points to current page", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> "Button Size",
			"param_name"		=> "size",
			"value"			=> array(
				"Small" => "btn_small",
				"Medium"=> "btn_medium",
				"Large" => "btn_large",
				"Huge"  => "btn_huge",
				"Stretched Small" => "btn_small_stretched",
				"Stretched Medium"=> "btn_medium_stretched",
				"Stretched Large" => "btn_large_stretched",
				"Stretched Huge"  => "btn_huge_stretched",
			),
			"std"		=> "btn_medium",
			"description"	=> "Select a size",
			'group'		=> 'Button Design',
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> "Button Color",
			"param_name"		=> "color",
			"admin_label"	=> true,
			"value"			=> array(
				"Theme Color"	=> "btn_theme_color",
				"Dark" 			=> "btn_dark",
				"White" 		=> "btn_white",
				"Blue" 			=> "btn_blue",
				"Bondi Blue"	=> "btn_bondi",
				"Royal Blue"	=> "btn_royalblue",
				"Turquoise" 	=> "btn_turquoise",
				"Azure"			=> "btn_azure",
				"Green" 		=> "btn_green",
				"Lime Green"	=> "btn_limegreen",
				"Emerald" 		=> "btn_emerald",
				"Jade"	 		=> "btn_jade",
				"Orange"		=> "btn_orange",
				"Yellow"		=> "btn_yellow",
				"Purple"		=> "btn_purple",
				"Plum"		=> "btn_plum",
				"Magenta"	=> "btn_magenta",
				"Red"		=> "btn_red",
				"Apple"		=> "btn_apple",
				"Pink"		=> "btn_pink",
				"Brown"		=> "btn_brown",
				"Simple Link"	=> "btn_no_bgr",
				"Simple Link White"	=> "btn_no_bgr_white",
			),
			"description"	=> "Select a button color. They are predefined for a number of reasons, like text color, hover effects etc. Use the CSS class option to define your own.",
			'group'			=> 'Button Design',
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> "Button Style",
			"param_name"	=> "btn_style",
			"value"		=> array(
				"Normal" 	=> "btn_normal_style", // Default
				"Gradient" 	=> "btn_gradient",
				"Outline" 	=> "btn_outline",
				"3D"	 		=> "btn_3d",
			),
			"description"	=> "Select a style",
			'group'		=> 'Button Design',
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> "Border Radius",
			"param_name"	=> "border_radius",
			"value"		=> array(
				"Rounded" => "btn_rounded",
				"Squared" => "btn_squared",
				"Oval" => "btn_circled",
			),
			"description"	=> "Select a border radius style",
			'group'			=> 'Button Design',
		),
        array(
			"type"          => "iconpicker",
			"heading"       => "Add Button Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" 		=> array(
				'type'      => 'alea',
				'emptyIcon' => true, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets' ),
			"group"         => esc_html__( 'Button Icon', 'boc-shortcodes-and-widgets' ),
		),
		array(
			 "type" 		=> "dropdown",
			 "heading" 		=> "Icon Position",
			 "param_name" 	=> "icon_pos",
			 "value"		=> array(
				"Before Text" 	=> "icon_pos_before",
				"After Text" 	=> "icon_pos_after",
			 ),
			 "description" 	=> "Choose a position for the icon",
			 'group'		=> 'Button Icon',
			 "dependency"	=> Array(
				'element'	=> "icon",
				'not_empty'	=> true,
				)
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> "Icon Effect",
			"param_name"	=> "icon_effect",
			"value"			=> array(
				"None" 		=> "none",
				"Animate In" 	=> "btn_icon_anim_in",
				"Animate Out" 	=> "btn_icon_anim_out",
			),
			"description"	=> "Select an Icon Animate Effect if you want one",
			"group"			=> 'Button Icon',
			"dependency"	=> Array(
				'element'	=> "icon",
				'not_empty'	=> true,
			)
		)
	)
));