<?php
/**
	Custom Slider
**/

// Register Shortcodes

// Custom Slider
if( ! function_exists( 'shortcode_boc_custom_slider' ) ) {
	function shortcode_boc_custom_slider($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_custom_slider', $atts );
		extract( $atts );

		if(!$content) return;
		
		// Animation Type
		if ($animation == 'Slide') {
			$anim_type_code = "animateOut: false,	animateIn: false";
		} elseif ($animation == 'Fade') {
			$anim_type_code = 'animateOut:"fadeOut",	animateIn: "fadeIn"';
		} elseif ($animation == 'Bottom-Top') {
			$anim_type_code = 'animateOut:"fadeOutDown",	animateIn: "fadeInUp"';
		} elseif ($animation == 'Flip') {
			$anim_type_code = 'animateOut:"fadeOutDown",	animateIn: "flipInX"';
		}

		// Nav position
		$is_nav_top = true;
		if($nav_position != "Top") {
			$is_nav_top = false;
		}
		
		// generate rand ID
		$slider_id = rand(1,10000);

		$str = '<div class="custom_slides '.($is_nav_top ? "custom_slides_top_nav" : "custom_slides_bottom_nav").' nav_design_'.esc_attr($nav_design).' nav_style_'.esc_attr($nav_style).'" id="custom_slides_'.$slider_id.'">';
		$str .= do_shortcode($content);
		$str .= '</div>';


			
		$css = '#custom_slides_'.$slider_id.'.owl-carousel .animated {-webkit-animation-duration: '.(int)$speed.'ms;animation-duration: '.(int)$speed.'ms;}';

		wp_enqueue_style( 'boc_shortcodes_style' );
		wp_add_inline_style( 'boc_shortcodes_style', $css );
		
		
		$js = '
			/* Custom Icon Slider :: START */
			jQuery(document).ready(function($) {								

				var slider_el = $("#custom_slides_'.$slider_id.'");
				var active_class = " active '.($bouncy_icon ? "bouncy_icon" : "").'";
				// Create Custom Icons Nav
				slider_el.on("initialized.owl.carousel", function(e) {

'.($is_nav_top ? 'slider_el.prepend("<div class=\"section\"><div class=\"cs_nav\"></div></div>");' :
				 'slider_el.append("<div class=\"section\"><div class=\"cs_nav\"></div></div>");').'						

					slider_el.find(".custom_slide_item").each( function(i, el) {
						if(!$(this).parent(".owl-item").hasClass("cloned")){
							var icon = $(this).data("icon");
							var has_text = $(this).data("has_text");
							var txt = $(this).data("txt");
							var sub_txt = $(this).data("sub_txt");
							var nav_item_class = (has_text!="") ? "has_text" : "has_no_text";

							if(i==0){
								nav_item_class += active_class;
							}
							var icon_btn_html = "<div class=\"col span_1_of_6 cs_nav_item "+ nav_item_class +"\"><div class=\"cs_nav_icon\"><i class=\"" + icon + "\"></i></div>";

							if(has_text!="") {
							'.(($nav_style==2) 	? 'icon_btn_html += "<div class=\"cs_sub_txt\">" + sub_txt + "</div><h4 class=\"cs_txt\">" + txt + "</h4>";'
												: 'icon_btn_html += "<h4 class=\"cs_txt\">" + txt + "</h4><div class=\"cs_sub_txt\">" + sub_txt + "</div>";').'
							}

							icon_btn_html += "</div>";

							slider_el.find(".section .cs_nav").append(icon_btn_html);
						}
					});
				});

				slider_el.owlCarousel({
						items: 				1,
						autoHeight: 		'.($auto_height	? "true" : "false").',
						smartSpeed:			'.(int)$speed.',
						dots:				true,
						slideBy: 			1,
						navRewind: 			false,
						rtl: 				' . (is_rtl() ? 'true' : 'false') . ',
						'.(($animation != "Slide") ? " mouseDrag:			false," : "").'	
						
						'.$anim_type_code.',
						responsive:{
							0:{
								animateOut: "fadeOut",	animateIn: "fadeIn",
							},
							769:{
								'.$anim_type_code.',
							}
						},
						onInitialized:  showIconSlider_'.$slider_id.'
				});

				// Attach events to Custom Icons Nav
				slider_el.find(".cs_nav_item").each( function(i, el) {
					$(this).on("click",function(){
						slider_el.find(".cs_nav_item").removeClass(active_class);
						$(this).addClass(active_class);
						slider_el.trigger("to.owl.carousel", i);
					});
				});
				
				// Call back to set Active Icon Nav 
				slider_el.on("changed.owl.carousel",function(e) {
					slider_el.find(".cs_nav_item").each( function(i, el) {
						if(i == e.item.index) {
							slider_el.find(".cs_nav_item").removeClass(active_class);
							$(this).addClass(active_class);
						}
					});
				});
				
				/* Show after initialized */
				function showIconSlider_'.$slider_id.'() {
					$("#custom_slides_'.$slider_id.'").fadeTo(0,1);
					$("#custom_slides_'.$slider_id.' .owl-item .boc_owl_lazy").css("opacity","1");
				}
			});
			/* Custom Icon Slider :: END */';

		wp_enqueue_script( 'boc_shortcodes_script');
		wp_add_inline_script( 'boc_shortcodes_script', $js );

		return $str;		
	}
	
	add_shortcode('boc_custom_slider', 'shortcode_boc_custom_slider');
}	
		
// Custom Slide Item
if( ! function_exists( 'shortcode_boc_custom_slider_item' ) ) {
	function shortcode_boc_custom_slider_item($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_custom_slider_item', $atts );
		extract( $atts );	

		$str = '<div class="custom_slide_item boc_owl_lazy '.esc_attr($css_classes).'" data-icon="icon '.esc_attr($icon).'" data-has_text="'.esc_attr($has_text).'" data-txt="'.esc_attr($txt).'" data-sub_txt="'.esc_attr($sub_txt).'">';
		$str .= do_shortcode($content);
		$str .= '</div>';

		return $str;
	}
	
	add_shortcode('boc_custom_slider_item', 'shortcode_boc_custom_slider_item');
}	
	
// Map Shortcodes in Visual Composer
vc_map( array(
	"name" 		=> esc_html__("Icon Slider", 'boc-shortcodes-and-widgets'),
	"base" 		=> "boc_custom_slider",
	"as_parent" => array('only' => 'boc_custom_slider_item'), //limit child shortcodes
	"content_element" => true,
	"icon" 		=> "boc_custom_slider",
	"category" 	=> "Alea Shortcodes",
	"show_settings_on_create" => true,
	"js_view" 	=> 'VcColumnView',
	"weight"  	=> 26,
	"params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Type", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "animation",
			"value" 		=> array('Slide','Fade','Bottom-Top','Flip'),
			"std"			=> "Slide",
			"description" 	=> esc_html__("Set your Animation type", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Navigation position", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "nav_position",
			"value" 		=> array('Top','Bottom'),
			"std"			=> "Top",
			"description" 	=> esc_html__("Do you want the navigation above or below the slides", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Navigation Style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "nav_style",
			"value"			=> array(
				esc_html__("Icon + Text Below", "boc-shortcodes-and-widgets")		=> '1',
				esc_html__("Icon + Text on Hover", "boc-shortcodes-and-widgets")	=> '2'
			),
			"std"			=> '1'
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Navigation Design", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "nav_design",
			"value"			=> array(
				esc_html__("Simple Icons", "boc-shortcodes-and-widgets")		=> '1',
				esc_html__("Round Icons", "boc-shortcodes-and-widgets")		=> '2'			
			),
			"std"			=> '1'
		),		
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Speed", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "speed",
			"value" 		=> array('250','500','750','1000'),
			"std"			=> "500",
			"description" 	=> esc_html__("Set the length of the Slider Animation (miliseconds)", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Enable AutoHeight", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "auto_height",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes for an AutoHeight slider - it will resize according to the item heights in sight", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Bouncing on Active Icon", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "bouncy_icon",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the Active Icon to Bounce", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));

vc_map( array(
	"name" => esc_html__("Custom Slider Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_custom_slider_item",
	"icon" 		=> "boc_custom_slider",
	"as_child" => array('only' => 'boc_custom_slider'),
	"as_parent" => array('except' => 'boc_custom_slider,boc_custom_slider_item,boc_content_slider,boc_content_slider_item,boc_img_carousel,boc_img_slider,boc_portfolio_carousel,boc_posts_carousel,boc_testimonials,boc_testimonial,boc_accordion'),
	"content_element" => true,
	"js_view" => 'VcColumnView',
	"params" => array(

		array(
			"type"          => "iconpicker",
			"heading"       => "Button Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select Navigation icon from library.', 'boc-shortcodes-and-widgets' ),
			"group"         => esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),

		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Has Text?", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "has_text",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want animated text to appear on Icon Hover", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Button Sub-Text", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "sub_txt",
			"description" 	=> esc_html__("Set your Navigation Item Sub-Text", 'boc-shortcodes-and-widgets'),
			"value" 		=> "",
			"dependency"	=> Array(
					'element'	=> "has_text",
					'not_empty'	=> true,
			),			
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Button Text", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "txt",
			"value" 		=> "Our Company",
			"description" 	=> esc_html__("Set your Navigation Item Text", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "has_text",
					'not_empty'	=> true,
			),				
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),		
	)
));

if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_custom_slider extends WPBakeryShortCodesContainer {
	}
}
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_boc_custom_slider_item extends WPBakeryShortCodesContainer {
	}
}
