<?php

/**
	Icon Shortcode - part of the Theme Base -> shortcodes.php
**/



// Map Shortcode in Visual Composer
vc_map( array(
	"name"		=> esc_html__("Icon", 'boc-shortcodes-and-widgets'),
	"description" => esc_html__("A custom icon", 'boc-shortcodes-and-widgets'),
	"base"		=> "boc_icon",
	"icon"		=> "boc_icon",
	"category" 	=> "Alea Shortcodes",
	"weight"	=> 72,
	"params"	=> array(
		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' 		=> 'alea',
				'emptyIcon' => false, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description' 	=> esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets' ),
		),
		array(
			"type"			=> "dropdown",
			"class"			=> "",
			"heading"		=> esc_html__( "Icon Size", 'boc-shortcodes-and-widgets' ),
			"param_name"	=> "size",
			"description"	=> esc_html__( "Select an icon size.", 'boc-shortcodes-and-widgets' ),
			"value"			=> array(
				esc_html__( "Tiny", "boc-shortcodes-and-widgets" )		=> "tiny",
				esc_html__( "Small", "boc-shortcodes-and-widgets")		=> "small",
				esc_html__( "Normal", "boc-shortcodes-and-widgets" )		=> "normal",
				esc_html__( "Large", "boc-shortcodes-and-widgets" )		=> "large",
				esc_html__( "Larger", "boc-shortcodes-and-widgets" )		=> "larger",
				esc_html__( "Huge", "boc-shortcodes-and-widgets" )		=> "huge",
			),
			"std"			=> "normal",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> "Icon Position",
			"param_name"	=> "icon_position",
			"value"		=> array(
				"Left"		=> "left",
				"Center"	=> "center",
				"Right"		=> "right",
				"Inline"	=> "inline",
			),
			"std"			=> "left",
			"description"	=> "Select your icon position",
		),
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon Color",
			"param_name"	=> "icon_color",
			"value"		=> "#333333",
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Add Background Color?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "has_icon_bg",
			"description"	=> esc_html__("If selected, your icon will have a background color", "boc-shortcodes-and-widgets"),
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon Background",
			"param_name"	=> "icon_bg",
			"value"		=> "#ffffff",
			"dependency"	=> Array( 'element'	=> "has_icon_bg", 'not_empty' => true ),
		),
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon Background Border",
			"param_name"	=> "icon_bg_border",
			"value"			=> "#ffffff",
			"std"			=> "#ffffff",
			"dependency"	=> Array( 'element'	=> "has_icon_bg", 'not_empty' => true ),
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> "Icon Background Border Width",
			"param_name"	=> "icon_bg_border_width",
			"value"			=> array(
				'1px'	=> '1px',
				'2px'	=> '2px',
				'3px'	=> '3px',
				'4px'	=> '4px',
				'5px'	=> '5px',
			),
			"std"			=> "1px",
			"dependency"	=> Array( 'element'	=> "has_icon_bg", 'not_empty' => true ),
		),
		array(
			"type"			=> "textfield",
			"class"			=> "",
			"heading"		=> esc_html__( "Border Radius", 'boc-shortcodes-and-widgets' ),
			"param_name"		=> "border_radius",
			"value"			=> "100%",
			"description"		=> esc_html__( "Change the background border radius/roundness (px/%).", 'boc-shortcodes-and-widgets' ),
			"dependency"	=> Array( 'element'	=> "has_icon_bg", 'not_empty' => true ),
		),
		array(
			"type"		=> "textfield",
			"heading"	=> "Margin Top",
			"param_name"	=> "mar_top",
			"value"		=> "",
			"description"	=> "Add a top margin if you want one. For example (10px)",			
		),
		array(
			"type"		=> "textfield",
			"heading"	=> "Margin Bottom",
			"param_name"	=> "margin_bottom",
			"value"		=> "",
			"description"	=> "Add a bottom margin if you want one. For example (10px)",
        ),
        array(
            "type"			=> 'checkbox',
            "heading" 		=> esc_html__("Add a link to the Icon?", 'boc-shortcodes-and-widgets'),
            "param_name" 		=> "add_link",
            "value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
        ),
        array(
            "type" => "textfield",
            "heading" => esc_html__("URL Link", "boc-shortcodes-and-widgets"),
            "param_name" => "href",
            "description" => __("Enter a link if you want one. Don't forget the http:// in front.", "boc-shortcodes-and-widgets"),
            "group"		=> "Link",
            "dependency"	=> Array(
                'element'	=> "add_link",
                'not_empty'	=> true,
            )
        ),
        array(
            "type" => "dropdown",
            "heading" => esc_html__("Target", "boc-shortcodes-and-widgets"),
            "param_name" => "target",
            "value" => array('_self','_blank'),
            "description" => esc_html__("Pick '_blank' if you want the link to open in a new tab.", "boc-shortcodes-and-widgets"),
            "group"		=> "Link",
            "dependency"	=> Array(
                'element'	=> "add_link",
                'not_empty'	=> true,
            )
        ),
        array(
            "type"			=> 'checkbox',
            "heading" 		=> esc_html__("Smooth scroll for 'Same page' link?", 'boc-shortcodes-and-widgets'),
            "param_name" 		=> "smooth_scroll",
            "value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
            "description" => esc_html__("Activate smooth scrolling for link if it points to current page", "boc-shortcodes-and-widgets"),
            "group"		=> "Link",
            "dependency"	=> Array(
                'element'	=> "add_link",
                'not_empty'	=> true,
            )
        ),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			 "param_name" => "delay",
			 "value" => "",
			 "description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			 "edit_field_class" =>"vc_col-sm-6",
			 "dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));
