<?php

/**
	Logo Gallery
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_logo_gallery' ) ) {
	function shortcode_boc_logo_gallery($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_logo_gallery', $atts );
		extract( $atts );

		// Get Attachments
		$images = explode(",",$image_ids);

		// Custom Links
		if ($add_links) {
			$custom_links = explode( ',', $custom_links);
		}
		
		// CSS Animation
		$css_animation_classes = "";
		if ( $css_animation !== '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
		} 
		
		if($images){

			// Img Hover Effect
			if ($img_hover_effect){
				$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
			}

			// generate checksum of $atts array
			$gallery_id = md5(serialize($atts));
			$rtl_class = is_rtl() ? 'rtl_grid' : '';
			
			$str = '<div class="logo_gallery '.($left_border ? " left_border" : "").'">';
			$str .= '<div id="img_gallery_'.$gallery_id.'" data-columns="'.$columns.'" class="grid_holder '.$rtl_class.' '.$css_classes.' '.$spacing.'">';

			$count = 0;
			foreach ( $images as $img_id ){

				// Attachment VARS
				$att_img_url = wp_get_attachment_image_src( $img_id, ($fixed_size ? 'boc_medium' : 'full') );
				$att_img_title = get_the_title($img_id);
				$alt = get_post_meta($img_id, '_wp_attachment_image_alt', true);
				
				// Image output
				$image_output = '<img src="'. esc_url($att_img_url[0]) .'" alt="'.$alt.'"/>';
				
				// Gallery Item
				$str .= '<div class="col span_1_of_'.esc_attr($columns).' info_item isotope_element '.esc_attr($css_animation_classes).'">
							<div class="pic '.esc_attr($img_hover_effect).'">';

				if ($add_links){
					$att_img_link = !empty($custom_links[$count]) ? esc_url($custom_links[$count]) : '#';
					if ( $att_img_link == '#' ) {
						$att_img_link = "javascript:void(0)";
					}
					$str .= '
						<a href="'. $att_img_link .'" target="'. esc_attr($target) .'" '. ($show_img_title ? ' class="tooltipsy" original-title="'.esc_attr($att_img_title).'"' : '').'>
							'.$image_output.'
						</a>';
				}else {
					$str .= '
						<a href="javascript:void(0)" style="cursor: default;" '. ($show_img_title ? ' class="tooltipsy" original-title="'.esc_attr($att_img_title).'"' : '').'>
							'.$image_output.'
						</a>';
				}
				
				$str .= '</div>
					</div>';

				$count ++;
			}

			$str .= '</div></div>';

			// If we Want the fading logos on Hover
			if($fading_logos){

				$js = '
					/* Logo Gallery Fading logos :: START */
					jQuery(document).ready(function($) {
						$("#img_gallery_'.$gallery_id.' .col").on("mouseover", function() {
								$(this).siblings(".col").each(function (i, el) {
									$(["-webkit-", "-moz-", "-o-", "-ms-", ""]).each(function (i, p) {
										$(el).css(p + "transition-delay" , 0 + "ms");
									});
								});
								$(this).siblings(".col").stop().fadeTo(0, 0.3);
						}).on("mouseleave", function() {
								$(this).siblings(".col").stop().fadeTo(0, 1);
						});
					});
					/* Logo Gallery Fading logos :: END */';
					
				wp_enqueue_script( 'boc_shortcodes_script');
				wp_add_inline_script( 'boc_shortcodes_script', $js );					
				
				$custom_css = '#img_gallery_'.$gallery_id.' .col {-webkit-transition: all 0.6s ease;-moz-transition: all 0.6s ease;		-ms-transition: all 0.6s ease;-o-transition: all 0.6s ease;transition: all 0.6s ease;}';
				wp_enqueue_style( 'boc_shortcodes_style' );
				wp_add_inline_style( 'boc_shortcodes_style', $custom_css );
			}

			return $str;
		}
	}

	add_shortcode('boc_logo_gallery', 'shortcode_boc_logo_gallery');
}


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Logo Grid", 'boc-shortcodes-and-widgets'),
	"base" => "boc_logo_gallery",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_logo_gallery",
	"weight"	=> 47,
	"params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Columns", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "columns",
			"value" 		=> Array(2,3,4,5),
			"std"			=> "3",
			"description" 	=> esc_html__("How many columns you want your items displayed in.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Item Spacing", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "spacing",
			"value" 		=> array('Big Spacing'=>'big_spacing','Small Spacing'=>'small_spacing','No Spacing'=>'no_spacing'),
			"std"			=> 'small_spacing',
			"description" 	=> esc_html__("Pick a spacing between the items in the grid", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Grey Left Border", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "left_border",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Fixed Image Size", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "fixed_size",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want to use the fixed size (600x380) image preset", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_hover_effect",
			"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Grey Out"=>9),
			"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Fading Logos on Hover", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "fading_logos",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Settings",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
			"description"	=> esc_html__("Select one if you want the images to be animated once the section enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"group"			=> "Settings",
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> "attach_images",
			"admin_label"	=> true,
			"heading"		=> esc_html__("Attach Images", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "image_ids",
			"description"	=> esc_html__('Select the images you want to have in your Slider.', 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Image Title Popup on Hover", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_img_title",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Do you want the Title Attribute to appear in a Popup when image is hovered", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Links", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "add_links",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> "exploded_textarea",
			"heading"		=> esc_html__("Custom Links", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "custom_links",
			"description"	=> esc_html__('Enter links for each separate image here (starting with "http://"). Divide each link with a line-break (Enter). For images without a link enter the "#" symbol.', 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "add_links",
				'not_empty'	=> true,
			),
			"group"			=> "Gallery",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "target",
			"value" 		=> array('_self','_blank'),
			"description" 	=> esc_html__("Pick '_blank' if you want the Image link to open in a new tab.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "add_links",
				'not_empty'	=> true,
			),
			"group"			=> "Gallery",
		),		
	)
));