<?php

/**
	Side Img Featured Text
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_side_img_box' ) ) {
	function shortcode_boc_side_img_box( $atts, $content = null ) {
		
		$atts = vc_map_get_attributes('boc_side_img_box', $atts );
		extract( $atts );	

		// Adding a check for VC picture added
		$img = '';
		if($picture_url){
			$vc_image = wp_get_attachment_image($picture_url,'full');
			// If not passed via VC, we get the URL
			if($vc_image){
				$img = $vc_image;
			}else {
				$img = get_template_directory_uri().'/images/user.png';
			}
		}else {
			$img = '<img src="'.get_template_directory_uri().'/images/user.png" />';
		}	
		
		if($round_img) {
			$css_classes .= " round_img";
		}
		if($img_3d) {
			$css_classes .= " img_3d";
		}
		if($img_small) {
			$css_classes .= " img_small";
		}

		$str = '	<div class="image_featured_text '.$css_classes.'">
						'.wp_kses_post($img).'
						<div class="text">
							'.($title ? '<h3>'.do_shortcode(wp_kses_post($title)).'</h3>' : '')
							.do_shortcode($content).'</div>
						'.($author ? '
						<div class="author_position">
							<span class="auth heading_font">'.wp_kses_post($author).'</span>'. ($position ? ' / <span class="pos">'.wp_kses_post($position).'</span>' : '').'
						</div> ' : '').'
					</div>';

		$js = '
			/* Side Image Box :: START */
			jQuery(document).ready(function($) {
				if(typeof side_img_last_row_set === "undefined") {

					// Add class "last" to left_img_box section to remove borders.
					$(".section .row_img_featured_texts_border").last().addClass( "last" );
					side_img_last_row_set = true;
				}
			});
			/* Side Image Box :: END */';
			
		wp_enqueue_script( 'boc_shortcodes_script');
		wp_add_inline_script( 'boc_shortcodes_script', $js );
			
		return $str;
	}
	
	add_shortcode('boc_side_img_box', 'shortcode_boc_side_img_box');
}

// Map Shortcode in Visual Composer
vc_map( array(
   "name" => esc_html__("Side Img Box", 'boc-shortcodes-and-widgets'),
   "description" => esc_html__("Side Image Featured Text", 'boc-shortcodes-and-widgets'),
   "base" 	=> "boc_side_img_box",
   "category" => "Alea Shortcodes",
   "icon" 	=> "boc_side_img_box",
   "weight"	=> 64,
   "params" => array(
		array(
			"type" => "attach_image",
			"heading" => esc_html__("Picture", 'boc-shortcodes-and-widgets'),
			"param_name" => "picture_url",
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Heading", 'boc-shortcodes-and-widgets'),
			"param_name" => "title",
			"admin_label"=> true,
			"std" => "",
			"description" => esc_html__("Enter a Heading if you want one", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 		=> "textarea_html",
			"heading" 	=> esc_html__("Text Below Title", 'boc-shortcodes-and-widgets'),
			"param_name" => "content",
			"value" 		=> esc_html__("Featured Text", 'boc-shortcodes-and-widgets'),
			"description"=> esc_html__("Enter the Featured text", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Author", 'boc-shortcodes-and-widgets'),
			"param_name" => "author",
			"admin_label"=> true,
			"description" => esc_html__("Enter the Author Name (if any)", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" => "textfield",
			"heading" => esc_html__("Author Position", 'boc-shortcodes-and-widgets'),
			"param_name" => "position",
			"admin_label"=> true,
			"description" => esc_html__("Enter the Author Position (if any)", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Round Image?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "round_img",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Side image to be round", 'boc-shortcodes-and-widgets'),						
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("3d Image?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_3d",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Side image to have a fancy border and a slight shadow", 'boc-shortcodes-and-widgets'),							
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Small Image?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_small",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Side image to be smaller", 'boc-shortcodes-and-widgets'),						
		),		
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
   )
));