<?php

/**
	Icon Shortcode - part of the Theme Base -> shortcodes.php
**/


// Font Icon 
if( ! function_exists( 'shortcode_boc_social_sharing_icons' ) ) {
	function shortcode_boc_social_sharing_icons($atts, $content = null) {
		
			global $post;
			
			$atts = vc_map_get_attributes('boc_social_sharing_icons', $atts );
			extract( $atts );
		
			// Get current page URL 
			$current_URL = urlencode(get_permalink());
	 
			// Get current page title
			$current_Title = str_replace( ' ', '%20', get_the_title());
			
			// Get Post Thumbnail for pinterest
			$crunchifyThumbnail = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
	 
			// Construct sharing URL without using any script
			$twitterURL = 'https://twitter.com/intent/tweet?text='.$current_Title.'&amp;url='.$current_URL;
			$facebookURL = 'https://www.facebook.com/sharer/sharer.php?u='.$current_URL;
			$googleURL = 'https://plus.google.com/share?url='.$current_URL;
			$whatsappURL = 'whatsapp://send?text='.$current_Title . ' ' . $current_URL;
			$linkedInURL = 'https://www.linkedin.com/shareArticle?mini=true&url='.$current_URL.'&amp;title='.$current_Title;
	 
			// Based on popular demand added Pinterest too
			$pinterestURL = 'https://pinterest.com/pin/create/button/?url='.$current_URL.'&amp;media='.$crunchifyThumbnail[0].'&amp;description='.$current_Title;
	 
			$content = "";	 
	 
			// Add sharing button at the end of page/page content
			$content .= '<div class="boc_social_sharing_icons '.esc_attr($css_classes).'">';
			if($show_facebook)
				$content .= '<a href="'.$facebookURL.'" onclick="bocPopupCenter(this.href,660,400);return false;"><span class="fa fa-facebook"></span></a>';
			if($show_twitter)
				$content .= '<a href="'. $twitterURL .'" onclick="bocPopupCenter(this.href,660,440);return false;"><span class="fa fa-twitter"></span></a>';
			if($show_google)
				$content .= '<a href="'.$googleURL.'" onclick="bocPopupCenter(this.href,660,400);return false;"><span class="fa fa-google-plus"></span></a>';
			if($show_linkedin)			
				$content .= '<a href="'.$linkedInURL.'" onclick="bocPopupCenter(this.href,660,420);return false;"><span class="fa fa-linkedin"></span></a>';
			if($show_pinterest)	
				$content .= '<a href="'.$pinterestURL.'" onclick="bocPopupCenter(this.href,660,420);return false;"><span class="fa fa-pinterest"></span></a>';
			if($show_whatsapp)	
				$content .= '<a href="'.$whatsappURL.'" onclick="bocPopupCenter(this.href,660,420);return false;"><span class="fa fa-whatsapp"></span></a>';
			$content .= '</div>';
			
			return $content;

	}
	
	add_shortcode('boc_social_sharing_icons', 'shortcode_boc_social_sharing_icons');
}

// Map Shortcode in Visual Composer
vc_map( array(
	"name"		=> "Social Sharing Icons",
	"description" => esc_html__("Share this page icons", 'boc-shortcodes-and-widgets'),
	"base"		=> "boc_social_sharing_icons",
	"icon"		=> "boc_social_sharing_icons",
	"category" 	=> "Alea Shortcodes",
	"weight"	=> 18,
	"params"	=> array(

		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Facebook", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_facebook",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
			"std"			=> "yes",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Twitter", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_twitter",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
			"std"			=> "yes",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Google +", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_google",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
			"std"			=> "yes",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Linked In", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_linkedin",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
			"std"			=> "yes",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Pinterest", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_pinterest",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
			"std"			=> "yes",
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("WhatsApp", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_whatsapp",
			"value" 		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"edit_field_class" =>"vc_col-sm-6",
		),
	
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
));
