<?php

/**
	Arrow Divider
**/


// Register Shortcode
if( ! function_exists( 'shortcode_boc_arrow_divider' ) ) {
	function shortcode_boc_arrow_divider( $atts, $content = null ) {


		$atts = vc_map_get_attributes('boc_arrow_divider', $atts );
		extract( $atts );
		
		if($type == "Bottom"){
			$css_classes .= ' bottom';
			$border = 'border-color: transparent transparent '.$color.' transparent;';
			$offset = 'bottom: '. $margin_bot .';';
		}else {
			$border = 'border-color: '.$color.' transparent transparent transparent;';
			$offset = 'top: '. $margin_top .';';
		}
		
		if($size == "Small"){
			$css_classes .= ' small';
		}
		
		$custom_styles = 'style="'.$offset.$border.'"';
		
		$str = '<div class="boc_arrow_divider '.esc_attr($css_classes).'" '.$custom_styles.'></div>';			
		return $str;
	}
	
	add_shortcode('boc_arrow_divider', 'shortcode_boc_arrow_divider');
}


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Arrow Divider", 'boc-shortcodes-and-widgets'),
	"base" =>  "boc_arrow_divider",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_arrow_divider",
	"weight"	=> 22,
	"params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Size", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "size",
			"value" 		=> array('Big','Small'),
		),	
		array(
			"type"			=> "colorpicker",
			"heading"		=> "Color",
			"param_name"	=> "color",
			"value"			=> "#ffffff",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Type", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "type",
			"value" 		=> array('Top','Bottom'),
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Margin Top",
			"param_name"	=> "margin_top",
			"std"			=> "0px",
			"dependency"	=> Array(
				'element'	=> "type",
				'value'		=> array('Top')
			),
			"description"	=> "Set your Margins according to your Row paddings in order to position the arrow correctly. For example if your Row has a top padding of 100px set this to -100px.",
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Margin Bottom",
			"param_name"	=> "margin_bot",
			"std"			=> "0px",
			"dependency"	=> Array(
				'element'	=> "type",
				'value'		=> array('Bottom')
			),
			"description"	=> "Set your Margins according to your Row paddings in order to position the arrow correctly. For example if your Row has a bottom padding of 100px set this to -100px.",			
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),			
	)
));