<?php

/**
	Bar Graph
**/

// Register Shortcode
if( ! function_exists( 'boc_bar_graph' ) ) {
	function boc_bar_graph($atts, $content = null) {
		
		$atts = vc_map_get_attributes('boc_bar_graph', $atts );
		extract( $atts );

		$graph_style = '';
		if($custom_color){
			$graph_style = 'style="background-color: '.esc_attr($color).';"';
		}

		$css_classes = '';
		if($thin_style) {
			$css_classes .= ' thin_style';
		}
		if($animated_bgr) {
			$css_classes .= ' animated_bgr';
		}
		if($dark_percent) {
			$css_classes .= ' dark_percent';
		}
		if($minimal_bubble_style) {
			$css_classes .= ' minimal_bubble_style';
		}

		$bar = '
		<div class="bar_graph boc_animate_when_almost_visible_custom_start boc_fade-in '.$css_classes.'">

			<p>' . wp_kses_post($title) . '</p>
			<div class="bar_container"><span '.$graph_style.' data-width="' . esc_attr($percent) . '"> <strong>' . (int)$percent . '%</strong> </span></div>

		</div>';
		return $bar;
	}
	
	add_shortcode('boc_bar_graph', 'boc_bar_graph');
}



function boc_bar_graph_settings(){

	return array(
	"name" => esc_html__("Bar Graph Item", 'boc-shortcodes-and-widgets'),
	"base" => "boc_bar_graph",
	"category" => "Alea Shortcodes",
	"icon" 	=> "boc_bar_graph",
	"weight"	=> 35,
	"params" => array(
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Title", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "title",
			"value" 		=> esc_html__("Graph Title", 'boc-shortcodes-and-widgets'),
			"description" 	=> esc_html__("Set your Graph Title", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Percent", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "percent",
			"value"			=> "85",
			"description" 	=> esc_html__("Enter your Percentage Value (0-100)", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> 'checkbox',
			"heading"		=> esc_html__("Thin Line Style?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "thin_style",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),				
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Pick Custom Color?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "custom_color",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Otherwise your Bar Graph will inherit your Main Theme Color", 'boc-shortcodes-and-widgets'),
		),			
		array(
			"type"			=> "colorpicker",
			"heading"		=> "Color",
			"param_name"	=> "color",
			"value"			=> "#666666",
			"dependency"	=> Array(
				'element'	=> "custom_color",
				'not_empty'	=> true,
			)
		),
		array(
			"type"			=> 'checkbox',
			"heading"		=> esc_html__("Animated Background?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "animated_bgr",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Dark Percent Background", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "dark_percent",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Otherwise it is grey with dark text", 'boc-shortcodes-and-widgets'),
		),	
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Minimal Bubble Style", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "minimal_bubble_style",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("No Background for the number bubble", 'boc-shortcodes-and-widgets'),
		),				
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),
	)
);
}


// Map Shortcode in Visual Composer
vc_lean_map('boc_bar_graph', 'boc_bar_graph_settings');