<?php

/**
	Image Gallery
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_img_gallery' ) ) {
	function shortcode_boc_img_gallery($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_img_gallery', $atts );
		extract( $atts );

		// Get Attachments
		$images = explode(",",$image_ids);
		if($images){
			
			// Img Hover Effect
			if ($img_hover_effect){
				$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
			}

			$gallery_id = md5(serialize($atts));
			
			// CSS Animation
			$css_animation_classes = "";
			if ( $css_animation !== '' ) {
				$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
			}	
			
			$rtl_class = is_rtl() ? 'rtl_grid' : '';
			
			$str = '';
			$str .= '<div id="img_gallery_'.$gallery_id.'" data-columns="'.$columns.'" class="boc_image_gallery grid_holder '.$rtl_class.' mfp_gallery '.$css_classes.' '.$spacing.'">';

			// Prep custom links array if we have it
			if('custom' == $img_link) {
				$custom_links = explode( ",", $custom_links);
			}
			
			// Walk images
			$count = 0;
			foreach ( $images as $img_id ){
				
				// Attachment VARS
				$att_img_link = wp_get_attachment_image_src( $img_id, 'full' );
				$att_img_url = wp_get_attachment_image_src( $img_id, ($fixed_size ? 'boc_medium' : 'full') );
				
				$img_attachment = boc_get_attachment_data($img_id);
				
				$att_img_title = $img_attachment['title'];
				$att_img_alt = $img_attachment['alt'];
				
				$att_img_caption = $img_attachment['caption'];
				$att_img_description =  $img_attachment['description'];
				
				// Image output
				$image_output = '<img src="'. esc_url($att_img_url[0]) .'" alt="'. ($show_img_alt ? esc_attr($att_img_alt) : "") .'" />';

				// Gallery Item
				$str .= '<div class="col span_1_of_'.esc_attr($columns).' '.esc_attr($css_animation_classes).' info_item isotope_element">
							<div class="pic '.esc_attr($img_hover_effect).'">';
				
				// Lightbox link
				if ( 'lightbox' == $img_link ) {
					$str .= '			
							<a href="'. esc_url($att_img_link[0]) .'" class="mfp_popup_gal" title="'. ($show_img_title ? esc_attr($att_img_title) : "") .'">
								'.$image_output.'
								'.($show_hover_overlay ? "<div class='img_overlay ".($hover_overlay_theme_color ? "theme_color" : "")."'><span class='hover_icon icon_plus'></span></div>" : "").'
							</a>';	
				}		
				// Custom Links
				elseif ('custom' == $img_link) {
					
					if(isset($custom_links[$count])){
						$custom_link = esc_url($custom_links[$count]);
					}else {
						$custom_link = "#";
					}
					
					if($custom_link == "#"){
						$custom_link = "javascript:void(0)";
					}
					
					$str .= '			
							<a href="'. $custom_link .'" target="'. esc_attr($target) .'" title="'. ($show_img_title ? esc_attr($att_img_title) : "") .'">
								'.$image_output.'
								'.($show_hover_overlay ? "<div class='img_overlay'><span class='hover_icon icon_zoom'></span></div>" : "").'
							</a>';
				}
				// None
				else {
					$str .= $image_output;
				}
				
				$str .= '	</div>';
				
				if( $show_caption_description && $att_img_caption ){
					$str .= '<h3 class="img_gallery_caption">'. $att_img_caption .'</h3>';
				}
				if( $show_caption_description && $att_img_description ){
					$str .= '<p class="img_gallery_description">'. $att_img_description	.'</p>';
				}
				
				$str .= '</div>';

				$count ++;
			}		
			
			$str .= '</div>';
			

			return $str;
		}
	}
	
	add_shortcode('boc_img_gallery', 'shortcode_boc_img_gallery');
}


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Image Gallery", 'boc-shortcodes-and-widgets'),
	"base" => "boc_img_gallery",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_img_gallery",
	"weight"	=> 56,
	"params" => array(
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__('Columns', 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "columns",
			"value" 		=> Array(2,3,4,5),
			"std"			=> "3",
			"description" 	=> esc_html__('How many columns you want your items displayed in.', 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Item Spacing", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "spacing",
			"value" 		=> array('Big Spacing'=>'big_spacing','Small Spacing'=>'small_spacing','No Spacing'=>'no_spacing'),
			"std"			=> 'small_spacing',
			"description" 	=> esc_html__("Pick a spacing between the items in the grid", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Fixed Image Size", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "fixed_size",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want to use the fixed size (600x380) image preset", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "img_hover_effect",
			"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Side" => 3, "Spin" => 4),
			"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
			"description"	=> esc_html__("Select one if you want the images to be animated once the section enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"group"			=> "Settings",
		),		
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Settings",
		),	
		array(
			"type"			=> "attach_images",
			"admin_label"	=> true,
			"heading"		=> esc_html__("Attach Images", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "image_ids",
			"description"	=> esc_html__('Select the images you want to include in your Slider.', 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> esc_html__( "Image Link", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "img_link",
			"value"			=> array(
				"None"				=> "none",
				"Lightbox Popup"	=> "lightbox",
				"Custom Links"		=> "custom",
			),
			"std"			=> "lightbox",
			"description"	=> esc_html__( "Do you want lightbox/links for your Gallery?", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> "exploded_textarea",
			"heading"		=> esc_html__("Custom Links", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "custom_links",
			"description"	=> esc_html__('Enter links for each separate image here (starting with "http://"). Divide each link with a line-break (Enter). For images without a link enter the "#" symbol.', 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "img_link",
				'value'		=> "custom",
			),
			"group"			=> "Gallery",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "target",
			"value" 		=> array('_self','_blank'),
			"description" 	=> esc_html__("Pick '_blank' if you want the Image link to open in a new tab.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "img_link",
				'value'		=> "custom",
			),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Show Dark Overlay on Image Hover", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_hover_overlay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Show Dark Overlay with Zoom Icon upon hovering linked images", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Dark Overlay inherits Main Theme Color", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "hover_overlay_theme_color",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("The Dark Overlay will iherit your Main Theme Color", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
			"dependency"	=> Array(
					'element'	=> "show_hover_overlay",
					'not_empty'	=> true,
			),	
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Caption/Description below Image", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_caption_description",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want to add the Caption & Desctiption fields below the image", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Image Title", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_img_title",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the Title Attribute added to your images' links", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Image Alt", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_img_alt",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the Alt Attribute added to your image(s)", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),		
	)
));