<?php

/**
	Image Slider 
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_img_slider' ) ) {
	function shortcode_boc_img_slider($atts, $content = null) {

		$atts = vc_map_get_attributes('boc_img_slider', $atts );
		extract( $atts );

		if ($animation == 'Fade') {
			$anim_type_code = 'animateOut:"fadeOut", animateIn: "fadeIn"';
		}else {
			$anim_type_code = '';
		}
			
		// Get Attachments
		$images = explode(",",$image_ids);
		if($images){

			// Arrows
			$nav = (($navigation == "Arrows") || ($navigation == "Both"));

			// Dots
			$dots = (($navigation == "Dots") || ($navigation == "Both"));
			if($dots){
				$css_classes .= ' has_dots'; 
			}			
			
			// Big arrows
			if($big_arrows){
				$css_classes .= ' big_arrows'; 
			}

			// Custom Links
			if ( $img_link == 'custom_link' ) {
				$custom_links = explode( ',', $custom_links);
			}

			// generate checksum of $atts array
			$slider_id = md5(serialize($atts));
			
			$str = '';
			
			$js = '
				/* Image Slider :: START */
				jQuery(document).ready(function($) {
					
					// Load carousel after its images are loaded
					boc_preloadImages($("#img_slider_'.$slider_id.' img"), function () {
						
						var carousel = $("#img_slider_'.$slider_id.'");
						
						var args = {
							items: 			1,
							mouseDrag:		true,
							autoplay:		'.($autoplay ? "true" : "false").',
							autoplayTimeout:'.(int)$autoplay_interval.',
							nav: 			'.($nav 	? "true" : "false").',
							dots: 			'.($dots 	? "true" : "false").',
							loop: 			'.($loop	? "true" : "false").',
							autoHeight: 	'.($auto_height	? "true" : "false").',
							smartSpeed:		'.(int)$speed.',
				'.( $nav ? "	navText:			[\"<span class='icon boc_i-angle-". (is_rtl() ? 'right' : 'left') ."'></span>\",\"<span class='icon boc_i-angle-". (is_rtl() ? 'left' : 'right') ."'></span>\"]," : "").'
							slideBy: 		1,
							navRewind: 		false,
							rtl: 			' . (is_rtl() ? 'true' : 'false') . ',
							onInitialized:  	showCarousel_'.$slider_id.',
							'.$anim_type_code.'
						};
						
						carousel.owlCarousel(args);

						var initital_width = carousel.css("width");		
						
						/* Refresh it for full width rows */
						$(window).load(function(){
							if(carousel.css("width") != initital_width) {
								carousel.trigger("destroy.owl.carousel").removeClass("owl-carousel owl-loaded");
								carousel.find(".owl-stage-outer").children().unwrap();
								carousel.owlCarousel(args);
							}
						});
					});

					/* Show after initialized */
					function showCarousel_'.$slider_id.'() {
						$("#img_slider_'.$slider_id.'").fadeTo(0,1);
						$("#img_slider_'.$slider_id.' .owl-item .boc_owl_lazy").css("opacity","1");
					}
				});
				/* Image Slider :: END */';

			wp_enqueue_script( 'boc_shortcodes_script');
			wp_add_inline_script( 'boc_shortcodes_script', $js );

			$str .= '<div class="img_slider mfp_gallery '.esc_attr($css_classes).'" id="img_slider_'.esc_attr($slider_id).'" style="opacity:0;">';


			// Used for custom links array
			$count = 0;
			
			foreach ( $images as $img_id ){

				// Attachment VARS
				$att_img_link = wp_get_attachment_image_src($img_id, 'full');
				$att_img_url = wp_get_attachment_url($img_id, 'full');
				$img_srcset = wp_get_attachment_image_srcset( $img_id, 'full' );
				$img_sizes = wp_get_attachment_image_sizes( $img_id, 'full' );
				
				$att_img_title = get_the_title($img_id);
				$att_img_alt = get_post_meta($img_id, '_wp_attachment_image_alt', true);
				
				// Image output
				$image_output = '<img 	src = "'. esc_url($att_img_url) .'"
										srcset = "'.esc_attr( $img_srcset ).'"
										sizes = "'.esc_attr( $img_sizes ).'"
										alt = "'. ($show_img_alt ? esc_attr($att_img_alt) : "") .'"
										title = "'. ($show_img_title ? esc_attr($att_img_title) : "") .'"/>';

				// Slider item start 
				$str .= '<div class="img_slider_item boc_owl_lazy">';

					
				if ( 'lightbox' == $img_link ) {
					$str .= '<div class="pic">
								<a href="'. esc_url($att_img_link[0]) .'" class="mfp_popup_gal" title="'. ($show_img_title ? esc_attr($att_img_title) : "") .'">
									'.$image_output.'
									'.($show_hover_overlay ? "<div class='img_overlay'><span class='hover_icon icon_zoom'></span></div>" : "").'
								</a>
							</div>';
								
				}elseif ( 'custom_link' == $img_link ) {

					$att_img_link = !empty($custom_links[$count]) ? $custom_links[$count] : '#';
					if ( $att_img_link == '#' ) {
						$str .= $image_output;
					} else {
						$str .= '
							<div class="pic">
								<a href="'. esc_url($att_img_link) .'" title="'. ($title ? esc_attr($att_img_title) : "") .'" target="'. esc_attr($target) .'">
									'.$image_output.''.($show_hover_overlay ? "<div class='img_overlay'><span class='hover_icon icon_zoom'></span></div>" : "").'
								</a>
							</div>';
					}
				} else {
					$str .= $image_output;
				}
					
				// Close main wrap	
				$str .= '</div>';
				
				$count ++;
			}
			
			$str .= '</div>';				

			return $str;
		}
	}
	
	add_shortcode('boc_img_slider', 'shortcode_boc_img_slider');
}


// Map Shortcode in Visual Composer
vc_map( array(
	"name" => esc_html__("Image Slider", 'boc-shortcodes-and-widgets'),
	"base" => "boc_img_slider",
	"category" => "Alea Shortcodes",
	"icon" 		=> "boc_img_slider",
	"weight"	=> 57,
	"params" => array(
		
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "animation",
			"value" 			=> array('Slide','Fade'),
			"description" 	=> esc_html__("Pick Animation type", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),		
			array(
			"type"			=> 'dropdown',
			"heading" 		=> esc_html__("Slider Navigation", 'boc-shortcodes-and-widgets'),
			"param_name" 		=> "navigation",
			"value"			=> Array("Arrows", "Dots", "Both"),
			"description" 	=> esc_html__("Select a Navigation Type", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),
		array(
			"type"			=> "checkbox",
			"heading"		=> esc_html__("Big arrows?", 'boc-shortcodes-and-widgets'),
			"param_name"		=> "big_arrows",
			"description"		=> esc_html__('Set if you want bigger arrows.', 'boc-shortcodes-and-widgets'),
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"dependency"		=> Array(
				'element'	=> "navigation",
				'value'		=> array( 'Arrows', 'Both' )
			),
			"group"			=> "Slider Settings",
		),		
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("AutoPlay the slider?", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Testimonial Slider to autoplay", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",						
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("AutoPlay Interval", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "autoplay_interval",
			"value" 		=> array('4000','6000','8000','10000','12000','14000'),
			"std"			=> "6000",
			"description" 	=> esc_html__("Set the Autoplay Interval (miliseconds).", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
					'element'	=> "autoplay",
					'not_empty'	=> true,
			),
			"group"			=> "Slider Settings",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Animation Speed", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "speed",
			"value" 		=> array('250','500','750','1000'),
			"std"			=> "250",
			"description" 	=> esc_html__("Set the length of the Slider Animation (miliseconds)", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),			
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Loop the slider", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "loop",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want your Slider to be Infinite", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Enable AutoHeight", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "auto_height",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes for an AutoHeight slider - it will resize according to the item heights in sight", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),						
		array(
			"type" 			=> "textfield",
			"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "css_classes",
			"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
			"group"			=> "Slider Settings",
		),
		array(
			"type"			=> "attach_images",
			"admin_label"	=> true,
			"heading"		=> esc_html__("Attach Images", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "image_ids",
			"description"	=> esc_html__('Select the images you want to include in your Slider.', 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> "dropdown",
			"heading"		=> esc_html__( "Image Link", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "img_link",
			"value"			=> array(
				"None"			=> "none",
				"Lightbox"		=> "lightbox",
				"Custom Links"	=> "custom_link",
			),
			"description"	=> esc_html__( "Where should the slider images link to?", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> "exploded_textarea",
			"heading"		=> esc_html__("Custom Links", 'boc-shortcodes-and-widgets'),
			"param_name"	=> "custom_links",
			"description"	=> esc_html__('Enter links for each separate image here (starting with "http://"). Divide each link with a line-break (Enter). For images without a link enter the "#" symbol.', 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "img_link",
				'value'		=> array( 'custom_link' )
			),
			"group"			=> "Gallery",
		),
		array(
			"type" 			=> "dropdown",
			"heading" 		=> esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "target",
			"value" 		=> array('_self','_blank'),
			"description" 	=> esc_html__("Pick '_blank' if you want the button link to open in a new tab.", 'boc-shortcodes-and-widgets'),
			"dependency"	=> Array(
				'element'	=> "img_link",
				'value'		=> array( 'custom_link' )
			),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Show Dark Overlay on Image Hover", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_hover_overlay",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Show Dark Overlay with Zoom Icon upon hovering linked images", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Image Title", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_img_title",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the Title Attribute added to your images' links", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
		array(
			"type"			=> 'checkbox',
			"heading" 		=> esc_html__("Add Image Alt", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "show_img_alt",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description" 	=> esc_html__("Set to Yes if you want the Alt Attribute added to your image(s)", 'boc-shortcodes-and-widgets'),
			"group"			=> "Gallery",
		),
	)
));