<?php

/**
	List Item
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_list_item' ) ) {
	function shortcode_boc_list_item( $atts, $content = null ) {
		

		$atts = vc_map_get_attributes('boc_list_item', $atts );
		extract( $atts );

		$icon_css = $icon_bgr_css = '';

		if($has_icon_color){
			if($icon_solid) {
				$icon_bgr_css = "background: ". esc_attr($icon_color) .";";
			}else {
				$icon_css = "color: ". esc_attr($icon_color) .";";
			}
		}

		//$css_animation = $this->getCSSAnimation($css_animation);
		
		$css_animation_classes = "";
		if ( $css_animation !== '' ) {
			$css_animation_classes = 'boc_animate_when_almost_visible boc_'. $css_animation .'';
		}
		$delay_tag = ( $delay ? " data-css_delay=".(int)$delay : "");
		
		if($margin_bot){
			$margin_bottom_css = ' style="margin-bottom: '.esc_attr($margin_bot).';"';
		}		
		
		$str = '<div class="boc_list_item '. esc_attr($css_animation_classes) .' '.esc_attr($css_classes).'" '.(isset($margin_bottom_css) ? $margin_bottom_css : "").' '.$delay_tag.'>
					<span class="li_icon '.esc_attr($icon_size).' '.($icon_solid ? ' icon_solid': '').'" style="'.$icon_bgr_css.'"><i class="icon ' . esc_attr($icon) . '" style="'.$icon_css.'"></i></span>
					<div class="boc_list_item_text '.esc_attr($icon_size).'">'. do_shortcode($content) .'</div>
				   </div>';
		return $str;
	}
	
	add_shortcode('boc_list_item', 'shortcode_boc_list_item');
}


// Map Shortcode in Visual Composer
vc_map( array(
   "name" 			=> esc_html__("List Item", 'boc-shortcodes-and-widgets'),
   "description" 	=> esc_html__("Custom Icon List Item", 'boc-shortcodes-and-widgets'),
   "base" 			=> "boc_list_item",
   "category" 		=> "Alea Shortcodes",
   "icon" 			=> "boc_list_item",
   "weight"			=> 70,
   "params" 		=> array(
        // added by valkilmar #1 :: START
		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => true, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
            ),
			'description' => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "dropdown",
			"class"			=> "",
			"heading"		=> esc_html__( "Icon Size", 'boc-shortcodes-and-widgets'),
			"param_name"		=> "icon_size",
			"description"		=> esc_html__( "Select an icon size.", 'boc-shortcodes-and-widgets'),
			"value"			=> array(
				esc_html__( "Small", "boc-shortcodes-and-widgets")			=> "small",
				esc_html__( "Normal", "boc-shortcodes-and-widgets" )		=> "normal",
				esc_html__( "Large", "boc-shortcodes-and-widgets" )		=> "large",
			),
			"std"			=> 'normal',
		),		
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Overwrite Icon Color", "boc-shortcodes-and-widgets"),
			"param_name"	=> "has_icon_color",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes'),
			"description"	=> esc_html__("If not checked Icon will inherit your main theme color", "boc-shortcodes-and-widgets"),
		),
		array(
			"type"			=> "colorpicker",
			"heading"		=> "Icon Color",
			"param_name"	=> "icon_color",
			"value"			=> "#333333",
			"dependency"	=> Array( 'element'	=> "has_icon_color", 'not_empty' => true ),				
		),
		array(
			"type" 			=> "checkbox",
			"heading" 		=> esc_html__("Icon Solid", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "icon_solid",
			"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("Do you want your icon to be a solid Background color and white icon", 'boc-shortcodes-and-widgets'),
		),   
		array(
			"type" 			=> "textarea_html",
			"heading" 		=> esc_html__("Text", 'boc-shortcodes-and-widgets'),
			"param_name" 	=> "content",
			"value" 		=> esc_html__("List Item Text", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"			=> "textfield",
			"heading"		=> "Margin Bottom",
			"param_name"	=> "margin_bot",
			"value"			=> "",
			"description"	=> "Add a bottom margin if you want one. Default is (6px)",			
		),
		array(
			"type"		=> "dropdown",
			"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
			"param_name"	=> "css_animation",
			"admin_label"	=> true,				
			"value"			=> array(
				esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
				esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
				esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
				esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
				esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
				esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
				esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "zoom",
				esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "zoom_out",
				esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "blur"),
			"description"	=> esc_html__("Select one if you want this element to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
			"edit_field_class" =>"vc_col-sm-6",
		),
		array(
			 "type" => "textfield",
			 "heading" => esc_html__("Override Delay (ms)", 'boc-shortcodes-and-widgets'),
			 "param_name" => "delay",
			 "value" => "",
			 "description" => esc_html__("Override the default delay for the CSS animation (e.g. 2000)", 'boc-shortcodes-and-widgets'),
			 "edit_field_class" =>"vc_col-sm-6",
			 "dependency"	=> Array(
				'element'	=> "css_animation",
				'not_empty'	=> true,
			),
		),
		array(
			"type" 		=> "textfield",
			"heading" 	=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" 	=> "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),	
	)
));