<?php

/**
	Portfolio Grid
**/

if ( ! function_exists('is_plugin_active')){ 
	include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
}

// Only if Portfolio plugin is enabled
if(function_exists('boc_portfolio_register')){ 

	// Register Shortcode
	if( ! function_exists( 'shortcode_boc_portfolio_grid' ) ) {
		function shortcode_boc_portfolio_grid($atts, $content = null) {
			
			$atts = vc_map_get_attributes('boc_portfolio_grid', $atts );
			extract( $atts );

			// Img Hover Effect
			if ($img_hover_effect){
				$img_hover_effect = ' img_hover_effect'.$img_hover_effect;
			}

			// Display Type
			$portfolio_style = 'type'.$display_style;
			if($centered) {
				$css_classes .= ' center';
			}
			if($hide_hover_icon) {
				$css_classes .= ' hide_hover_icon';
			}
			
			$portfolio_items_spacing = $spacing;

			$projects = boc_get_portfolio_items($limit, $order_by, $order, $category_name);
			
			$str = '';

			if($projects->have_posts()){

				$grid_id = md5(serialize($atts));

				if($filter_links){

					$portfolio_category = get_terms('portfolio_category');

					if($portfolio_category){
						
						$str.='
							<div class="portfolio_inline_filter">
								<ul class="grid_filter_inline '.($minimal_filter_style? 'minimal_filter_style' : 'regular_filter_style').' '.($center_filter? 'center' :'').' data-option-key="filter">
								'.($show_filter_label? '<li class="portfolio_filter_label">'.esc_html__("Filter", "boc-shortcodes-and-widgets").'</li>	': '').'
									<li><div data-option-value="*" class="current_portfolio_item">'.esc_html__("All", "boc-shortcodes-and-widgets").'</div></li>';

							if($category_name!=""){
								$cats_to_show = (explode( "," , str_replace(' ', '', $category_name)));
								
								// WPML compatibility :: START
								foreach ($cats_to_show as $cat) {
									$terms_for_wpml = get_term_by('slug', $cat, 'portfolio_category');
									$terms_for_wpml = apply_filters('wpml_object_id', $terms_for_wpml->term_id, 'custom taxonomy', true);
									$cats_to_show []= get_term_by('term_id', $terms_for_wpml, 'portfolio_category')->slug;
								}
								// WPML compatibility :: END
							}
							foreach($portfolio_category as $portfolio_cat){
								// Show only cats that are filtered
								if(($category_name=="") || (($category_name!="") && in_array($portfolio_cat->slug, $cats_to_show))){			
									$str.='<li><div data-option-value=".'.esc_attr($portfolio_cat->slug).'">'.esc_html($portfolio_cat->name).'</div></li>';
								}
							}

						$str.='
								</ul>
							</div>
						';
					}
				}
				
				// $columns will always be 4 for Metro Grid
				if($grid_type=='metro'){
					$columns = 4;
				}

				$rtl_class = is_rtl() ? 'rtl_grid' : '';
				
				$str.='

					<div id="portfolio_grid_'.$grid_id.'" data-columns="'.$columns.'" class="portfolio_grid grid_holder '.$rtl_class.' grid_type_'.$grid_type.' '.($css_items_animation ? "animated_items" : "").' '.esc_attr($portfolio_items_spacing).' '.esc_attr($css_classes).' p_style_'.esc_attr($portfolio_style).'">';
							while($projects->have_posts()): $projects->the_post();
								if(has_post_thumbnail()):

									$data_types = '';
									$cats = array();
									
									$item_cats = get_the_terms($projects->post->ID, 'portfolio_category');
									if($item_cats):
										foreach($item_cats as $item_cat) {
											$data_types .= $item_cat->slug . ' ';
											$cats[] = $item_cat->name;
										}
									endif;
									
									// set column fraction ie "span_1_of_3"
									$col_fraction = 1;
									$tall_col = false;
									
									// Alt + Title attributes
									$alt = get_post_meta(get_post_thumbnail_id(), "_wp_attachment_image_alt", true);
									$title = get_the_title(get_post_thumbnail_id());
									
									// Feat. Image
									if($grid_type=='cropped'){
										$feat_img = get_the_post_thumbnail($projects->post->ID, 'boc_medium', array("alt"=> $alt,"title"=>$title));
									
									}elseif($grid_type=='no_crop'){
										$feat_img = get_the_post_thumbnail($projects->post->ID, 'full', array("alt"=> $alt,"title"=>$title));
									
									// metro
									}else {
										// Get Portfolio item's size setting (wide, tall etc.)
										$size_setting = get_post_meta($projects->post->ID, "boc_portfolio_metro_size_options", true);
										$feat_img = get_the_post_thumbnail($projects->post->ID, $size_setting, array("alt"=> $alt,"title"=>$title));
										
										// If tall - add helper class for gutter
										$tall_col = ((($size_setting=='boc_widetall')||($size_setting=='boc_tall')) ? true : false);
										
										// Fraction depends on setting - if wide - set to 2
										$col_fraction = ((($size_setting=='boc_widetall')||($size_setting=='boc_wide')) ? '2' : '1');
									}
									
									// set item_width ie "span_1_of_3"
									$item_width = 'span_'.$col_fraction.'_of_'.esc_attr($columns);
									

									$str.=
										'
										<div class="col '.$item_width.' info_item isotope_element '.esc_attr($data_types).' '.($tall_col?"tall_col":"").'">
											<a href="'.get_the_permalink().'" class="pic_info_link_'.esc_attr($portfolio_style).'">
											  <div class="portfolio_animator_class '.($css_items_animation ? 'boc_anim_hidden boc_'.esc_attr($css_items_animation) : '').'">
												<div class="pic_info '.esc_attr($portfolio_style).'">
													<div class="pic '.esc_attr($img_hover_effect).'">
														<div class="plus_overlay"></div>
														<div class="plus_overlay_icon"></div>
														<figure>'.$feat_img.'</figure>
														<div class="img_overlay_icon"><span class="portfolio_icon icon_link"></span></div></div>
														<div class="info_overlay">
															<div class="info_overlay_padding">
																<div class="info_desc">
																	<span class="portfolio_icon icon_link"></span>				
																	<h3>'.get_the_title().'</h3>
																	<section>'.implode(' / ', $cats).'</section>
																</div>
															</div>
														</div>
													</div>
											  </div>
											</a>
										</div>
										';

								endif; 
							endwhile;
							
							wp_reset_postdata();
							
							$str.='
				</div>
				
			<div class="clear"></div>';
			}
			
			return $str;

		}
		
		add_shortcode('boc_portfolio_grid', 'shortcode_boc_portfolio_grid');
	}



	// Map Shortcode in Visual Composer
	vc_map( array(
	   "name" => esc_html__("Portfolio Grid", 'boc-shortcodes-and-widgets'),
	   "base" => "boc_portfolio_grid",
	   "category" => "Alea Shortcodes",
	   "icon" 	=> "boc_portfolio_grid",
	   "weight"	=> 44,
	   "params" => array(
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Grid Type", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "grid_type",
				"value" 		=> Array(
					esc_html__("Cropped (Same Width & Height)", "boc-shortcodes-and-widgets")	  	=> 'cropped',		// Use the boc_medium thumbnail
					esc_html__("Masonry (Same Width, Auto Height)", "boc-shortcodes-and-widgets") => 'no_crop',		// Use original image - no cropping
					esc_html__("Metro Style Grid", "boc-shortcodes-and-widgets")					=> 'metro'),		// Use custom Metro grid sizes
				"std"			=> "3",
				"description" 	=> esc_html__("Choose your grid Style", 'boc-shortcodes-and-widgets'),
				"group"			=> "Grid Settings",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Columns", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "columns",
				"value" 		=> Array(2,3,4),
				"std"			=> "3",
				"description" 	=> esc_html__("How many columns you want your items displayed in.", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "grid_type",
						'value'		=> array( 'cropped', 'no_crop' )
				),
				"group"			=> "Grid Settings",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Item Spacing", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "spacing",
				"value" 		=> array('Big Spacing'=>'big_spacing','Small Spacing'=>'small_spacing','No Spacing'=>'no_spacing'),
				"std"			=> 'small_spacing',
				"description" 	=> esc_html__("Pick a spacing between the items in the grid. For Metro grid  'No Spacing' is advisable in order to have best alignment.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Grid Settings",
			),
			array(
				"type"			=> 'checkbox',
				"heading"		=> esc_html__("Center Texts?", "boc-shortcodes-and-widgets"),
				"param_name"	=> "centered",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"std"			=> 'yes',
				"description"	=> esc_html__("Check if you want the title and subtitle texts centered.", "boc-shortcodes-and-widgets"),
				"group"			=> "Grid Settings",
			),			
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Enable Filter Links", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "filter_links",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Set to Yes if you want Category Filter Links above your grid", 'boc-shortcodes-and-widgets'),
				"group"			=> "Grid Settings",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Center Filter Options", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "center_filter",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Set to Yes if you want to center Your Filter", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "filter_links",
						'not_empty'	=> true,
				),
				"group"			=> "Grid Settings",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Minimal Filter Style?", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "minimal_filter_style",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Set to Yes if you want minimalistic Filter Links", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "filter_links",
						'not_empty'	=> true,
				),
				"group"			=> "Grid Settings",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Show Filter Label", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "show_filter_label",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Show 'Filter' label in front of filter", 'boc-shortcodes-and-widgets'),
				"dependency"	=> Array(
						'element'	=> "filter_links",
						'not_empty'	=> true,
				),
				"group"			=> "Grid Settings",
			),
			array(
				"type"		=> "dropdown",
				"heading"	=> esc_html__("CSS Animation", "boc-shortcodes-and-widgets"),
				"param_name"	=> "css_items_animation",
				"admin_label"	=> true,				
				"value"			=> array(
					esc_html__("None", "boc-shortcodes-and-widgets")					=> '',
					esc_html__("Top to bottom", "boc-shortcodes-and-widgets")			=> "top-to-bottom",
					esc_html__("Bottom to top", "boc-shortcodes-and-widgets")			=> "bottom-to-top",
					esc_html__("Left to right", "boc-shortcodes-and-widgets")			=> "left-to-right",
					esc_html__("Right to left", "boc-shortcodes-and-widgets")			=> "right-to-left",
					esc_html__("Fade In", "boc-shortcodes-and-widgets")				=> "fade-in",
					esc_html__("Zoom In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom",
					esc_html__("Zoom Out", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_zoom_out",
					esc_html__("Blur In", "boc-shortcodes-and-widgets")				=> "boc_animate_when_almost_visible boc_blur"),
				"description"	=> esc_html__("Animation will be applied to each single Item in your grid for a better effect", "boc-shortcodes-and-widgets"),
				"group"			=> "Grid Settings",
			),	
			array(
				"type" 			=> "textfield",
				"heading" 		=> esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "css_classes",
				"description" 	=> esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Grid Settings",
			),
			array(
				"type" 			=> "textfield",
				"heading" 		=> esc_html__("Total Items Limit", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "limit",
				"std"			=> "9",
				"description" 	=> esc_html__("How many items you want to limit your grid to", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),			
			array(
				"type" 			=> "textfield",
				"heading" 		=> esc_html__("Category Name Filter (slug)", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "category_name",
				"value" 		=> "",
				"description" 	=> esc_html__("Filter only a certain Category from your portfolio grid (comma-separated)", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),				
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("'Order By' Clause", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "order_by",
				"value" 		=> array('none','ID','title','name','date','rand'),
				"std"			=> 'date',
				"description" 	=> __("Order results by a certain field. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the available WP options here</a>.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("'Order' Clause", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "order",
				"value" 		=> array('DESC','ASC'),
				"description" 	=> __("Order results in a Descending or Ascending order. <a href='http://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters' target='_blank'>More on the order here</a>.", 'boc-shortcodes-and-widgets'),
				"group"			=> "Query",
			),
			array(
				"type" 			=> "dropdown",
				"heading" 		=> esc_html__("Display Style", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "display_style",
				"value" 		=> array(
					"Diagonal Unroll (1)"		=> '1',
					"Overlay Fade (2)"	 		=> '2',
					"Overlay Fade Up (3)" 		=> '3',
					"Circular Explode (4)" 		=> '4',
					"Text Overlay (5)"		 	=> '5',
					"Rotate (6)"			 	=> '6',
					"Color Overlay Text (7)"	=> '7',
					"Dark Overlay Text (8)"		=> '8',
					"White Overlay Text (9)"	=> '8 light'
				),
				"description" 	=> esc_html__("Pick a Display Style. Metro grid friendly styles are 7,8 and 9", 'boc-shortcodes-and-widgets'),
				"group"			=> "Design",
			),
			array(
				"type"			=> 'checkbox',
				"heading" 		=> esc_html__("Hide Hover Icon?", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "hide_hover_icon",
				"value"			=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
				"description" 	=> esc_html__("Hide the Icon in the image Overlay on Hover", 'boc-shortcodes-and-widgets'),
				
				"group"			=> "Design",
			),			
			array(
				"type"			=> 'dropdown',
				"heading" 		=> esc_html__("Hover Image Effect", 'boc-shortcodes-and-widgets'),
				"param_name" 	=> "img_hover_effect",
				"value"			=> Array("None" => '', "Zoom Out" => 1, "Zoom In" => 2, "Side" => 3, "Spin" => 4),
				"description" 	=> esc_html__("Pick a hover Image Effect", 'boc-shortcodes-and-widgets'),
				"group"			=> "Design",
			),
	   )
	));	
}