<?php

/**
	Side Icon Featured Text
**/

// Register Shortcode
if( ! function_exists( 'shortcode_boc_side_icon_box' ) ) {
	function shortcode_boc_side_icon_box( $atts, $content = null ) {
		

		$atts = vc_map_get_attributes('boc_side_icon_box', $atts );
		extract( $atts );	

		$icon_css = $icon_bgr_css = '';
		
		$link = '';
		if($href){
			$link = '<a href="'.esc_url($href).'" target="'.esc_attr($target).'">';
		}
		
		if($has_icon_color){
			if($icon_solid) {
				$icon_bgr_css = "background: ". esc_attr($icon_color) .";";
			}else {
				$icon_css = "color: ". esc_attr($icon_color) .";";
			}
		}
					
		$content = '<div class="side_icon_box '.esc_attr($icon_size).' '.esc_attr($css_classes).' '.($animated ? "boc_animate_when_almost_visible" : "").'"><span class="icon_feat '.($icon_solid ? ' icon_solid': '').'" style="'.$icon_bgr_css.'"><i class="icon ' . esc_attr($icon) . '" style="'.$icon_css.'"></i></span><h3>'.($href ? $link : '') . $title . ($href ? '</a>' : '').'</h3><div class="side_icon_box_content">'.do_shortcode($content).'</div></div>';
		return $content;
	}
	
	add_shortcode('boc_side_icon_box', 'shortcode_boc_side_icon_box');
}

// Map Shortcode in Visual Composer
vc_map( array(
   "name" => esc_html__("Side Icon Box", 'boc-shortcodes-and-widgets'),
   "description" => esc_html__("Side Iconed Featured Box", 'boc-shortcodes-and-widgets'),
   "base" 	=> "boc_side_icon_box",
   "category" => "Alea Shortcodes",
   "icon" 	=> "boc_side_icon_box",
   "weight"	=> 66,
   "params" => array(
		array(
			"type" => "textfield",
			"heading" => esc_html__("Heading", 'boc-shortcodes-and-widgets'),
			"param_name" => "title",
			"admin_label"=> true,
			"value" => esc_html__("Featured Title", 'boc-shortcodes-and-widgets'),
			"description" => esc_html__("Enter the Heading for your Icon Box", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type" 		=> "textarea_html",
			"heading" 	=> esc_html__("Text Below Title", 'boc-shortcodes-and-widgets'),
			"param_name" => "content",
			"value" 		=> esc_html__("Featured Text", 'boc-shortcodes-and-widgets'),
			"description"=> esc_html__("Enter the text to go below your Heading", 'boc-shortcodes-and-widgets'),
		),
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Animate Box In?", "boc-shortcodes-and-widgets"),
			"param_name"	=> "animated",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("Check Yes if you want the box to be animated once it enters the browsers viewport.", "boc-shortcodes-and-widgets"),
		),		
		array(
			"type" => "textfield",
			"heading" => esc_html__("Extra class name", 'boc-shortcodes-and-widgets'),
			"param_name" => "css_classes",
			"value" => "",
			"description" => esc_html__("If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.", 'boc-shortcodes-and-widgets'),
		),

		array(
			"type"          => "iconpicker",
			"heading"       => "Icon",
			"param_name"    => "icon",
			"admin_label"   => true,
			"settings" => array(
				'type' => 'alea',
				'emptyIcon' => true, // default true, display an "EMPTY" icon?
				'iconsPerPage' => 4000, // default 100, how many icons per/page to display, we use (big number) to display all icons in single page
			),
			'description'   => esc_html__( 'Select icon from library.', 'boc-shortcodes-and-widgets' ),
			"group"         => esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),

		array(
			"type"			=> "dropdown",
			"class"			=> "",
			"heading"		=> esc_html__( "Icon Size", 'boc-shortcodes-and-widgets' ),
			"param_name"		=> "icon_size",
			"description"		=> esc_html__( "Select an icon size.", 'boc-shortcodes-and-widgets' ),
			"value"			=> array(
				esc_html__( "Small", "boc-shortcodes-and-widgets" )		=> "small",
				esc_html__( "Normal", "boc-shortcodes-and-widgets" )		=> "normal",
				esc_html__( "Large", "boc-shortcodes-and-widgets" )		=> "large",
				esc_html__( "X-Large", "boc-shortcodes-and-widgets" )		=> "xlarge",
			),
            "std"       => "normal",
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),			
		array(
			"type"		=> 'checkbox',
			"heading"	=> esc_html__("Overwrite Icon Color", "boc-shortcodes-and-widgets"),
			"param_name"	=> "has_icon_color",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"	=> esc_html__("If not checked Icon will inherit your main theme color", "boc-shortcodes-and-widgets"),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),				
		array(
			"type"		=> "colorpicker",
			"heading"	=> "Icon Color",
			"param_name"	=> "icon_color",
			"value"		=> "#333333",
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
			"dependency"	=> Array( 'element'	=> "has_icon_color", 'not_empty' => true ),				
		),				
		array(
			"type" 		=> "checkbox",
			"heading" 	=> esc_html__("Icon Solid", 'boc-shortcodes-and-widgets'),
			"param_name" => "icon_solid",
			"value"		=> Array(esc_html__("Yes", "boc-shortcodes-and-widgets") => 'yes' ),
			"description"=> esc_html__("Do you want your icon to be a solid Background color and white icon", 'boc-shortcodes-and-widgets'),
			"group"		=> esc_html__( 'Icon', 'boc-shortcodes-and-widgets' ),
		),		
		array(
			"type" => "textfield",
			"heading" => esc_html__("URL Link", 'boc-shortcodes-and-widgets'),
			"param_name" => "href",
			"value" => "",
			"description" => esc_html__("Enter a link if you want one", 'boc-shortcodes-and-widgets'),
			"group"		=> esc_html__( 'Link', 'boc-shortcodes-and-widgets'),	
		),
		array(
			"type" => "dropdown",
			"heading" => esc_html__("Target", 'boc-shortcodes-and-widgets'),
			"param_name" => "target",
			"value" => array('_self','_blank'),
			"description" => esc_html__("Pick '_blank' if you want the link to open in a new tab.", 'boc-shortcodes-and-widgets'),
			"group"		=> esc_html__( 'Link', 'boc-shortcodes-and-widgets'),	
		),
   )
));