<?php
//  THEME OPTIONS

/**	
	Return Theme Default Color
**/
if( ! function_exists( 'boc_get_default_color' ) ) { 
	function boc_get_default_color() {
	
		$boc_default_color = "#0bafc7";
		return $boc_default_color;
	}
}

/**	
	Return Main Theme Color
**/
if( ! function_exists( 'boc_get_main_color' ) ) { 
	function boc_get_main_color() {
	
		$boc_main_color = get_theme_mod('boc_main_color', boc_get_default_color());
		return $boc_main_color;
	}
}
/**	
	Return Footer Copyright text
**/
if( ! function_exists( 'boc_get_footer_copyright_text' ) ) { 
	function boc_get_footer_copyright_text() {
	
		return '<a href="https://themeforest.net/item/alea-business-multipurpose-wordpress-theme/22902144" target="_blank">Alea Theme</a> &copy; 2019 &nbsp; | &nbsp; <a href="http://themeforest.net/user/blueowlcreative/portfolio?ref=blueowlcreative" target="_blank">BlueOwlCreative</a>';
	}
}


/**
	Return Responsive Page Setting
**/
if( ! function_exists( 'boc_responsive_option' ) ) { 
	function boc_responsive_option() {
	
		if(ot_get_option('responsive_design','on')=='on'){
			$responsive_option = true;
		}else {
			$responsive_option = false;
		}
		
		return $responsive_option ? 'responsive' : 'non-responsive';
	}
}

/**
	Return Wrapper Style
**/
if( ! function_exists( 'boc_page_wrapper_style' ) ) { 
	function boc_page_wrapper_style() {
	
		global $post;
		// Get wrapper style set in Theme Options
		$wrapper_style = ot_get_option('wrapper_style','full_width_wrapper');
		
		// Overwrite Default wrapper style from Page Settings if different than "default" or Null
		if ( is_single() || is_page() ) {
			$page_wrapper_style = get_post_meta($post->ID, 'boc_page_wrapper_style', true);
			if(!($page_wrapper_style && $page_wrapper_style == 'default')) {
				$wrapper_style = $page_wrapper_style;
			}
		}
		return $wrapper_style;
	}
}

/**
	Return Page Sidebar Layout
**/
if( ! function_exists( 'boc_page_sidebar_layout' ) ) { 
	function boc_page_sidebar_layout() {
	
		global $post;
		if(!isset($post->ID)){
			return 'full-width';
		}
		
		$sidebar_layout = ot_get_option('sidebar_layout','full-width');
		$meta_box_layout = get_post_meta($post->ID, "boc_meta_sidebar_layout", true);

		// Overwrite is set in the editor Meta Box
		if($meta_box_layout && ($meta_box_layout!='default')) {
			$sidebar_layout = $meta_box_layout;
		}
		return $sidebar_layout;
	}
}

/**	
	Return Blog Listing Sidebar Layout
**/
if( ! function_exists( 'boc_posts_sidebar_layout' ) ) { 
	function boc_posts_sidebar_layout() {
	
		$sidebar_layout = ot_get_option('sidebar_layout_posts','right-sidebar');
		
		// If empty - overwrite with full-width
		if(!is_active_sidebar( 'alea_default_sidebar' )){
			$sidebar_layout = 'full-width';
		}
		return $sidebar_layout;
	}
}
/**	
	Return Single Post Sidebar Layout
**/
if( ! function_exists( 'boc_single_post_sidebar_layout' ) ) { 
	function boc_single_post_sidebar_layout() {
	
		global $post;
		
		$sidebar_layout = ot_get_option('sidebar_layout_single_post','full-width');
		$meta_box_layout = get_post_meta($post->ID, "boc_meta_sidebar_layout", true);
		// Overwrite is set in the editor Meta Box (only if we are not on the index.php template)
		if(!empty($meta_box_layout) && ($meta_box_layout!='default') && is_single()) {
			$sidebar_layout = $meta_box_layout;
		}
		return $sidebar_layout;
	}
}

/**	
	Return Whether We have SEARCH in the header
**/
if( ! function_exists( 'boc_show_search_in_header' ) ) { 
	function boc_show_search_in_header() {
	
		$show_search = ot_get_option('show_search','on');
		return $show_search;
	}
}

/**	
	Return Whether We have SEARCH in the header
**/
if( ! function_exists( 'boc_mobile_show_search_in_header' ) ) { 
	function boc_mobile_show_search_in_header() {
	
		$show_search = ot_get_option('mobile_show_search','off');
		return $show_search;
	}
}

/**	
	Return Whether We have SEARCH SEPARATOR in the header
**/
if( ! function_exists( 'boc_show_search_separator' ) ) { 
	function boc_show_search_separator() {
	
		$show_search_sep = ot_get_option('show_search_separator','on');
		return $show_search_sep;
	}
}


/**	
	Return Whether Main Navigation has Underline Effect Setting ON
**/
if( ! function_exists( 'boc_is_main_nav_underline_effect' ) ) { 
	function boc_is_main_nav_underline_effect() {

		return (ot_get_option('main_nav_underline_effect','on') == 'on');
	}
}

/**	
	Return Main Navigation Underline Effect Color
**/
if( ! function_exists( 'boc_main_nav_underline_effect_color' ) ) { 
	function boc_main_nav_underline_effect_color() {

		return ot_get_option('main_nav_underline_effect_color', boc_get_default_color());
	}
}

/**	
	Return Header Height
**/
if( ! function_exists( 'boc_header_height' ) ) { 
	function boc_header_height() {

		return ot_get_option('header_height','92');
	}
}
/**
	Return Sticky Header BGR Color 
**/
if( ! function_exists( 'boc_get_header_bgr_color' ) ) { 
	function boc_get_header_bgr_color() {
	
		return ot_get_option('header_bgr_color', '#ffffff');
	}
}



/**
	Return Main Nav Style 
**/
if( ! function_exists( 'boc_get_navigation_style' ) ) { 
	function boc_get_navigation_style() {
	
		return ot_get_option('navigation_style', 'menu_regular_style');
	}
}


/**
	Return Angular style Logo Background
**/
if( ! function_exists( 'get_angular_main_navigation_logo_background' ) ) {
	function get_angular_main_navigation_logo_background() {
		
		return ot_get_option('angular_main_navigation_logo_background', '#ffffff');
	}
}

/**
	Return Angular style Logo Background for Transparent Header
**/
if( ! function_exists( 'get_transparent_angular_main_navigation_logo_background' ) ) {
	function get_transparent_angular_main_navigation_logo_background() {
		
		return ot_get_option('transparent_angular_main_navigation_logo_background', '#ffffff');
	}
}

/**
	Return Full width Stripe style
**/
if( ! function_exists( 'get_full_width_stripe_menu' ) ) {
	function get_full_width_stripe_menu() {
		
		return (ot_get_option('full_width_stripe_menu', 'off') == 'on');
	}
}

/**
	Return Stripe Menu background
**/
if( ! function_exists( 'get_stripe_menu_background' ) ) {
	function get_stripe_menu_background() {

		return ot_get_option('stripe_menu_background', 'black');
	}
}


/**
	Return SubMenu background
**/
if( ! function_exists( 'get_submenu_background' ) ) {
	function get_submenu_background() {

		return ot_get_option('submenu_style', 'sub_black');
	}
}

/**
	Return SubMenu Item style
**/
if( ! function_exists( 'get_submenu_item_style' ) ) {
	function get_submenu_item_style() {

		return ot_get_option('submenu_item_style', 'sub_simple');
	}
}


/**
	Return SubMenu Item Hover Style
 **/
if( ! function_exists( 'get_submenu_item_hover_style' ) ) {
	function get_submenu_item_hover_style() {

		return ot_get_option('submenu_item_hover_style', 'submenu_bgr_swap');
	}
}

/**
	Return SubMenu Item Hover Indent animation
 **/
if( ! function_exists( 'get_submenu_item_hover_indent' ) ) {
	function get_submenu_item_hover_indent() {

		return (ot_get_option('submenu_item_hover_indent', 'on')=='on') ? 'submenu_hover_indent' : '';
	}
}

/**
	Return SubMenu Item Hover color
 **/
if( ! function_exists( 'get_submenu_item_hover_color' ) ) {
	function get_submenu_item_hover_color() {
		$default_color = boc_get_default_color();
		return ot_get_option('submenu_item_hover_color', $default_color);
	}
}


/**
	Return SubMenu Top border
**/
if( ! function_exists( 'get_submenu_top_border' ) ) {
	function get_submenu_top_border() {

		return (ot_get_option('submenu_top_border', 'on') == 'on') ? "submenu_top_border" : "";
	}
}

/**
	Return SubMenu Top border color
**/
if( ! function_exists( 'get_submenu_top_border_color' ) ) {
	function get_submenu_top_border_color() {

		return ot_get_option('submenu_top_border_color', '#0bafc7');
	}
}







/**	
	Return Whether Header is Full width
**/
if( ! function_exists( 'boc_is_header_full_width' ) ) {
	function boc_is_header_full_width() {

		return (ot_get_option('header_width','0') == '1');
	}
}


/**
	Return Whether Header is Sticky
**/
if( ! function_exists( 'boc_is_header_sticky' ) ) {
	function boc_is_header_sticky() {

		return (ot_get_option('sticky_header','on') == 'on');
	}
}


/**	
	Return Whether Nav only for Sticky Header
**/
if( ! function_exists( 'boc_is_only_nav_sticky_header' ) ) { 
	function boc_is_only_nav_sticky_header() {
		return (ot_get_option('only_nav_sticky_header','off') == 'on');
	}
}


/**
	Return Sticky Header BGR Color 
**/
if( ! function_exists( 'boc_get_sticky_header_color' ) ) { 
	function boc_get_sticky_header_color() {
	
		return ot_get_option('sticky_header_color', '#ffffff');
	}
}
/**
	Return Sticky Header Opacity 
**/
if( ! function_exists( 'boc_get_sticky_header_opacity' ) ) { 
	function boc_get_sticky_header_opacity() {
	
		return ot_get_option('sticky_header_opacity', '0.97');
	}
}


/**
	Return Subheader
**/
if( ! function_exists( 'boc_get_is_subheader_on' ) ) { 
	function boc_get_is_subheader_on() {
	
		return  ot_get_option('subheader','off') == 'on';
	}
}



/**
	Return Subheader BGR 
**/
if( ! function_exists( 'boc_get_subheader_bgr_color' ) ) { 
	function boc_get_subheader_bgr_color() {
	
		return ot_get_option('subheader_bgr_color', '#e9f3fc');
	}
}

/**
	Return Subheader color 
**/
if( ! function_exists( 'boc_get_subheader_text_color' ) ) { 
	function boc_get_subheader_text_color() {
	
		return ot_get_option('subheader_text_color', "#ffffff");
	}
}


/**	
	Return Sticky Header Height
**/
if( ! function_exists( 'boc_sticky_header_height' ) ) { 
	function boc_sticky_header_height() {

		return ot_get_option('sticky_header_height','64');
	}
}


/**	
	Return Whether the mm_bordered_columns Setting ON
**/
if( ! function_exists( 'boc_is_mm_bordered_columns' ) ) { 
	function boc_is_mm_bordered_columns() {

		return (ot_get_option('mm_bordered_columns','on') == 'on');
	}
}


/**
	Return Header Transparency Option 
**/
if( ! function_exists( 'boc_is_transparent_header' ) ) { 
	function boc_is_transparent_header() {
	
		
		// Get post id if on a post or page
		if(is_archive() || is_search() || is_tax() || is_home()){
			$post_id = 0;
		}else {
			global $post;
			if(!empty($post))
				$post_id = $post->ID;
			else
				$post_id = 0;
		}

		global $woocommerce;
				
		// If shop get shop page id
		if(function_exists('is_shop') && is_shop()){
			if(function_exists('wc_get_page_id')){
				$post_id = wc_get_page_id('shop');
			}else {
				$post_id = woocommerce_get_page_id('shop');
			}
		}

		$boc_transparent_header = get_post_meta($post_id, "boc_transparent_header_set", true);
		
		if($boc_transparent_header == 'on') {
			return true;
		}else {
			return false;
		}
	}
}

/**
	Return Transparent Logo Effect (flip or fade) 
**/
if( ! function_exists( 'boc_get_transparent_logo_effect' ) ) { 
	function boc_get_transparent_logo_effect() {

		return ot_get_option('transparent_logo_effect', 'flip');
	}
}

/**
	Return Transparent Header BGR Color 
**/
if( ! function_exists( 'boc_get_transparent_header_color' ) ) { 
	function boc_get_transparent_header_color() {
	
		return ot_get_option('transparent_header_color', '#ffffff');
	}
}
/**
	Return Transparent Header Opacity 
**/
if( ! function_exists( 'boc_get_transparent_header_opacity' ) ) { 
	function boc_get_transparent_header_opacity() {
	
		return ot_get_option('transparent_header_opacity', '0.1');
	}
}

/**
	Return Main Navigation Color 
**/
if( ! function_exists( 'boc_get_main_navigation_color' ) ) { 
	function boc_get_main_navigation_color() {
	
		return ot_get_option('main_navigation_color', '#333333');
	}
}
/**
	Return Main Navigation Hover Color 
**/
if( ! function_exists( 'boc_get_main_navigation_hover_color' ) ) { 
	function boc_get_main_navigation_hover_color() {
	
		return ot_get_option('main_navigation_hover_color', '#333333');
	}
}
/**
	Return Striped Main Navigation Hover Color 
**/
if( ! function_exists( 'boc_get_striped_main_navigation_hover_color' ) ) { 
	function boc_get_striped_main_navigation_hover_color() {
	
		$default_color = boc_get_default_color();
		return ot_get_option('striped_main_navigation_hover_color', $default_color);
	}
}

/**
	Return Transparent Header Main Navigation Color 
**/
if( ! function_exists( 'boc_get_transparent_header_nav_color' ) ) { 
	function boc_get_transparent_header_nav_color() {
	
		return ot_get_option('transparent_header_navigation_color', '#ffffff');
	}
}
/**
	Return Transparent Header Main Navigation Hover Color 
**/
if( ! function_exists( 'boc_get_transparent_header_nav_hover_color' ) ) { 
	function boc_get_transparent_header_nav_hover_color() {
	
		return ot_get_option('transparent_header_navigation_hover_color', '#ffffff');
	}
}

/**
	Return Subheader BGR for Transparent Header 
**/
if( ! function_exists( 'boc_get_subheader_transparent_header_bgr_color' ) ) { 
	function boc_get_subheader_transparent_header_bgr_color() {
	
		return ot_get_option('subheader_transparent_header_bgr_color', boc_get_default_color());
	}
}

/**
	Return Subheader color for Transparent Header 
**/
if( ! function_exists( 'boc_get_subheader_transparent_header_text_color' ) ) { 
	function boc_get_subheader_transparent_header_text_color() {
	
		return ot_get_option('subheader_transparent_header_text_color', "#ffffff");
	}
}



/**	
	Return Blog Excerpt limit
**/
if( ! function_exists( 'boc_blog_excerpt_limit' ) ) { 
	function boc_blog_excerpt_limit() {

		return ot_get_option('blog_excerpt_limit','55');
	}
}

/**	
	Return More link Classes for Blog
**/
if( ! function_exists( 'boc_more_link_classes' ) ) { 
	function boc_more_link_classes() {

		return "more-link".ot_get_option('blog_more_link_style','1');
	}
}
