/**
	Alea Common JS functionaly 
**/


// Global Vars
var boc_is_mobile 				= (bocJSParams.boc_is_mobile_device) ? true : false;
var sticky_header 				= (bocJSParams.sticky_header =='0')?false:true;
var transparent_header 			= (bocJSParams.transparent_header =='0')?false:true;
var fixed_footer 				= (bocJSParams.fixed_footer =='0')?false:true;
var mm_bordered_columns			= (bocJSParams.mm_bordered_columns =='0')?false:true;
var boc_woo_lightbox_enabled	= (bocJSParams.boc_woo_lightbox_enabled =='0')?false:true;
var boc_submenu_animation_effect= bocJSParams.boc_submenu_animation_effect;
var retina_logo_url 			= bocJSParams.retina_logo_url;
var mobile_retina_logo_url 		= bocJSParams.mobile_retina_logo_url;
var retina_logo_transparent_url = bocJSParams.retina_logo_transparent_url;

jQuery(document).ready(function($){

	"use strict";

	var header_h = $('#header').outerHeight();
	var win_width = getWindowWidth();
	
	// Set retina logos 
	if (window.devicePixelRatio >= 2) {
		if(retina_logo_url != ""){
			$(".logo_img > a > img").attr("src", retina_logo_url);
		}
		if((mobile_retina_logo_url != "") && boc_is_mobile){
			$("#mobile_logo > a > img").attr("src", mobile_retina_logo_url);
		}
		if(retina_logo_transparent_url != ""){
			$("#transparent_logo > img").attr("src", retina_logo_transparent_url);
		}
	}	
	
	
	// Center logo in Main nav
	if($('#wrapper').hasClass('menu_midlogo') && !boc_is_mobile) {
		boc_center_logo_in_header();
		
		$(window).smartresize(function() {
			boc_align_midlogo_to_center();
		});
	}
	
	if($('#wrapper').hasClass('menu_midlogo') && boc_is_mobile) {
		jQuery('#wrapper.menu_midlogo #header').animate({opacity: 1}, 500);
	}
	

	// Push down content
	if(sticky_header && (jQuery('#header').boc_doesExist()) && !transparent_header && !boc_is_mobile){
		if(win_width >= 1018){
			$('.content_body').css('marginTop', header_h + 'px');
		}
	}
	
	
	// Hamburger menu init
	boc_menu_icon_init();
	
	// Responsive menu init
	mobile_menu_init();
	
	
	// Mobile fixes
	if(boc_is_mobile){

		$('#footer').addClass('mobile_force_relative_position');

        // Hide Header on scroll down
        var didScroll;
        var lastScrollTop = 0;
        var delta = 5;
        var navbarHeight = $('#mobile_header').outerHeight();
 
		if(!$('#mobile_header').hasClass('mobile_header_always_sticky')) {
			
			$(window).scroll(function(event){
				didScroll = true;
			});

			setInterval(function() {
				if (didScroll) {
					boc_hasScrolled();
					didScroll = false;
				}
			}, 300);

			function boc_hasScrolled() {
				var st = $(window).scrollTop();

				// Make sure they scroll more than delta
				if(Math.abs(lastScrollTop - st) <= delta)
					return;

				if (st > lastScrollTop && st > navbarHeight){
					// Scroll Down + Hide menu if active
					if(!$('#mobile_menu').hasClass('mobile_menu_active')) {
						$('#mobile_header').removeClass('mobile_header_down').addClass('mobile_header_up');
					}

				} else {
					// Scroll Up
					if(st + $(window).height() < $(document).height()) {
						$('#mobile_header').removeClass('mobile_header_up').addClass('mobile_header_down');
					}
				}

				lastScrollTop = st;
			}
		}

	}	

	
	// MENU LOGIC - Start	
	// Menu Animation
	if(boc_submenu_animation_effect!="sub_fade_in"){
		var boc_menu_animation =  {
			"opacity": 		"show",
			"height": 		["show", "easeOutCubic"],
			"marginTop": 	["show", "easeOutCubic"],
			"marginBottom": ["show", "easeOutCubic"],
			"paddingTop": 	["show", "easeOutCubic"],
			"paddingBottom":["show", "easeOutCubic"],
		};
		var boc_menu_animation_out =  {
			"opacity": 		"hide",
			"height": 		["hide", "easeOutExpo"],
			"marginTop": 	["hide", "easeOutExpo"],
			"marginBottom": ["hide", "easeOutExpo"],
			"paddingTop": 	["hide", "easeOutExpo"],
			"paddingBottom":["hide", "easeOutExpo"],
		};
	}else {
		var boc_menu_animation =  		{"opacity": "show" 	};
		var boc_menu_animation_out =  	{"opacity":	"hide"	};
	}
	
	// Main menu
	$('ul.boc_main_menu').superfish({
		delay:         500,
		hoverClass:    'sf-hover',
		animation:     boc_menu_animation,
		animationOut:  boc_menu_animation_out,
		speed:         250,
		speedOut:      150,
		cssArrows:     true,
	});
	
	// Underline Effect
	$('#menu > .main_menu_underline_effect > li > ul.sub-menu').parent().addClass('no_border');

	// Mobile menu
	$('#mobile_menu ul li a > span').addClass('fa fa-angle-down');		
	$('#mobile_menu ul li a > span').on('click',function(e){	
		e.preventDefault();
		$(this).parent('a').next('ul').stop(true,true).slideToggle(300);
		if($(this).hasClass('fa fa-angle-down')) {
			$(this).removeClass('fa fa-angle-down').addClass('fa fa-angle-up');	
		}else {
			$(this).removeClass('fa fa-angle-up').addClass('fa fa-angle-down');	
		}
	});
	
	// Fly out menu
	$('.boc_side_widget .widget_nav_menu ul li.menu-item-has-children > a').append('<span class="fa fa-angle-down"></span>');	
	$('.boc_side_widget .widget_nav_menu ul li.menu-item-has-children > a > span').on('click',function(e){	
		e.preventDefault();
		$(this).parent('a').next('ul').stop(true,true).slideToggle(300);
		if($(this).hasClass('fa fa-angle-down')) {
			$(this).removeClass('fa fa-angle-down').addClass('fa fa-angle-up');	
		}else {
			$(this).removeClass('fa fa-angle-up').addClass('fa fa-angle-down');	
		}
	});
	
	
	// Sidebar Menu
	$('.wpb_widgetised_column').attr('id','sidebar');


	$(window).smartresize(function() {
		var win_width = getWindowWidth();
		if(win_width >= 1018){

			if($('#mobile_menu_toggler').hasClass('active_mobile_menu')){
				$('#mobile_menu_toggler').removeClass('active_mobile_menu');
				$('.m_nav_ham').removeClass('m_nav_menu').addClass('button_closed');
				$("#m_ham_1").removeClass("m_nav_ham_1_open");
				$("#m_ham_2").removeClass("m_nav_ham_2_open");
				$("#m_ham_3").removeClass("m_nav_ham_3_open");
			}
		}
	});

	// Megamenu
	// Mega Menu Borders
	if(mm_bordered_columns && !boc_is_mobile){
		$('#menu > ul > li.megamenu').addClass("mm_bordered_columns");
		$('#menu > ul > li.megamenu').each(function(){
			var mm_highest_column_h = $(this).children("ul").innerHeight();

			$(this).children("ul:first").children("li").each(function(){
				$(this).css('min-height',(mm_highest_column_h - 51));
			});
		});
	}
	// Mega Menu Column Titles
	$('#menu .mm_col_title').css('marginTop','12px');
	$('#menu > ul > li.megamenu > ul > li').addClass('mm_col_title');
	
	// Hide invisible mm containers and show their children
	$('.mobile_menu_ul > li ul > li.mm_hide > a').hide().siblings('ul').show();
	
	
	// MENU LOGIC :: END	

	
	// If clicked on Wrapper overlay
	jQuery('.wrapper_overlay').on('click',function(){
		jQuery('#boc_menu_icon').trigger('click');
	});
	// If clicked on Close button
	jQuery('.boc_side_widget_close').on('click',function(){
		jQuery('#boc_menu_icon').trigger('click');
	});
		

	// Search in Header
	$('.header_search_icon').on('click',function(e){
		e.preventDefault();
		$('#search_wrapper').toggleClass('shown');
		setTimeout(function() {
				$('#header_search_field').focus();
		}, 1000);
	});
	$('#search-close').on('click',function(){
		$('#search_wrapper').toggleClass('shown');
	});	
	
	$('.testimonials').parents('.textwidget').css('paddingBottom',0);

	// Top Comment class
	$('.single_comment:first').addClass('first_comment');
	
	// Footer Navigation pushoff
	$('#footer .menu').addClass('margined_left');
	$('#footer .menu').parent().prev('h3').addClass('margined_left');

	
	// TABS
	// First we build the tabs
	$('.resp-tabs-container .single_tab_div').each(function(){
		var title = $(this).attr('rel-title');
		// Replace spaces with dashes for ID
		var title_id = title.replace(/\s+/g, '-').toLowerCase();
		var icon = $(this).attr('rel-icon');
		var icon_html = (icon!=='') ? "<span class='icon "+ icon +"'></span> " : '';
		$(this).parent('.resp-tabs-container').prev('ul.resp-tabs-list').append('<li id="'+ title_id +'">'+ icon_html + title +'</li>');
	});
	
	$('.newtabs').each(function(){
		var type = $(this).hasClass("vertical")? "vertical" : "horizontal";
		$(this).easyResponsiveTabs({
			type: type,
			width: 'auto',
			fit: true,
			activate: function(e) {
				setTimeout(function() {
					$('.resp-accordion.resp-tab-active')[0].scrollIntoView();
				}, 500);
			},
		});
		$(this).animate({opacity: 1},200);
		
		// Check for page's hashtag, if it matches - click the tab
		if(window.location.hash) {
		  var hash = window.location.hash.substring(1); //Puts hash in variable, and removes the # character
		  $(this).find(':first-child').children(".resp-tab-item").each(function(){			
				if($(this).attr("id") == hash) {
					$(this).trigger('click');
				}
		  });
		}
	});


	/* Accordions */
	$(".accordion").on('click',function(){
		
		// Do we toggle siblings
		var no_sibling_toggle = $(this).parent('.acc_item').parent('.acc_holder').hasClass('no_sibling_toggle');
		if(!no_sibling_toggle){
			$(this).parent('.acc_item').siblings().children(".accordion_content").not($(this).siblings(".accordion_content")).slideUp(500,'easeInOutExpo');
			$(this).parent('.acc_item').siblings().children(".accordion").not($(this)).removeClass("active_acc");
		}
		$(this).next(".accordion_content").slideToggle(500,'easeInOutExpo');
		
		if($(this).hasClass('active_acc')){
			$(this).removeClass("active_acc");
		}else{
			$(this).addClass("active_acc");
		}
	});
	
	// Open Active accordion item when scrolled to	
	window.setTimeout(function(){
		$('.acc_is_open').waypoint(function () {
			if(!$(this).parent('.accordion').hasClass('active_acc')){
				$(this).trigger('click');
			}
		}, { offset:'85%',triggerOnce: true });
	}, 800);
	/* Accordions::END */


	/* Info Messages */
	$(".closable").each(function(){
		$(this).prepend('<a class="boc_i-close msg_icon"></a>');		
	});
	
	$("a.boc_i-close").on('click',function(){
		$(this).parent().fadeOut(600);
	});
	
	// If responsive mode is enabled set Variable
	if($('#wrapper').hasClass('responsive')) {
		var responsive_mode = true;
	}else {
		var responsive_mode = false;
	}

	// Tooltips
	$('.tooltipsy').tipsy({fade: true, gravity: 's'});


	// VC Image links, Replace PP with MFP
	$(".vc_single_image-wrapper").each(function(){
		if($(this).hasClass("prettyphoto")) {
			$(this).removeClass("prettyphoto").addClass("mfp_popup");
		}
	});


	// Magnific Popup Items
	$("a.mfp_popup").magnificPopup({
		type:'image',
		mainClass: 'boc_popup_fade',
		removalDelay: 200,
		fixedContentPos: false,
	});
	$(".mfp_gallery").each(function() {
		$(this).magnificPopup({
			delegate: "a.mfp_popup_gal",
			type:'image',
			gallery:{	
				enabled: true
			},
			mainClass: 'boc_popup_fade',
			removalDelay: 200,
			fixedContentPos: false,
		});
	});
	
	// For Videos, GMaps
	$("a.mfp_iframe_popup, .wpb_single_image.mfp_iframe_popup a").magnificPopup({
		type:'iframe',
		mainClass: 'boc_popup_fade',
		removalDelay: 200,
		fixedContentPos: false,
	});	 

    
	// WooCommerce product page custom gallery
	if(boc_woo_lightbox_enabled) {
		$(".boc_single_product .images").each(function() {
			$(this).magnificPopup({
				delegate: "a",
				type:'image',
				gallery:{	
					enabled: true
				},
				mainClass: 'boc_popup_fade',
				removalDelay: 200,
				fixedContentPos: false,
			});
		});
	}
	

    // Animate icons fading
	$('.footer_soc_icon').on('mouseover', function() {
			$(this).siblings('a').stop().fadeTo(100, 0.35);
		}).on('mouseleave', function() {
			$(this).siblings('a').stop().fadeTo(100, 1);
		}
	);

    // Resize Videos to Inherit parent width
    $(function() {

        var $allVideos = $("iframe[src*='//player.vimeo.com'], iframe[src*='//www.youtube.com'], iframe[src*='//www.youtu.be'], object, embed").not('.rev_slider iframe');

    	$allVideos.each(function() {
    		$(this)
    	    .attr('data-aspectRatio', this.height / this.width)
    	    .removeAttr('height')
    	    .removeAttr('width');
    	});

    	$(window).smartresize(function() {
    	  $allVideos.each(function() {
    		    var nWidth = $(this).parent().width();
				$(this).width(nWidth).height(nWidth * $(this).attr('data-aspectRatio'));
    	   });
    	}).resize();
    });

	
	// Custom BOC Waypoints
	
	// Bar graph
	$('.bar_graph.boc_animate_when_almost_visible_custom_start:not(.boc_start_animation)').waypoint(function () {
		var b_width = $(this).find("span").attr("data-width");
		$(this).addClass('boc_start_animation');
			$(this).find("span").animate({width: b_width+"%"},1600,"easeOutCubic");
			$(this).find("span strong").animate({opacity: 1},1600,"easeOutCubic");	
	}, { offset:'85%',triggerOnce: true });


	// Add Delays for specific theme elements	
	
	// Portfolio, Post Items (.info_item, .post_item_block) - for carousels
	$('.info_block').each(function(i, e) {
		$(e).find('.info_item.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 250;
			$(e).trans(i * delay + 'ms', '-delay');
		});
	});
	
	// Further timing available in elements like post carousel
	$('.posts_carousel_holder').each(function(i, e) {
		$(e).find('.post_item_block.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 160;
			$(e).trans(i * delay + 'ms', '-delay');
		});
	});

	// Portfolio, Post Items (.info_item) - for grids & portfolio page
	$('.grid_holder.animated_items').each(function(i, e) {
		$(e).find('.portfolio_animator_class, .post_item_block').each(function (i, e) {
			var delay = 160;
			$(e).trans(i * delay + 'ms', '-delay');
		});
	});
	
	// Show all Portfolio, Post child elements at once for Grids
	window.setTimeout(function(){
		$('.grid_holder.animated_items').each(function() {
			$(this).waypoint(function () {
				$(this).find('.portfolio_animator_class, .post_item_block').addClass('boc_start_animation');
			}, { offset:'85%',triggerOnce: true });
		});
	}, 300);


	// Image Gallery
	$('.boc_image_gallery').each(function (i, e) {
		var delay = 200;
		$(e).find(".col").each(function (i, e) {
			$(e).trans(i * delay + 'ms', '-delay');
		});
	});

	// Logo Gallery
	$('.logo_gallery').each(function (i, e) {
		var delay = 200;
		$(e).find(".col").each(function (i, e) {
			$(e).trans(i * delay + 'ms', '-delay');
		});
	});	
	
	
	// Add Delays for Identical elements on a single Row
	$('.vc_row').each(function(i, e) {
		
		// Price Columns
		$(e).find('.price_column.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 300;
			$(e).trans(i * delay + 'ms', '-delay');
		});

		// Person
		$(e).find('.team_block_content.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 300;
			$(e).trans(i * delay + 'ms', '-delay');
		});

		// Top Icon Box
		$(e).find('.top_icon_box:not(.type7):not(.type8):not(.type9).boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 300,
			stagger = 200 + i*500;

			// Each child
			$(this).children().each(function (i, e) {

				if(!$(this).is(".back_icon") || !$(this).is(".back_icon")){
					if(!$(this).is("a")){
						$(e).trans(i * delay + stagger + 'ms', '-delay');
					}else {
						$(e).children('.icon_holder').trans(i * delay + stagger + 'ms', '-delay');
					}
				}
			});
		});	
		// Top Icon Box 7,8
		$(e).find('.top_icon_box.type7.boc_animate_when_almost_visible:not(.boc_start_animation),.top_icon_box.type8.boc_animate_when_almost_visible:not(.boc_start_animation),.top_icon_box.type9.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 100,
			stagger = 200 + i*200;

			// Each Box
			$(this).trans(i * delay + stagger + 'ms', '-delay');
		});	
		
		
		// Icon Info Box
		$(e).find('.icon_info_box.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 100,
			stagger = 200 + i*200;

			// Each Box
			$(this).trans(i * delay + stagger + 'ms', '-delay');
		});	
		
		// Image with Icon
		$(e).find('.boc_image_with_icon.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 100,
			stagger = 200 + i*150;

			// Each Box
			$(this).trans(i * delay + stagger + 'ms', '-delay');
		});	
		
		// Images
		$(e).find('.wpb_single_image.wpb_boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 100,
			stagger = i*170;

			// Each Box
			$(this).trans(i * delay + stagger + 'ms', '-delay');
		});

		// Image Boxes
		$(e).find('.boc_image_box.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 100,
			stagger = i*170;

			// Each Box
			$(this).trans(i * delay + stagger + 'ms', '-delay');
		});	
		
		
		// Side Icon Box
		$(e).find('.side_icon_box.boc_animate_when_almost_visible:not(.boc_start_animation)').each(function (i, e) {
			var delay = 150,
			stagger = 200 + i*300;
		
			// Each child
			$(this).children().each(function (i, e) {
				
				if(!$(this).is("a")){
					$(e).trans(i * delay + stagger + 'ms', '-delay');
				}else {
					$(e).children('.icon_holder').trans(i * delay + stagger + 'ms', '-delay');
				}
			});
		});

		// Counters
		$(e).find('.single_numbers_holder.boc_anim_hidden').each(function (i, e) {

			$(this).waypoint(function () {
				var delay = 600;
				setTimeout(function(){
					$(e).find(".counter").each(function (i, e) {
						var end_nu = $(e).find(".counter_hidden:first").attr("data-end-nu");
						$(e).flipCounter("startAnimation", { end_number: end_nu, duration: 1200 }).find(".counter_desc").addClass("shown");
					});
				}, i * delay );
				$(this).addClass('boc_start_animation');
				
			}, { offset:'80%',triggerOnce: true });		
		});

		// Circular Counter
		$(e).find('.circ_numbers_holder').each(function (i, e) {
			
			$(this).waypoint(function () {
				var delay = 500;
				setTimeout(function(){
				
					$(e).find(".circ_counter").each(function (i, e) {
							var end_nu = parseInt($(e).find("canvas:first").attr("data-end-nu"));
							var white_text = $(e).data('white_text');
							var size = $(e).data('size');
							var angle = ($(e).data('angle') !== '') ? 0 : 0.49;

							var opts = {
								lines: 1, // The number of lines to draw
								angle: angle, // The length of each line
								lineWidth: 0.03, // The line thickness
								colorStart: $(e).data('color'),
								colorStop: $(e).data('color'),    // just experiment with them
								strokeColor: (white_text ? "rgba(0,0,0,0.1)" : "#f5f5f5"),   // to see which ones work best for you
								shadowColor: (white_text ? "rgba(0,0,0,0.1)" : "#eeeeee"),
							};
						
							$(e).find("canvas:first").gauge(opts, end_nu);
							$(e).find(".counter_percent_sign:first").addClass("shown");

					});
				}, i * delay );	
				
			}, { offset:'80%', triggerOnce: true });
		});	

	});
	
	
	// Highlights
	setTimeout(function(){
		$('.hilite:not(.no_show)').waypoint(function () {
			$(this).addClass('show_hilite');
		}, { offset:'85%',triggerOnce: true });
	}, 600 );
	
	
	// Add wrapper for unroll animations
	$('.boc_animate_when_almost_visible:not(.boc_start_animation, .post_item_block )').each(function () {
		
		// Add parent wrapper for Unroll animation
		if($(this).hasClass('boc_bottom-unroll')) {
			$(this).wrap( "<div class='boc_animation_wrapper'></div>" );
			
			// Apply margins to parent to preserve animation clipping
			$(this).parent().css({"marginBottom": parseInt($(this).css("marginBottom")), "marginTop": parseInt($(this).css("marginTop"))});
			$(this).css({"marginBottom": 0, "marginTop": 0});

			// Apply display value to parent
			$(this).parent().css('display',$(this).css("display"));
		}
	});
	// Waypoints for animation_wrappers
	setTimeout(function() {
		$('.boc_animation_wrapper').waypoint(function () {
			// Add manual delay if one was set
			var delay = parseInt($(".boc_animate_when_almost_visible", this).data("css_delay"));
			if(delay > 0) {
				$(".boc_animate_when_almost_visible", this).trans(delay + 'ms', '-delay');
			}
			
			$(".boc_animate_when_almost_visible", this).addClass('boc_start_animation');
			// If it's a button - disable delay after it animates in
			if($(".boc_animate_when_almost_visible", this).hasClass('button')) {
				$(this).addClass('btn_wrapper');
				var that = $(".boc_animate_when_almost_visible", this);
				setTimeout(function() {
					that.trans(0 + 'ms', '-delay');
				}, delay + 20);
			}

		}, { offset:'85%',triggerOnce: true });
	}, 400);


	// GLOBAL BOC Waypoints 
	setTimeout(function() {
		$('.boc_animate_when_almost_visible:not(.boc_start_animation, .post_item_block )').waypoint(function () {
			// Add manual delay if one was set
			var delay = parseInt($(this).data("css_delay"));
			if(delay!="undefined") {
				$(this).trans(delay + 'ms', '-delay');
			}
			$(this).addClass('boc_start_animation');
			// If it's a button - disable delay after it animates in
			if($(this).hasClass('button')) {
				var that = $(this);
				setTimeout(function() {
					that.trans(0 + 'ms', '-delay');
				}, delay + 20);
			}

		}, { offset:'85%',triggerOnce: true });
	}, 400);


	// Custom Waypoints (Carousels) - start animation upon activation of items
	setTimeout(function() {
		$('.boc_animate_when_almost_visible.post_item_block:not(.boc_start_animation)').waypoint(function () {
			if($(this).parent().hasClass("active")){
				$(this).addClass('boc_start_animation');
			}
		}, { offset:'85%',triggerOnce: true });
	}, 800);


	// Create Image Hover effect for Class
	$('.img_zoom_on_hover').each(function (i, e) {
		$(e).find("a").each(function (i, e) {
			$(e).wrap("<div class='pic'></div>");
			$(e).find("img").after('<div class="img_overlay theme_color"><span class="hover_icon icon_plus"></span></div>');
		});
	});	
	
	// Create Image Hover effect for products	
	$('.boc_single_product .single_product_left img').each(function (i, e) {
		$(e).wrap("<div class='pic'></div>").after('<div class="img_overlay theme_color"><span class="hover_icon icon_plus"></span></div>');
	});
	// Wrap imgs in a pic div
	$('.woocommerce .products .product').each(function (i, e) {
		$(e).find('img').wrapAll("<div class='pic'></div>");
	});
	// Add bgr effect
	$('.woocommerce .products .product').each(function (i, e) {
		$(e).prepend("<div class='product_bgr_pop'></div>");
	});
	
	if($('.widget.woocommerce .product-categories').boc_doesExist()){
		// Categories count
		$('.widget.woocommerce .product-categories li a').on('mouseover',function(){
			$(this).next().addClass('cat_hovered');
		}).on('mouseleave', function() {
			$(this).next().removeClass('cat_hovered');
		});
		$('.widget.woocommerce .product-categories li .count').each(function(){
			var replaced = $(this).html().replace(/\s|\(|\)/g,"");
			$(this).html(replaced).css('opacity',1);
		});
	}



	// Animated Headlines Prep
	$(".cd-headline").each(function(){
		// Rem default inner span
		$(this).children('span').contents().unwrap();
		
		var $words_span = $('<span class="cd-words-wrapper"></span>');
		$(this).find('b').first().addClass('is-visible').before($words_span);
		
		$(this).find('b').detach().each(function(i,e){
			$words_span.append($(e));
		});
		
		$(this)
		  .contents()
		  .filter(function() {
			if(this.nodeType === 3) { //Node.TEXT_NODE
				$(this).wrap('<span></span>');
			}
		});

	});


	// Animated Headlines Init
	boc_AH.init();

	
	// Typewriter Animated Headline
	$(".typewriter").each(function(){
		var array_texts = [];
		var style_attr = $(this).find('b:first').attr('style');
		var back_delay = 	(typeof $(this).find('b:first').attr("data-backdelay") != 'undefined') 	? parseInt($(this).find('b:first').attr("data-backdelay")) : 4000;
		var type_speed = 	(typeof $(this).find('b:first').attr("data-typespeed") != 'undefined') 	? parseInt($(this).find('b:first').attr("data-typespeed")) : 80;
		var start_delay = 	(typeof $(this).find('b:first').attr("data-startdelay") != 'undefined') ? parseInt($(this).find('b:first').attr("data-startdelay")) : 300;
		var loop_count = 	(typeof $(this).find('b:first').attr("data-loopcount") != 'undefined') ? parseInt($(this).find('b:first').attr("data-loopcount")) : 1;
		
		$(this).find('b').each(function(){
			array_texts.push($(this).text());
		});
		$(this).find('b').wrapAll("<span class='typewriter_txt'>");
		$(this).find('.typewriter_txt').text('').attr('style', style_attr);
		
		// If no CSS animation
		if(!$(this).hasClass('boc_animate_when_almost_visible')) {
			
			var that = $(this);
			setTimeout(function() {
				that.waypoint(function() {
					that.animate({ opacity: 1 });
					that.find('.typewriter_txt').typed({
						strings: 	array_texts,
						backDelay: 	back_delay,
						typeSpeed: 	type_speed,
						startDelay: start_delay,
						loop: 		true,
						loopCount: 	loop_count,
					});
				}, { offset:'90%',triggerOnce: true});
			}, 1000);
		}else {
			var delay = parseInt($(this).data("css_delay"));
			if(delay!="undefined") {
				$(this).trans(delay + 'ms', '-delay');
			}
			$(this).waypoint(function() {
					$(this).find('.typewriter_txt').typed({
						strings: 	array_texts,
						backDelay: 	back_delay,
						typeSpeed: 	type_speed,
						startDelay: start_delay,
						loop: 		true,
						loopCount: 	loop_count,
					});
			}, { offset:'90%',triggerOnce: true});
		}
		
	});	
	
	
	// Resize Sticky Header + Manage Transparent Logos
	function headerResize() {
		var win_width = getWindowWidth();
		if(win_width >= 1018){
			var window_y = $(window).scrollTop();
			if(window_y >= (header_h - 20)){
				$('#header').addClass('scrolled');
			}else {	
				$('#header').removeClass('scrolled');
			}
		}
	}
	
	// Header resizing - check if mobile_header is visible instead of boc_is_mobile to support ipad pro
	if(sticky_header && $('#mobile_header:hidden')){
		headerResize();
		$(window).scroll(function () {
			headerResize();
		});
	}
	
	// Header and footer distance
	if(!boc_is_mobile){
		$(window).smartresize(function() {

			var win_width = getWindowWidth();
			if(win_width >= 1018){
				if(sticky_header && !transparent_header && ($('#header').boc_doesExist())){
					// Since full_header_h will not always be correct if page is scrolled : we take larger than calculated and settings value
					var full_header_h = Math.max((Number(bocJSParams.header_height) + $('#subheader').parent('.full_header').outerHeight()), $('#header').outerHeight());
					$('.content_body').css('marginTop', full_header_h + 'px');	  
				}
				var footer_h = $('#footer').height();
				// If widget columns - add their spacing
				if($('#footer .section').boc_doesExist()){
					footer_h += 52;
				}
				
				if(fixed_footer && ($('#footer').boc_doesExist())){
					$('.content_body').css('marginBottom', footer_h - 1 + 'px');
				}
			}else {
				$('.content_body').css('marginTop', 0);	
				$('.content_body').css('marginBottom', 0);
			}
		});
	} else { // Big Mobile Screens TODO ????
		$(window).smartresize(function() {

			var win_width = getWindowWidth();
			if(win_width >= 1018){
				if(sticky_header && !transparent_header && ($('#header').boc_doesExist())){
					// Since full_header_h will not always be correct if page is scrolled : we take larger than calculated and settings value
					var full_header_h = Math.max((Number(bocJSParams.header_height) + $('#subheader').parent('.full_header').outerHeight()), $('#header').outerHeight());
					$('.content_body').css('marginTop', full_header_h + 'px');	  
				}

			}else {
				$('.content_body').css('marginTop', 0);	
			}
		});
	}
	

	// Hide Preloader if it is set
	if ($('#boc_page_preloader').boc_doesExist()){
		$(window).load(function(){
			boc_hide_page_preloader();
		});
	}


	/* ----------- WooCommerce Cart ------------ */

	var notification_timeout;
	var productName;

	// Add top padding to product page if there's no pageheading
	if(!$('.full_container_page_title').boc_doesExist()) {
		$('.boc_single_product').animate({paddingTop: 40},500);
	}
	
	// Feed Product name to notification
	$('.woocommerce .product .add_to_cart_button').on('click',function(){
		if($(this).parents('li').find('h2').boc_doesExist()) {
			productName = $(this).parents('li').find('h2').text();
		}else {
			productName = $(this).parents('li').find('h3').text();
		}
		$('.header_cart .cart-notification span.item-name').html(productName);
	});

	// Notification
	$('.header_cart .cart-notification').on('mouseover', function(){
		$(this).fadeOut(400);
		$('.header_cart .widget_shopping_cart').stop(true,true).fadeIn(300);
		$('.header_cart .cart_list').stop(true,true).fadeIn(300);
		clearTimeout(notification_timeout);
	});

	// Header cart
	$('.header_cart').on('mouseover',function(){
		var win_width = getWindowWidth();
		if(win_width >= 1018){
			$('.header_cart .widget_shopping_cart').stop(true,true).fadeIn(300);
			$('.header_cart .cart_list').stop(true,true).fadeIn(300);
			clearTimeout(notification_timeout);
			$('.header_cart .cart-notification').fadeOut(200);
		}
	}).on('mouseleave', function() {
		$('.header_cart .widget_shopping_cart').stop(true,true).fadeOut(200);
		$('.header_cart .cart_list').stop(true,true).fadeOut(200);
	});


	$('body').on('added_to_cart', shopping_cart_notification_show);
	$('body').on('added_to_cart', shopping_cart_dropdown);
	
	
	function shopping_cart_dropdown() {
		
		setTimeout(function(){ 
			if(!$('.header_cart .widget_shopping_cart .widget_shopping_cart_content .cart_list .empty').length && $('.header_cart .widget_shopping_cart .widget_shopping_cart_content .cart_list').length > 0 ) {
				
				$('.header_cart').removeClass('is_empty').addClass('is_not_empty');
				
			}else {
				$('.header_cart').addClass('is_empty').removeClass('is_not_empty');
			}
		},400);
	}

	function shopping_cart_notification_show(e) {
	
		setTimeout(function(){ 
			clearTimeout(notification_timeout);
			
			if(!$('.widget_shopping_cart .widget_shopping_cart_content .cart_list .empty').length && $('.widget_shopping_cart .widget_shopping_cart_content .cart_list').length > 0 && typeof e.type != 'undefined' ) {

				setTimeout(function(){ $('.header_cart .cart-notification').fadeIn(400); },200);
				notification_timeout = setTimeout(hide_notification, 3500);
			}
		},400);
	}

	function hide_notification() {
		$('.header_cart .cart-notification').stop(true,true).fadeOut();
	}

	/* ----------- WooCommerce Cart :: END ------------ */


	// Smoothscroll for Single Page
	var boc_scroll = new SmoothScroll('[rel="smooth_scroll"],[rel="gumshoe_scroll"]', {
		// Speed & Duration
		speed: 300, 
		clip: true,
	});
	
	setTimeout(function(){
		var menu_spy = new Gumshoe('.boc_main_menu a[rel="gumshoe_scroll"]',{
			// Active classes
			navClass: 'is-selected', // applied to the nav list item
			contentClass: 'section-active',
		});		
	}, 700);
	
	
	// Scroll to Top
	if($('.boc_scroll_to_top').boc_doesExist()){
		$(window).smartscroll(function(e) {
			var scr_to_top = $(this).scrollTop();

			if(scr_to_top > 800){
				$('.boc_scroll_to_top').addClass('shown');
			}else {
				$('.boc_scroll_to_top').removeClass('shown');		  
			}
		});
		
		$('.boc_scroll_to_top').on('click',function(e) {
			boc_scroll.animateScroll(0, null,{ speed: 400, easing: 'easeOutQuad' });
		});
	}	
	
	
	// If mobile and gumshoe Single page - close the mobile menu on click
	$('.mobile_menu_ul a[rel=gumshoe_scroll]').on('click',function(){
		if(boc_is_mobile){
			jQuery('#mobile_menu_toggler').trigger('click');
		}
	});
	
	// Push header down for admin bar
	$(window).smartresize(function() {
		pushHeaderAdminBar();
	});	
	
	// Parallax Scroll	
	function boc_parallaxScroll(){
		var o=function(){
			if($(window).width() > 768){
				var o=$(window).height(),e=$(document).scrollTop();
				$(".parallax_scroll_me").each(
					function(s,t){
						var a=$(t);
						
						// Get speed
						var classNames = a.attr('class').split(/\s+/);
						// Set default
						var speedClass = "speed_20";
						$.each(classNames, function(index, item) {
							if(item.indexOf("speed_") == 0){
								speedClass = item;
							}
						});
						var speed = parseInt(speedClass.substring(6))/100;
						var n=(a.offset().top+50,speed);
						if(e > a.offset().top-o)
							var r=e-(a.offset().top-o);
						else 
							var r=0;
						
						r*=-n,a.css({"-webkit-transform":"translate3d(0, "+1.2*r+"px, 0)","-moz-transform":"translate3d(0, "+ Math.round(1.2*r) +"px, 0)","-ms-transform":"translate3d(0, "+Math.round(1.2*r) +"px, 0)",transform:"translate3d(0, "+ Math.round(1.2*r) +"px, 0)"})})}
						
			else $(".parallax_scroll_me").css({"-webkit-transform":"","-moz-transform":"","-ms-transform":"",transform:""})
		};

		o(),$(window).on("scroll",function(){o()}),$(window).on("resize",function(){o()})
	}
	
	$(function(){
		if($(".parallax_scroll_me").boc_doesExist()){
			boc_parallaxScroll();
		}
	});	
	
	
});



// Isotope Grid
jQuery(window).load(function(){
	jQuery(function($){
		"use strict";
		$(".grid_holder:not(.rtl_grid)").each( function(i, e){
			
			// If found in Tabs, do not isotope
			if (! $(e).parents('.newtabs').boc_doesExist()) {
			
				var $container = $(e);
				var cols = $(e).attr('data-columns');

				var win_width = getWindowWidth();

				// Each column height settings for gutter grids - only for Metro portfolio grids && for spaced grids && for certain styles, only for Desktop and large Res. 
				if(!boc_is_mobile && (win_width >= 1281)){
					if($(e).hasClass('grid_type_metro') && ($(e).hasClass('small_spacing') || $(e).hasClass('big_spacing')) && ($(e).hasClass('p_style_type7') || $(e).hasClass('p_style_type8'))){
						var gutter = ( $(e).hasClass('small_spacing') ? 8 : 30 );
						var reg_col_h = $(e).children('.col.span_1_of_4:not(.tall_col)').first().height() - gutter;
						
						$(e).children('.col').each( function(i, e){
							$(e).attr('data-default-height',$(e).height());
							if($(e).hasClass('tall_col')){
								$(e).height(reg_col_h*2 + gutter);
							}else{
								$(e).height(reg_col_h);
							}
						});
					}
				}
				
				// Init Isotope
				$container.isotope({
				  masonry: {
					columnWidth: '.span_1_of_' + cols,
					stagger: 30,
					transitionDuration: 500,
				  }
				});

				// On Resize
				$(window).smartresize( function() {
					var win_width = getWindowWidth();
					// Rescale only if resized to smaller grid
					if(!boc_is_mobile && (win_width < 1281)){
						setTimeout(function() {
							$(e).children('.col').each( function(i, e){
								$(e).height('auto');
							});

							// ReINIT Grid
							$container.isotope({
							  masonry: {
								columnWidth: '.span_1_of_' + cols,
								stagger: 30,
								transitionDuration: 500
							  }
							});
							
						},400);
					}
				});
				
				
				// Category Filters
				var $optionLinks = $container.prev().find(".grid_filter_inline").find("li div");

				$optionLinks.on('click',function(){
					var selector = $(this).attr("data-option-value");
					$container.isotope({ 
						filter: selector,
						stagger: 30,
						transitionDuration: 500
					});
					$container.prev().find(".grid_filter_inline li div").removeClass("current_portfolio_item");
					$(this).addClass("current_portfolio_item");
				
					return false;
				});
			}
		});				
	});
});


// Check if element(s) exist
jQuery.fn.boc_doesExist = function(){
	return jQuery(this).length > 0;
};


/* Hide Preloader function */
function boc_hide_page_preloader(){
	
	jQuery('#boc_page_preloader').css('opacity', 0);
	setTimeout(function(){
		jQuery('#boc_page_preloader').remove();
	}, 600);
}


//On Page load calculate header spacing for admin bar
jQuery(window).load(function(){
	"use strict";
	pushHeaderAdminBar();
});


// Custom WindowWidth method, will use instead of $(window).width() cuz scroll messes it up
function getWindowWidth() {
	return window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
}


function pushHeaderAdminBar() {
	var wp_adm_h = jQuery('#wpadminbar').height();
	if(sticky_header){

		if(jQuery('#wpadminbar').boc_doesExist() && (jQuery('#wpadminbar').css('display')!='none')) {
			if(!boc_is_mobile){
				jQuery('#header').css('marginTop', wp_adm_h + 'px');
			}
		}

	}else if(transparent_header && !boc_is_mobile) {
		jQuery('#header.transparent_header').css('marginTop', wp_adm_h + 'px');
	}
}

//On Page load calculate footer spacing
if(!boc_is_mobile){
	if(jQuery('#footer').boc_doesExist()){
		jQuery(window).load(function(){
			"use strict";
			var win_width = getWindowWidth();
			if(win_width >= 1018){
				var footer_h = jQuery('#footer').height();
				// If widget columns - add their spacing
				if(jQuery('#footer .section').boc_doesExist()){
					footer_h += 52;
				}
				if(fixed_footer){
					jQuery('.content_body').css('marginBottom', footer_h + 'px');
				}
			}else {
				jQuery('.content_body').css('marginBottom', 0);
			}
		});
	}
}

// For Animation transitions
jQuery.fn.trans = function () {
	var t = arguments[0],
		d = arguments[1] || '';
	if (t) {
		jQuery.each(this, function (i, e) {
			jQuery(['-webkit-', '-moz-', '-o-', '-ms-', '']).each(function (i, p) {
				jQuery(e).css(p + 'transition' + d, t);
			});
		});
	}
};

function boc_preloadImages(imgs, callback) {
	
	var cache = [],
		imgsTotal = imgs.length,
		imgsLoaded = 0;

	// If IE start off animations right away
	var ua = window.navigator.userAgent;
    var msie = ua.indexOf('MSIE ');	
	var trident = ua.indexOf('Trident/');
	
	if (msie > 0) {
        callback();
    }
    if (trident > 0) {
        callback();
    }
		
	if(jQuery(imgs).length){
		jQuery(imgs).each(function (i, img) {
			var cacheImage = document.createElement('img');
						
			cacheImage.onload = function () {
				if (++imgsLoaded == imgsTotal) callback();
			};
			cacheImage.src = jQuery(img).attr('src');
						
			cache.push(cacheImage);
		});
	}else {
		callback();
	}
}

// Ham Menu
function boc_menu_icon_init() {

	var	$mobile_toggleButton = jQuery('#mobile_boc_menu_icon');
	var	$menuButtonBars = jQuery('.boc_menu_icon_ham');

	// Side Widget SlideToggle
	jQuery('#boc_menu_icon, #mobile_boc_menu_icon').on('click',function(){
		jQuery('#boc_menu_icon, #mobile_boc_menu_icon').toggleClass('active_mobile_menu');
		jQuery('.boc_side_widget').toggleClass("active_side_widget");
		jQuery('#wrapper').toggleClass("active_side_widget");
    	jQuery('body').toggleClass('block_body_mobile');

		// Change ham button style
		if(jQuery('#boc_menu_icon').hasClass('active_mobile_menu')){
			$menuButtonBars.removeClass('button_closed');
			$menuButtonBars.addClass('button_open');
			jQuery("#boc_menu_icon_ham_1").addClass("boc_menu_icon_ham_1_open");
			jQuery("#boc_menu_icon_ham_2").addClass("boc_menu_icon_ham_2_open");
			jQuery("#boc_menu_icon_ham_3").addClass("boc_menu_icon_ham_3_open");
			jQuery("#mobile_boc_menu_icon_ham_1").addClass("boc_menu_icon_ham_1_open");
			jQuery("#mobile_boc_menu_icon_ham_2").addClass("boc_menu_icon_ham_2_open");
			jQuery("#mobile_boc_menu_icon_ham_3").addClass("boc_menu_icon_ham_3_open");
		}else{
			$menuButtonBars.removeClass('button_open');
			$menuButtonBars.addClass('button_closed');
			jQuery("#boc_menu_icon_ham_1").removeClass("boc_menu_icon_ham_1_open");
			jQuery("#boc_menu_icon_ham_2").removeClass("boc_menu_icon_ham_2_open");
			jQuery("#boc_menu_icon_ham_3").removeClass("boc_menu_icon_ham_3_open");
			jQuery("#mobile_boc_menu_icon_ham_1").removeClass("boc_menu_icon_ham_1_open");
			jQuery("#mobile_boc_menu_icon_ham_2").removeClass("boc_menu_icon_ham_2_open");
			jQuery("#mobile_boc_menu_icon_ham_3").removeClass("boc_menu_icon_ham_3_open");
		}
	});
}

// Center logo in header
function boc_center_logo_in_header() {
	jQuery(document).ready(function() {
		"use strict";
		var top_level_items = jQuery('ul.boc_main_menu > li').size();
		var i = 0;

		jQuery('ul.boc_main_menu > li').each(function() {
			i++;
			if(i == Math.round(top_level_items/2)) {
				// Force to inherit height as it gets lost in the moving
				jQuery( "#logo > .logo_img > a" ).css('height',jQuery( "#logo" ).height());
				jQuery( "#logo" ).insertAfter( jQuery(this) );
				
				boc_align_midlogo_to_center();
			}
		});
		// If no main nav - center logo
		if(!jQuery('#menu .boc_main_menu').boc_doesExist()) {
			jQuery( "#logo" ).addClass('no_menu_center_logo');
		}
		jQuery('#wrapper.menu_midlogo #header').animate({opacity: 1}, 300);
	});
}

// Some math to position menu so that logo is in the center of header
function boc_align_midlogo_to_center() {
	
	var is_rtl = jQuery('body').hasClass('rtl');
	
	if(is_rtl){
		jQuery('.boc_main_menu').css('right', 0);
	}else{
		jQuery('.boc_main_menu').css('left', 0);
	}
	var win_w = getWindowWidth();
	var logo_w = jQuery('#wrapper.menu_midlogo .boc_main_menu #logo').outerWidth();

	var logo_should_be_pos = (win_w/2 - logo_w/2);
	
	if(is_rtl){
		var logo_curr_pos = win_w - (jQuery('#wrapper.menu_midlogo .boc_main_menu #logo').offset().left + jQuery('#wrapper.menu_midlogo .boc_main_menu #logo').outerWidth());
		jQuery('.boc_main_menu').css('right', parseInt(logo_should_be_pos - logo_curr_pos));	
	}else{	
		var logo_curr_pos = jQuery('#wrapper.menu_midlogo .boc_main_menu #logo').offset().left;
		jQuery('.boc_main_menu').css('left', parseInt(logo_should_be_pos - logo_curr_pos));	
	}


	// Megamenu set position and width
	var menu_w = jQuery('.boc_main_menu').width();

	var menu_offset 	= jQuery('.boc_main_menu ').offset();
	var header_offset 	= jQuery('#menu').offset();

	var header_w = jQuery('#menu').width();

	if(is_rtl){
		jQuery('.megamenu > .sub-menu').css({
			'width': jQuery('#menu').width(),
			'right': -((win_w -(menu_offset.left + jQuery('.boc_main_menu ').outerWidth())) - (win_w - (header_offset.left + jQuery('#menu ').outerWidth())))
		});
	}else {
		jQuery('.megamenu > .sub-menu').css({
			'width': jQuery('#menu').width(),
			'left': -(menu_offset.left - header_offset.left)
		});
	}
}



// Mobile Menu
function mobile_menu_init() {

	var $toggleButton = jQuery('#mobile_menu_toggler');
		$menuButton = jQuery('#m_nav_menu');
		$menuButtonBars = jQuery('.m_nav_ham');

	// Mobile Menu SlideToggle
	$toggleButton.on('click',function(){		
		jQuery(this).toggleClass('active_mobile_menu');
		jQuery('#mobile_menu').toggleClass('mobile_menu_active');
		jQuery('body').toggleClass('noscroll');
	});

	// Change Button style
	$toggleButton.on("click", function(){
		if($toggleButton.hasClass('active_mobile_menu'))
		{	
			$menuButtonBars.removeClass('button_closed');
			$menuButtonBars.addClass('button_open');
			jQuery("#m_ham_1").addClass("m_nav_ham_1_open");
			jQuery("#m_ham_2").addClass("m_nav_ham_2_open");
			jQuery("#m_ham_3").addClass("m_nav_ham_3_open");
		}
		else
		{
			$menuButtonBars.removeClass('button_open');
			$menuButtonBars.addClass('button_closed');
			jQuery("#m_ham_1").removeClass("m_nav_ham_1_open");
			jQuery("#m_ham_2").removeClass("m_nav_ham_2_open");
			jQuery("#m_ham_3").removeClass("m_nav_ham_3_open");
		}
	});
}


// Check for Particles Animation
jQuery(window).load(function(){
	"use strict";
	if(jQuery('#particles_animation').boc_doesExist()) {
		if(jQuery('#particles_animation').hasClass("particles_on_top")){
			particlesJS('particles_animation','particles_animation','top');
		}else {
			particlesJS('particles_animation','particles_animation','bottom');		
		}
	}
});


// Gumshoe Dotted Side Nav
jQuery(window).load(function(){
	"use strict";
	if(jQuery('#boc_vertical-nav').boc_doesExist()){
		
		// Each li - add delay
		jQuery('#boc_vertical-nav').find('li').each(function (i, e) {
			var delay = 100;
			jQuery(e).trans(i * delay + 'ms', '-delay');
		});
		
		// Make it wait for carousels etc to init
		setTimeout(function(){
			jQuery('#boc_vertical-nav').addClass('shown');
			var spy = new Gumshoe('#boc_vertical-nav a[rel="gumshoe_scroll"]',{
				// Active classes
				navClass: 'is-selected', // applied to the nav list item
				contentClass: 'section-active',
			});
		}, 700);
	}
});



/* Popup in the center - Social icons */
function bocPopupCenter(url, w, h) {
	var dualScreenLeft = window.screenLeft != undefined ? window.screenLeft : screen.left;
	var dualScreenTop = window.screenTop != undefined ? window.screenTop : screen.top;

	var width = window.innerWidth ? window.innerWidth : document.documentElement.clientWidth ? document.documentElement.clientWidth : screen.width;
	var height = window.innerHeight ? window.innerHeight : document.documentElement.clientHeight ? document.documentElement.clientHeight : screen.height;

	var left = ((width / 2) - (w / 2)) + dualScreenLeft;
	var top = ((height / 2) - (h / 2)) + dualScreenTop;
	var newWindow = window.open(url, '', 'toolbar=no,resizable=yes,scrollbars=yes, width=' + w + ', height=' + h + ', top=' + top + ', left=' + left);

	// Puts focus on the newWindow
	if (window.focus) {
		newWindow.focus();
	}
}


// SmartResize Method
(function($,sr){
  var debounce = function (func, threshold, execAsap) {
	  var timeout;

	  return function debounced () {
		  var obj = this, args = arguments;
		  function delayed () {
			  if (!execAsap)
				  func.apply(obj, args);
			  timeout = null;
		  };

		  if (timeout)
			  clearTimeout(timeout);
		  else if (execAsap)
			  func.apply(obj, args);

		  timeout = setTimeout(delayed, threshold || 150);
	  };
  }
  // smartresize 
  jQuery.fn[sr] = function(fn){  return fn ? this.bind('resize', debounce(fn)) : this.trigger(sr); };

})(jQuery,'smartresize');




// SmartScroll
(function($, sr){

    var debounce = function (func, threshold, execAsap) {
        var timeout;

        return function debounced () {
            var obj = this, args = arguments;

            function delayed () {
                if (!execAsap)
                    func.apply(obj, args);
                timeout = null;
            }

            if (timeout)
                clearTimeout(timeout);
            else if (execAsap)
                func.apply(obj, args);

            timeout = setTimeout(delayed, threshold || 100);
        };
    };
    // smartscroll
    jQuery.fn[sr] = function(fn, threshhold){  return fn ? this.bind('scroll', debounce(fn, threshhold)) : this.trigger(sr); };

})(jQuery,'smartscroll');
