<?php
/**
 * Template Name: Portfolio Page
 *
 * A Full Width custom page template without sidebar.
 * @package WordPress
 */

get_header(); ?>

	<div class="container">
		<div class="section">
			<?php while (have_posts()) : the_post(); ?>
				<?php the_content(); ?>
			<?php endwhile; ?>
		</div>
	</div>
	
	<div class="container">
		
	<?php if(function_exists('boc_portfolio_register')){ ?>
		
		<div class="section portfolio_section">
				
				<?php
				$portfolio_category = get_terms('portfolio_category');
				$portfolio_hover_icon = (ot_get_option('portfolio_hover_icon','on') == 'on') ? '' : 'hide_hover_icon';

				if($portfolio_category): ?>
						<div id="portfolio_filter">
							<span id="current_filter"><?php esc_html_e('All', 'alea');?></span>
							<ul id="filter_list"  data-option-key="filter">
							<?php foreach($portfolio_category as $portfolio_cat): ?>		
								<li><div data-option-value=".<?php echo esc_attr($portfolio_cat->slug); ?>"><?php echo esc_html($portfolio_cat->name); ?></div></li>
							<?php endforeach; ?>			        
								<li><div data-option-value="*"><?php esc_html_e('All', 'alea');?></div></li>
							</ul>
						</div>			
				
				<?php endif; ?>

				<?php $portfolio_items_spacing = ot_get_option('portfolio_items_spacing','big_spacing');?>
		
				<div data-columns="3" class="portfolio_grid grid_holder animated_items <?php echo esc_attr($portfolio_hover_icon);?> <?php echo esc_attr($portfolio_items_spacing); ?>">
				<?php 

					$portfolio_style = ot_get_option('portfolio_style') ? ot_get_option('portfolio_style') : 'type1';
					// Img Hover Effect
					$portfolio_img_hover_effect = 'img_hover_effect'.ot_get_option('portfolio_img_hover_effect','2');
					
					$limit = (int)ot_get_option('portfolio_items_per_page',9);
					$portfolio_order = esc_html(ot_get_option('portfolio_order','DESC'));
					$portfolio_orderby = esc_html(ot_get_option('portfolio_orderby','date'));
					
					$gallery = boc_get_portfolio_items($limit, $portfolio_orderby, $portfolio_order, '', $paged);
		
					while($gallery->have_posts()): $gallery->the_post();
						if(has_post_thumbnail()):
		
							$data_types = '';
							$cats = array();
							
							$item_cats = get_the_terms($post->ID, 'portfolio_category');
							if($item_cats):
							foreach($item_cats as $item_cat) {
								$data_types .= $item_cat->slug . ' ';
								$cats[] = esc_html($item_cat->name);
							}
						endif;

						$portfolio_img_size = ot_get_option('portfolio_img_size','boc_medium');
				?>
						<div class="col span_1_of_3 info_item isotope_element <?php echo esc_attr($data_types);?>">
							<a href="<?php the_permalink(); ?>" class="pic_info_link_<?php echo esc_attr($portfolio_style);?>">
							  <div class="portfolio_animator_class boc_anim_hidden boc_right-to-left">
								<div class="pic_info <?php echo esc_attr($portfolio_style);?>">
									<div class="pic <?php echo esc_attr($portfolio_img_hover_effect);?>"><div class="plus_overlay"></div><div class="plus_overlay_icon"></div>
									<?php echo get_the_post_thumbnail( $post->ID, $portfolio_img_size ); ?> 
									<div class="img_overlay_icon"><span class="portfolio_icon icon_link"></span></div></div>
									<div class="info_overlay">
										<div class="info_overlay_padding">
											<div class="info_desc center">
												<span class="portfolio_icon icon_link"></span>				
												<h3><?php the_title(); ?></h3>
												<section><?php echo implode(' / ', $cats);?></section>
											</div>
										</div>
									</div>
								</div>
							  </div>
							</a>
						</div>

					<?php endif; endwhile; ?>
				</div>		
		</div>
		<!-- Portfolio::END -->
		
		<?php
		
		$js = '
			var new_w = jQuery("#filter_list").width() - 20;
			jQuery("#current_filter").css("width",new_w);
			
			jQuery(document).ready(function($){
				"use strict";
				if(!boc_is_mobile) {
					$("#portfolio_filter").on("mouseenter touchstart", function(){ 
						 $("#filter_list").stop(false, true).slideDown({
							duration:500,
							easing:"easeOutExpo"});	
					});
					$("#portfolio_filter").on("mouseleave", function(){
						 $("#filter_list").stop(false, true).slideUp({
							duration:200,
							easing:"easeOutExpo"});
					});
				}else {
					
					$("#portfolio_filter").on("click", function(){
						$("#filter_list").stop(false, true).slideDown({
							duration:500,
							easing:"easeOutExpo"});	
					});
				}
			});

			// Custom filters function
			jQuery(window).load(function(){
				jQuery(function($){
					"use strict";
					var $container = $(".grid_holder");

					$container.isotope({
					  itemSelector : ".isotope_element",	
					});

					var $optionSets = $("#filter_list"),
					$optionLinks = $optionSets.find("li div");

					$optionLinks.on("click",function(){
						var selector = $(this).attr("data-option-value");

						$container.isotope({ filter: selector });

						$("#current_filter").html($(this).html());
						$("#filter_list").stop(false, true).slideUp({
							duration:100,
							easing:"easeOutExpo"
						});
						return false;
					});
				});
			});';
			
		wp_register_script( 'boc_portfolio_inline_script', false);
		wp_enqueue_script( 'boc_portfolio_inline_script');
		wp_add_inline_script( 'boc_portfolio_inline_script', $js );
		
		
		boc_pagination($gallery->max_num_pages, $range = 2); ?>
		
		<div class="h40"></div>
	</div>
	
	<?php } else { ?>

		<h3><?php esc_html_e('Please, install the "Alea Portfolio CPT" plugin if you want to use this template', 'alea');?></h3>
	
	<?php } ?>
	
<?php get_footer(); ?>