<?php
/**
 * Used for a standard post entry
 *
 * @package	Alea
 * @author BlueOwlCreative
 */


// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
?>
	
			<!-- Post Loop :: Start -->
			<div <?php post_class(array("post_item","big_image_post_format","section"));?>>

			<?php 	// Do we use shortened Featured imgs
					$img_height = (ot_get_option('blog_full_img_height','off') == 'off') ? "boc_thin" : "full";

					// IF Post type is Standard (false) 	
					if(function_exists( 'get_post_format' ) && get_post_format( $post->ID ) != 'gallery' && get_post_format( $post->ID ) != 'video' && has_post_thumbnail()) { 
						$attachment_image = wp_get_attachment_image_src(get_post_thumbnail_id($post->ID), $img_height);
						$att_img_alt = get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true);
			?>			
						<div class="pic mb30">
							<a href="<?php the_permalink(); ?>" title="<?php echo esc_attr($post->post_title); ?>">
								<img src="<?php echo esc_url($attachment_image[0]); ?>" alt="<?php echo esc_attr($att_img_alt);?>"/><div class="img_overlay"><span class="hover_icon icon_plus"></span></div>
							</a>
						</div>
			<?php 	} // IF Post type is Standard :: END ?>
			

					
					
			<?php 	// IF Post type is Gallery
					if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'gallery' )) {

						$images = get_post_meta($post->ID, "gallery", true);

						if($images){ 

							$images_arr = explode( ',', $images);
						
							$str = "<div id='img_slider_index_template_".$post->ID."' class='img_slider big_arrows opacity_0'>";
							foreach ( $images_arr as $img_id ){

								// Attachment VARS
								$att_img_link = wp_get_attachment_image_src( $img_id, $img_height);
								$att_img_title = get_the_title($img_id);
								$att_img_alt = get_post_meta($img_id, '_wp_attachment_image_alt', true);

								$str .= '<div class="pic">
											<a href="'. get_the_permalink() .'" title="'. esc_attr($att_img_title) .'">
												<img src="'. esc_url($att_img_link[0]) .'" alt="'. esc_attr($att_img_alt) .'" class="boc_owl_lazy"/>
												<div class="img_overlay"><span class="hover_icon icon_plus"></span></div>
											</a>
										</div>';

							}
							$str .= '</div>';

							echo wp_kses_post($str);

							$js =
							'jQuery(document).ready(function($) {

								boc_preloadImages($("#img_slider_index_template_'.$post->ID.' img"), function (){					
									$("#img_slider_index_template_'.$post->ID.'").owlCarousel({
											items: 				1,
											nav: 				true,
											dots:				false,
											autoHeight: 		true,
											smartSpeed:			600,
											navText:
											["<span class=\'icon boc_i-angle-left\'></span>","<span class=\'icon boc_i-angle-right\'></span>"],
											slideBy: 			1,
											rtl: 				'. (is_rtl() ? "true" : "false").',
											navRewind: 			false,
											onInitialized: 		bocShowPostCarousels
									});
								});

								function bocShowPostCarousels() {
									$("#img_slider_index_template_'.$post->ID.'").fadeTo(0,1);
									$("#img_slider_index_template_'.$post->ID.' .owl-item .boc_owl_lazy").css("opacity","1");
								}
							});';

							wp_register_script('boc_loop_inline_script', false, array('alea-common'));
							wp_enqueue_script('boc_loop_inline_script');
							wp_add_inline_script('boc_loop_inline_script', $js);

						} // If Images :: END ?> 

				<?php } // IF Post type is Gallery :: END ?>


				<?php	// IF Post type is Video 
						if (( function_exists( 'get_post_format' ) && get_post_format( $post->ID ) == 'video')  ) {				

							if($video_embed_code = get_post_meta($post->ID, 'video_embed_code', true)) {
								echo "<div class='video_max_scale'>";
								echo wp_kses($video_embed_code, boc_expand_allowed_tags());
								echo "</div>";
							}
						} // IF Post type is Video :: END 
				?>

							<div class="post_item_desc">
								
								<?php if(get_the_title()!=''){ ?>
								<h3 class="post_title dark_links"><a href="<?php esc_url(the_permalink()); ?>" title="<?php printf(esc_attr__('Permalink to %s', 'alea'), the_title_attribute('echo=0')); ?>"><?php esc_html(the_title()); ?></a></h3>
								<?php } ?>								
	
						
						<?php	// Meta Data
				
								$id = $post->ID;
								$show_author 	= (ot_get_option('blog_meta_author', 'on') == 'on');
								$show_date 		= (ot_get_option('blog_meta_date', 'on') == 'on');
								$show_cats 		= ((ot_get_option('blog_meta_cats', 'on') == 'on') && has_category());
								$show_tags 		= ((ot_get_option('blog_meta_tags', 'on') == 'on') && has_tag());
								$show_comments 	= (ot_get_option('blog_meta_comments', 'on') == 'on');
								$show_like_button = (ot_get_option('blog_meta_like', 'on') == 'on');				
						?>
								<div class="post_meta clearfix">

								<?php if($show_author) { ?>
										<span><a href="<?php echo get_author_posts_url($post->post_author);?>"><span class="post_author"><?php echo get_avatar(get_the_author_meta("user_email", $post->post_author), "24").' '.esc_html__('by','alea').' '.get_the_author_meta("nickname", $post->post_author);?></span></a></span>
								<?php } ?>

								<?php if($show_date) { ?>
									<span class="post_date"><span class="blog_icon boc_i-clock-outline"></span><?php echo boc_post_date();?></span>
								<?php } ?>

								<?php if($show_cats) { ?>
									<span class="post_cats"><?php echo esc_html__('in','alea').'&nbsp; '; the_category(', '); ?></span>
								<?php } ?>

								<?php if($show_tags) { ?>
									<span class="tags"><span class="blog_icon boc_i-tag-outline"></span> <?php the_tags('',', '); ?></span>
								<?php } ?>
								
								<?php if($show_comments) { ?>
									<span class="post_comments"><a href="<?php comments_link();?>" rel="smooth_scroll"><span class="blog_icon blog_icon boc_i-comment-bubble"></span><?php echo (int)$wp_query->post->comment_count;?></a></span>
								<?php } ?>

								<?php if($show_like_button) {
									echo (((ot_get_option('posts_like_functionality','on')=='on')&& function_exists( 'get_simple_likes_button' )) ? get_simple_likes_button( $id ) : '');
									} ?>

								</div>

								<div class="post_description clearfix">
							
							<?php	// Show Excerpt
									$short_excerpt = wp_trim_words(get_the_excerpt(), boc_blog_excerpt_limit());
									echo esc_html($short_excerpt);
							?>
								<div class="<?php echo boc_more_link_classes();?>"><a href="<?php esc_url(the_permalink()); ?>"><?php esc_html_e('Read more','alea');?></a></div>
								</div>							
						</div>
					</div>
					<!-- Post Loop End -->
